#include <bits/stdc++.h>
 
using namespace std;
 
const int N = 2e5 + 7;
vector <int> g[N];
int depth[N];
map <pair <int, int>, int> ans;

int dfs0(int v, int d = 0) {
    depth[v] = d;
    for (int u : g[v]) {
        depth[v] = max(depth[v], dfs0(u, d + 1));
    }
    return depth[v];
}
 
int dfs(int v, int u) {
    int best_v = -1, best_u = -1;
    for (int vv : g[v]) {
        if (best_v == -1 || depth[vv] > depth[best_v]) {
            best_v = vv;
        }
    }
    if (g[best_v].empty()) {
        return 1;
    }
    for (int uu : g[u]) {
        if (best_u == -1 || depth[uu] < depth[best_u]) {
            best_u = uu;
        }
    }
    if (g[best_u].empty()) {
        return 1 + dfs(best_v, best_v);
    }
    return dfs(best_v, best_u);
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs0(1);
    cout << dfs(1, 1) << '\n';
    return 0;
}