#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define s second
#define f first
#define ll long long
const ll maxn = 1e6 + 200, inf = 1e9, mod = 1e9 + 7;

int n;
ll a[1005][1005], row[2000], col[2000];
void slow(){
    for (int x = 1; x <= n; ++x){
        for (int y = 1; y <= n; ++y){
            for (int x2 = 1; x2 <= n; ++x2){
                for (int y2 = 1; y2 <= n; ++y2){
                    swap(a[x][y], a[x2][y2]);
                    for (int i = 1; i <= n; ++i){
                        for (int j = 1; j <= n; ++j){
                            row[i] += a[i][j];
                            col[j] += a[i][j];
                        }
                    }
                    bool ok = 1;
                    for (int i = 1; i <= n; ++i){
                        for (int j = 1; j <= n; ++j){
                            ok &= (row[i] == row[j]);
                            ok &= (col[i] == col[j]);
                            ok &= (row[i] == col[j]);
                        }
                    }
                    if (ok){
                        cout << x << " " << y << "\n" << x2 << " " << y2 << '\n';
                        exit(0);
                    }
                    for (int i = 1; i <= n; ++i){
                        row[i] = 0;
                        col[i] = 0;
                    }
                    swap(a[x][y], a[x2][y2]);
                }
            }
        }
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= n; ++j){
            cin >> a[i][j];
        }
    }
    if (n <= 10){
        slow();
        exit(0);
    }

    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= n; ++j){
            col[j] += a[i][j];
            row[i] += a[i][j];
        }
    }
    map<ll, int> mx;
    int mxsum = -1;
    for (int i = 1; i <= n; ++i){
        mx[row[i]] += 1;
        mxsum = max(mxsum, mx[row[i]]);
    }
    int aa = -1, b = -1, c = -1, d = -1;
    for (int i = 1; i <= n; ++i){
        if (mx[row[i]] != mxsum){
            if (aa == -1){
                aa = i;
            }
            else{
                b = i;
            }
        }
    }
    mx.clear();
    mxsum = -1;
    for (int i = 1; i <= n; ++i){
        mx[col[i]] += 1;
        mxsum = max(mxsum, mx[col[i]]);
    }
    for (int i = 1; i <= n; ++i){
        if (mx[col[i]] != mxsum){
            if (c == -1){
                c = i;
            }
            else{
                d = i;
            }
        }
    }
    vector<pair<int, int>> kek;
    kek.pb(mp(aa, c));
    kek.pb(mp(aa, d));
    kek.pb(mp(b, c));
    kek.pb(mp(b, d));

    for (auto it : kek){
        for (auto it2 : kek){
            for (int i = 1; i <= n; ++i){
                row[i] = 0;
                col[i] = 0;
            }
            int x = it.f, y = it.s;
            int x2 = it2.f, y2 = it2.s;
            swap(a[x][y], a[x2][y2]);
            for (int i = 1; i <= n; ++i){
                for (int j = 1; j <= n; ++j){
                    row[i] += a[i][j];
                    col[j] += a[i][j];
                }
            }
            bool ok = 1;
            for (int i = 1; i <= n; ++i){
                for (int j = 1; j <= n; ++j){
                    ok &= (row[i] == row[j]);
                    ok &= (col[i] == col[j]);
                    ok &= (row[i] == col[j]);
                }
            }
            if (ok){
                cout << x << " " << y << "\n" << x2 << " " << y2 << '\n';
                exit(0);
            }
            swap(a[x][y], a[x2][y2]);
        }
    }
}
