#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast,no-stack-p0rotector,unrol-loops,fast-math,O3")
#pragma GCC target("sse,see2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#endif
#include <bits/stdc++.h>
#define speed ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define precision cout.precision(30);cerr.precision(10);
#ifdef ONLINE_JUDGE
#define debug(x) cerr << x << "<---"<<#x<<'\n'
#else
#define debug(x)
#endif
#define ll long long
#define ld long double
#define sz(x) (int)x.size()
#define mp(x,y) make_pair(x,y)
#define all(x) x.begin(), x.end()
#define pc(x) __builtin_popcount(x)
#define pcll(x) __builtin_popcountll(x)
#define F first
#define S second
using namespace std;
const int N = 1e3 + 5;
const int inf = 1e9 + 7;

inline static int triArea2(int x1, int y1, int x2, int y2, int x3, int y3){
    return (x2-x1)*(y3-y1)-(y2-y1)*(x3-x1);
}

int a[N][N];

inline static void solve(){
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            cin >> a[i][j];
        }
    }

    int c1 = 0, c2 = 0, r1 = 0, r2 = 0;

    int gottabe = 0;
    for (int i = 1; i <= n * n; i++)
    {
        gottabe += i;
    }

    gottabe /= n;

    for (int i = 1; i <= n; i++)
    {
        int sum = 0;
        for (int j = 1; j <= n; j++)
        {
            sum += a[i][j];
        }
        if (sum != gottabe){
            if (c1 == 0)
                c1 = i;
            else
                c2 = i;
        }
    }

    for (int i = 1; i <= n; i++)
    {
        int sum = 0;
        for (int j = 1; j <= n; j++)
        {
            sum += a[j][i];
        }
        if (sum != gottabe){
            if (r1 == 0)
                r1 = i;
            else
                r2 = i;
        }
    }

    if (r2 == 0)
        r2 = r1;
    if (c2 == 0)
        c2 = c1;

    swap(a[c1][r1], a[c2][r2]);

    bool f = false;

    for (int i = 1; i <= n; i++)
    {
        int sum = 0;
        for (int j = 1; j <= n; j++)
        {
            sum += a[i][j];
        }
        if (sum != gottabe){
            f = true;
        }
    }

    for (int i = 1; i <= n; i++)
    {
        int sum = 0;
        for (int j = 1; j <= n; j++)
        {
            sum += a[j][i];
        }
        if (sum != gottabe){
            f = true;
        }
    }

    if (!f)
    {
//        cout << c1 << ' ' << r1 << '\n' << c2 << ' ' << r2 << '\n';
        cout << r1 << ' ' << c1 << '\n' << r2 << ' ' << c2 << '\n';
        return;
    }
    swap(a[c1][r1], a[c2][r2]);
    swap(a[c1][r2], a[c2][r1]);
    cout << r1 << ' ' << c2 << '\n' << r2 << ' ' << c1 << '\n';
}

int32_t main(){
    speed;
    //precision(3);
    int T = 1;
    srand(time(0));
    //cin >> T;
    while(T--){
        solve();
    }
    return 0;
}

