#include <iostream>
#include <map>
#include <cmath>
#include <algorithm>
using namespace std;
#define ll long long
ll gor[1001];
ll ver[1001];
ll a[1001][1001];
int solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> a[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			gor[i] += a[i][j];
			ver[i] += a[j][i];
		}
	}
	ll nsum = (1 + n * n) * n / 2;
	int gcor1 = -1, gcor2 = -1;
	int vcor1 = -1, vcor2 = -1;
	for (int i = 0; i < n; i++) {
		if (gor[i] != nsum && gcor1 == -1) {
			gcor1 = i;
		}
		else if (gor[i] != nsum && gcor1 != -1) {
			gcor2 = i;
		}
		if (ver[i] != nsum && vcor1 == -1) {
			vcor1 = i;
		}
		else if (ver[i] != nsum && vcor1 != -1) {
			vcor2 = i;
		}
	}
	if (gcor1 != -1 && gcor2 != -1 && vcor1 != -1 && vcor2 != -1) {
		swap(a[gcor1][vcor1], a[gcor2][vcor2]);
		ll s1 = 0;
		ll s2 = 0;
		ll s3 = 0;
		ll s4 = 0;
		for (int i = 0; i < n; i++) {
			s1 += a[i][vcor1];
			s2 += a[i][vcor2];
			s3 += a[gcor1][i];
			s4 += a[gcor2][i];
		}
		if (s2 != nsum && s1 != nsum && s3 != nsum && s4 != nsum) {
			cout << gcor2 + 1 << " " << vcor1 + 1 << endl << gcor1 + 1 << " " << vcor2 + 1;
			return 0;
		}
		else  if (s2 == nsum && s1 == nsum && s3 == nsum && s4 == nsum) {
			cout << gcor1 + 1 << " " << vcor1 + 1 << endl << gcor2 + 1 << " " << vcor2 + 1;
			return 0;
		}
	}
	if (gcor1 == -1 && vcor1 != -1 && vcor2 != -1) {
		for (int i = 0; i < n; i++) {
			swap(a[i][vcor1], a[i][vcor2]);
			ll s1, s2;
			s1 = 0;
			s2 = 0;
			for (int j = 0; j < n; j++) {
				s1 += a[j][vcor1];
				s2 += a[j][vcor2];
			}
			if (s2 == nsum && s1 == nsum) {
				cout << i + 1 << " " << vcor1 + 1 << endl << i + 1 << ' ' << vcor2 + 1;
				return 0;
			}
			swap(a[i][vcor1], a[i][vcor2]);
		}
	}
	if (vcor1 == -1 && gcor1 != -1 && gcor2 != -1) {
		for (int i = 0; i < n; i++) {
			swap(a[gcor1][i], a[gcor2][i]);
			ll s1, s2;
			s1 = 0;
			s2 = 0;
			for (int j = 0; j < n; j++) {
				s1 += a[gcor1][j];
				s2 += a[gcor2][j];
			}
			if (s2 == nsum && s1 == nsum) {
				cout << gcor1 + 1 << " " << i + 1 << endl << gcor2 + 1 << ' ' << i + 1;
				return 0;
			}
			swap(a[gcor1][i], a[gcor2][i]);
		}
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	
}

/*
36
3
9 4 2
3 5 7
8 1 6

3
2 9 4
3 5 7
8 1 6

3
3 9 2
4 5 7
8 1 6

3
5 9 2
3 4 7
8 1 6

3
7 9 2
3 5 4
8 1 6

3
8 9 2
3 5 7
4 1 6

3
1 9 2
3 5 7
8 4 6

3
6 9 2
3 5 7
8 1 4

3
4 2 9
3 5 7
8 1 6

3
4 3 2
9 5 7
8 1 6

3
4 5 2
3 9 7
8 1 6

3
4 7 2
3 5 9
8 1 6

3
4 8 2
3 5 7
9 1 6

3
4 1 2
3 5 7
8 9 6

3
4 6 2
3 5 7
8 1 9

3
4 9 3
2 5 7
8 1 6

3
4 9 5
3 2 7
8 1 6

3
4 9 7
3 5 2
8 1 6

3
4 9 8
3 5 7
2 1 6

3
4 9 1
3 5 7
8 2 6

3
4 9 6
3 5 7
8 1 2

3
4 9 2
5 3 7
8 1 6

3
4 9 2
7 5 3
8 1 6

3
4 9 2
8 5 7
3 1 6

3
4 9 2
1 5 7
8 3 6

3
4 9 2
6 5 7
8 1 3

3
4 9 2
3 7 5
8 1 6

3
4 9 2
3 8 7
5 1 6

3
4 9 2
3 1 7
8 5 6

3
4 9 2
3 6 7
8 1 5

3
4 9 2
3 5 8
7 1 6

3
4 9 2
3 5 1
8 7 6

3
4 9 2
3 5 6
8 1 7

3
4 9 2
3 5 7
1 8 6

3
4 9 2
3 5 7
6 1 8

3
4 9 2
3 5 7
8 6 1

*/

/*
1
0 0 0 1
2
0 0 0 2
3
0 0 1 0
4
0 0 1 1
5
0 0 1 2
6
0 0 2 0
7
0 0 2 1
8
0 0 2 2
9
0 1 0 2
10
0 1 1 0
11
0 1 1 1
12
0 1 1 2
13
0 1 2 0
14
0 1 2 1
15
0 1 2 2
16
0 2 1 0
17
0 2 1 1
18
0 2 1 2
19
0 2 2 0
20
0 2 2 1
21
0 2 2 2
22
1 0 1 1
23
1 0 1 2
24
1 0 2 0
25
1 0 2 1
26
1 0 2 2
27
1 1 1 2
28
1 1 2 0
29
1 1 2 1
30
1 1 2 2
31
1 2 2 0
32
1 2 2 1
33
1 2 2 2
34
2 0 2 1
35
2 0 2 2
36
2 1 2 2
*/