#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

using namespace std;

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back

int n;
bool good(vector<vector<int>> &a)
{
    {
        map<int, int> was;
        for (int i = 0; i < n; ++i)
        {
            int cur = 0;
            for (int j = 0; j < n; ++j)
            {
                cur += a[i][j];
            }

            if (i && was[cur] != 1)
            {
                return false;
            }
            was[cur] = 1;
        }
    }
    {
        map<int, int> was;
        for (int i = 0; i < n; ++i)
        {
            int cur = 0;
            for (int j = 0; j < n; ++j)
            {
                cur += a[j][i];
            }

            if (i && was[cur] != 1)
            {
                return false;
            }
            was[cur] = 1;
        }
    }
    return true;
}

void solve()
{
    cin >> n;

    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> a[i][j];

    if (n <= 4)
    {
        for (int x = 0; x < n; ++x)
            for (int y = 0; y < n; ++y)
                for (int x1 = 0; x1 < n; ++x1)
                    for (int y1 = 0; y1 < n; ++y1)
                    {
                        swap(a[x][y], a[x1][y1]);
                        if (good(a))
                        {
                            cout << x + 1 << " " << y + 1 << "\n"
                                 << x1 + 1 << " " << y1 + 1 << "\n";
                            return;
                        }
                        swap(a[x][y], a[x1][y1]);
                    }
    }
    else
    {
        vector<int> hor(n), vert(n);
        vector<int> bH, bV;
        int goodH = 0;
        int goodV = 0;
        {
            map<int, vector<int>> cnt;
            for (int i = 0; i < n; ++i)
            {
                int cur = 0;
                for (int j = 0; j < n; ++j)
                    cur += a[i][j];
                hor[i] = cur;
                cnt[cur].pb(i);
            }

            for (auto e : cnt)
            {
                if (e.s.size() < 2)
                {
                    bH.insert(bH.end(), e.s.begin(), e.s.end());
                }
                else
                    goodH = e.f;
            }
        }
        {
            map<int, vector<int>> cnt;
            for (int i = 0; i < n; ++i)
            {
                int cur = 0;
                for (int j = 0; j < n; ++j)
                {
                    cur += a[j][i];
                }
                vert[i] = cur;
                cnt[cur].pb(i);
            }

            for (auto e : cnt)
                if (e.s.size() < 3)
                {
                    bV.insert(bH.end(), e.s.begin(), e.s.end());
                }
                else
                    goodV = e.f;
        }

        if (bH.size() != 0 && bH.size() != 2)
            while (true)
            {
            }

        if (bH.size() != 0 && bH.size() != 2)
            while (true)
            {
            }

        if (bH.size() == 0 && bV.size() == 0)
            while (true)
            {
            }

        if (bH.size() > 0 && bV.size() > 0)
        {
            int x1 = bH[0];
            int y1 = bH[1];
            int x2 = bV[0];
            int y2 = bV[1];

            swap(a[x1][y1], a[x2][y2]);
            if (good(a))
            {
                cout << x1 + 1 << " " << y1 + 1 << "\n"
                     << x2 + 1 << " " << y2 + 1 << "\n";
                return;
            }
            swap(a[x1][y1], a[x2][y2]);

            swap(a[x2][y1], a[x1][y2]);
            if (good(a))
            {
                cout << x2 + 1 << " " << y1 + 1 << "\n"
                     << x1 + 1 << " " << y2 + 1 << "\n";
                return;
            }
            swap(a[x2][y1], a[x1][y2]);

            swap(a[x1][y2], a[x2][y1]);
            if (good(a))
            {
                cout << x1 + 1 << " " << y2 + 1 << "\n"
                     << x2 + 1 << " " << y1 + 1 << "\n";
                return;
            }
            swap(a[x1][y2], a[x2][y1]);
        }
        else if (bH.size() > 0)
        {
            int x1 = bH[0];
            int x2 = bH[1];
            for (int i = 0; i < n; ++i)
            {
                hor[x1] -= a[x1][i];
                hor[x1] += a[x2][i];

                hor[x2] -= a[x2][i];
                hor[x2] += a[x1][i];
                if (goodH == hor[x1] && goodH == hor[x2])
                {
                    cout << x1 + 1 << " " << i + 1 << "\n"
                         << x2 + 1 << " " << i + 1 << "\n";
                    return;
                }
                hor[x1] += a[x1][i];
                hor[x1] -= a[x2][i];

                hor[x2] += a[x2][i];
                hor[x2] -= a[x1][i];
            }
        }
        else if (bV.size() > 0)
        {
            int x1 = bV[0];
            int x2 = bV[1];
            for (int i = 0; i < n; ++i)
            {
                vert[x1] -= a[i][x1];
                vert[x1] += a[i][x2];

                vert[x2] -= a[i][x2];
                vert[x2] += a[i][x1];
                if (goodV == vert[x1] && goodV == vert[x2])
                {
                    cout << i + 1 << " " << x1 + 1 << "\n"
                         << i + 1 << " " << x2 + 1 << "\n";
                    return;
                }
                vert[x1] += a[i][x1];
                vert[x1] -= a[i][x2];

                vert[x2] += a[i][x2];
                vert[x2] -= a[i][x1];
            }
        }
        else
            while (true)
            {
            }
    }
}

main()
{
    solve();
    return 0;
}