#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define sz(s) (int)s.size()
#define pb push_back
#define all(s) s.begin(), s.end()

const int N = 1e5;
const int mod = 1e9 + 7;
ll f[N];
ll inv[N];
ll bp(ll n, ll k) {
    if (!k) return 1;
    if (k == 1) return n;
    if (k & 1) return (bp(n, k - 1) * n) % mod;
    ll x = bp(n, k / 2);
    return (x * x) % mod;
}

ll C(int n, int k) {
    if (k > n or k < 0 or n < 0) return 0;
    return f[n] * inv[k] % mod * inv[n - k] % mod;
}
ll dp[N];
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    f[0] = 1;
    inv[0] = 1;
    for (int i = 1; i < N; i++) {
        f[i] = (f[i - 1] * i) % mod;
        inv[i] = bp(f[i], mod - 2);
    }
    int n;
    cin >> n;
    dp[1] = 1;
    dp[2] = 1;
    dp[3] = 2;
    for(int i = 4; i <= n; i++) {
        ll tot = 0;
        for(int j = 1; j <= i - 1; j++) {
            if(2 * j > i) continue;
            ll cnt = C(i - 1, j) * 1ll * C(i - 1 - j, i - 2 * j);
            tot = (tot + cnt) % mod;
        }
        dp[i] = tot * dp[i - 1] % mod;
    }
    cout << dp[n] << '\n';
}
