#include <bits/stdc++.h>
using namespace std;

#define int long long

const int MOD = 1e+9 + 7;

int32_t main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;

    int dp1[n + 1][n + 1] { };

    dp1[0][0] = 1;

    int sum[n + 1] { };

    for (int i = 1; i <= n; i++)
        sum[i] = sum[i - 1] + i;

    for (int i = 1; i <= n; i++)
        for (int s = sum[i]; s <= n; s++)
            for (int cnt = 1; s - cnt * i >= sum[i - 1]; cnt++) {
                dp1[i][s] += dp1[i - 1][s - cnt * i];

                if (dp1[i][s] >= MOD)
                    dp1[i][s] -= MOD;
            }

    int dp2[n + 2][n + 2] { };

    dp2[n + 1][0] = 1;

    for (int i = n; i >= 1; i--)
        for (int s = 0; s <= n; s++)
            for (int cnt = 0; s - cnt * i >= 0; cnt++) {
                dp2[i][s] += dp2[i + 1][s - cnt * i];

                if (dp2[i][s] >= MOD)
                    dp2[i][s] -= MOD;
            }

    int ans = 0;

    for (int i = 1; i <= n; i++)
        for (int s = sum[i - 1]; s <= n; s++)
            ans = (ans + i * dp1[i - 1][s] * dp2[i + 1][n - s]) % MOD;

    ans = (ans + (n + 1) * dp1[n][n]);

    cout << ans << "\n";
}
