#include <iostream>
#include <algorithm>
#include <numeric>
#include <math.h>
#include <cmath>
#include <string>
#include <map>
#include <vector>

using namespace std;
const long long mod = 1000000007;

long long fact(long long a) {
	long long ans = 1;
	for (long long i = 1; i <= a; i++) {
		ans = (ans * i) % mod;
	}
	return ans % mod;
}
long long revmod(int n, int m) {
	while (gcd(n, m) > 1);
	int v = m, i = 1, z = 0;
	while (n > 1) {
		int q = n / m; int t = m; m = n % m;
		n = t; t = z; z = i - q * t; i = t;
	}
	while (i < 0) i += v;
	return i % v;
}
long long moddiv(long long x, long long y) {
	return (x % mod) * revmod(y, mod);
}
long long cnk(long long n, long long k) {
	return moddiv(moddiv(fact(n),fact(k)),fact(n - k));
}

int main()
{
	long long n, k, ans = 1;
	cin >> n;
	n--;
	for (long long i = 1; i <= n; i++) {
		long long q = i + 1, part = 0, modi = 1;
		while (q >= 2) {
			q -= 2;
			part = (part + (cnk(i, modi) * cnk(i - modi, q)) % mod) % mod;
			modi++;
			modi %= mod;
		}
		ans = (ans * part) % mod;
	}
	cout << ans << endl;
}
