#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void printans(int a, int b, int c, int d) {
    cout << a + 1 << " " << b + 1 << "\n" << c + 1 << " " << d + 1;
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int> (n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    vector<int> srow(n);
    vector<int> scol(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            srow[i] += a[i][j];
            scol[i] += a[j][i];
        }
    }
    int mxrow = 0, mxcol = 0, mnrow = 1000000000, mncol = 1000000000;
    for (int i = 0; i < n; ++i) {
        mxrow = max(mxrow, srow[i]);
        mxcol = max(mxcol, scol[i]);
        mnrow = min(mnrow, srow[i]);
        mncol = min(mncol, scol[i]);
    }
    int i1 = -1, i2 = -1, j1 = -1, j2 = -1;
    for (int i = 0; i < n; ++i) {
        if (srow[i] == mxrow) {
            i1 = i;
        }
        if (srow[i] == mnrow) {
            i2 = i;
        }
        if (scol[i] == mxcol) {
            j1 = i;
        }
        if (scol[i] == mncol) {
            j2 = i;
        }
    }
    if (mxrow == mnrow) {
        for (int i = 0; i < n; ++i) {
            if (scol[j1] + a[i][j2] - a[i][j1] == scol[j2] + a[i][j1] - a[i][j2]) {
                printans(i, j1, i, j2);
            }
        }
    } else if (mxcol == mncol) {
        for (int j = 0; j < n; ++j) {
            if (srow[i1] + a[i2][j] - a[i1][j] == srow[i2] + a[i1][j] - a[i2][j]) {
                printans(i1, j, i2, j);
            }
        }
    } else {
        if (scol[j1] + a[i2][j2] - a[i1][j1] == scol[j2] + a[i1][j1] - a[i2][j2]) {
            printans(i1, j1, i2, j2);
        } else {
            printans(i1, j2, i2, j1);
        }
    }
    return 0;
}