﻿#pragma optimize("O2");

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int n; cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            cin >> a[i][j];

    map<int, int> ocHor, ocVer;
    int mx = 0, ind = 0;
    vector<int> ver(n, 0), hor(n, 0);
    int mxh = 0, besth = 0, mxv = 0, bestv = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ver[i] += a[i][j];
        }
        ocVer[ver[i]]++;
        if (ocVer[ver[i]] > mxv) {
            mxv = ocVer[ver[i]];
            bestv = ver[i];
        }
    }
    for (int j = 0; j < n; j++) {
        for (int i = 0; i < n; i++) {
            hor[j] += a[i][j];
        }
        ocHor[hor[j]]++;
        if (ocHor[hor[j]] > mxh) {
            mxh = ocHor[hor[j]];
            besth = hor[j];
        }
    }
    
    if (n < 10) {
        for (int i1 = 0; i1 < n; i1++) {
            for (int j1 = 0; j1 < n; j1++) {
                for (int i2 = 0; i2 < n; i2++) {
                    for (int j2 = 0; j2 < n; j2++) {
                        int sv1 = ver[i1], sh1 = hor[j1], sv2 = ver[i2], sh2 = hor[j2];
                        sv1 -= a[i1][j1];
                        sh1 -= a[i1][j1];
                        sv2 -= a[i2][j2];
                        sh2 -= a[i2][j2];

                        sv1 += a[i2][j2];
                        sh1 += a[i2][j2];
                        sv2 += a[i1][j1];
                        sh2 += a[i1][j1];

                        bool ok = 1;
                        for (int i = 0; i < n; i++)
                            if (i != i1 && i != i2 && (ver[i] != sv1 || ver[i] != sv2))
                                ok = 0;
                        for (int i = 0; i < n; i++)
                            if (i != j1 && i != j2 && (hor[i] != sh1 || hor[i] != sh2))
                                ok = 0;
                        if (ok) {
                            cout << i1 + 1 << ' ' << j1 + 1 << endl << i2 + 1 << ' ' << j2 + 1 << endl;
                            return 0;
                        }
                    }
                }
            }
        }
    }
    else {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (ver[i] != bestv || hor[j] != besth) {
                    cout << i + 1 << ' ' << j + 1 << endl;
                }
            }
        }
    }
}
