﻿#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int q; cin >> q;
    unordered_map<int, int> xEven_yEven, xOdd_yEven, xEven_yOdd, xOdd_yOdd;
    unordered_map<int, int> yEven_xEven, yEven_xOdd, yOdd_xEven, yOdd_xOdd;
    int evenCol = 0, oddCol = 0;
    int evenRow = 0, oddRow = 0;
    set<pair<int, int>> st;
    while (q--) {
        int x, y; cin >> x >> y;
        if (st.find({ x, y }) != st.end()) {
            st.erase({ x, y });
            if (x % 2 == 0 && y % 2 == 0) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yEven[x]--;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);

                evenRow -= max(yEven_xEven[y], yEven_xOdd[y]);
                yEven_xEven[y]--;
                evenRow += max(yEven_xEven[y], yEven_xOdd[y]);
            }
            else if (x % 2 == 1 && y % 2 == 0) {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yEven[x]--;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);

                evenRow -= max(yEven_xEven[y], yEven_xOdd[y]);
                yEven_xOdd[y]--;
                evenRow += max(yEven_xEven[y], yEven_xOdd[y]);
            }
            else if (x % 2 == 0 && y % 2 == 1) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yOdd[x]--;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);

                oddRow -= max(yOdd_xEven[y], yOdd_xOdd[y]);
                yOdd_xEven[y]--;
                oddRow += max(yOdd_xEven[y], yOdd_xOdd[y]);
            }
            else {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yOdd[x]--;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);

                oddRow -= max(yOdd_xEven[y], yOdd_xOdd[y]);
                yOdd_xOdd[y]--;
                oddRow += max(yOdd_xEven[y], yOdd_xOdd[y]);
            }
        }
        else {
            st.insert({ x, y });
            if (x % 2 == 0 && y % 2 == 0) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yEven[x]++;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);

                evenRow -= max(yEven_xEven[y], yEven_xOdd[y]);
                yEven_xEven[y]++;
                evenRow += max(yEven_xEven[y], yEven_xOdd[y]);
            }
            else if (x % 2 == 1 && y % 2 == 0) {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yEven[x]++;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);

                evenRow -= max(yEven_xEven[y], yEven_xOdd[y]);
                yEven_xOdd[y]++;
                evenRow += max(yEven_xEven[y], yEven_xOdd[y]);
            }
            else if (x % 2 == 0 && y % 2 == 1) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yOdd[x]++;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);

                oddRow -= max(yOdd_xEven[y], yOdd_xOdd[y]);
                yOdd_xEven[y]++;
                oddRow += max(yOdd_xEven[y], yOdd_xOdd[y]);
            }
            else {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yOdd[x]++;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);

                oddRow -= max(yOdd_xEven[y], yOdd_xOdd[y]);
                yOdd_xOdd[y]++;
                oddRow += max(yOdd_xEven[y], yOdd_xOdd[y]);
            }
        }

        cout << max({oddCol, evenCol, evenRow, oddRow}) << '\n';
    }
}