#include <bits/stdc++.h>
#ifndef Local
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

template <typename T, typename U>
bool smin(T& a, U b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T, typename U>
bool smax(T& a, U b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const int mod = 1e9 + 7;

int bpow(int x, int k) {
    int r = 1;
    while (k) {
        if (k & 1)
            r = r * x % mod;
        x = x * x % mod;
        k >>= 1;
    }
    return r;
}

void solve() {
    int n;
    cin >> n;
    vector<int> cnt(3);
    for (int i = 0, c; i < n; ++i) {
        cin >> c;
        ++cnt[c % 3];
    }
    if (abs(cnt[1] - cnt[2]) > 2 || abs(cnt[1] - cnt[2]) < 1) {
        cout << 0 << endl;
        return;
    }
    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; ++i) {
        fact[i] = fact[i - 1] * i % mod;
    }
    int ans = fact[cnt[0]] * fact[cnt[1]] % mod * fact[cnt[2]] % mod;
    ans = ans * fact[n - 1] % mod * bpow(fact[cnt[1] + cnt[2] - 1], mod - 2) % mod;
    ans = ans * bpow(fact[n - cnt[1] - cnt[2]], mod - 2) % mod;
    cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int tt = 1;
//	cin >> tt;
	while (tt--)
		solve();

	return 0;
}
