#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int INF = 1e9 + 1;
//#define int long long
#define endl "\n"

vector <vector <int>> sm;
vector <map <int, int>> t;
vector <int> dp;
vector <int> m;
vector <int> h;

void dfs1(int v, int height, int p = -1){
    h[v] = height;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        dfs1(to, height + 1, v);
        m[v] = min(m[to] + 1, m[v]);
    }
    if (m[v] == INF)
        m[v] = 0;
}

int dfs(int v, int p = -1){
    int res = -1;
    vector <int> g;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        g.push_back(dfs(to, v));
        if ((int)t[g[0]].size() < (int)t[g.back()].size())
            swap(g[0], g.back());
    }
    if (g.empty()){
        dp[v] = 0;
        t[v][h[v]] = 0;
        return v;
    }
    swap(g[0], res);
    for (int i = 1; i < (int)g.size(); i++){
        for (auto j:t[g[i]]){
            if (t[res].count(j.first))
                t[res][j.first] = max(t[res][j.first], j.second);
            else
                t[res][j.first] = j.second;
        }
    }
    if (t[res].count(h[v] + m[v]))
        dp[v] = t[res][h[v] + m[v]] + 1;
    if (t[res].count(h[v]))
        t[res][h[v]] = max(t[res][h[v]], dp[v]);
    else
        t[res][h[v]] = dp[v];
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    sm.resize(n);
    dp.resize(n, 0);
    h.resize(n, 0);
    m.resize(n, INF);
    t.resize(n);
    for (int i = 0; i < n - 1; i++){
        int p;
        cin >> p;
        p--;
        sm[i + 1].push_back(p);
        sm[p].push_back(i + 1);
    }
    dfs1(0, 0, -1);
//    cout << 243534 << endl;
    dfs(0, -1);
    cout << dp[0];
}