#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll INF = 1e18 + 1;
#define int long long
#define endl "\n"

vector<vector<int>> w;
int n;

void check(int x1, int y1, int x2, int y2) {
    int valx = -1, valy = -1;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += w[i][j];
        }
        if (valx == -1) valx = sum;
        else if (valx != sum) return;
    }
    for (int j = 0; j < n; j++) {
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += w[i][j];
        }
        if (valy == -1) valy = sum;
        else if (valy != sum) return;
    }
    cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    w.resize(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> w[i][j];
        }
    }
    if (n < 5) {
        for (int x1 = 0; x1 < n; x1++) {
            for (int y1 = 0; y1 < n; y1++) {
                for (int x2 = 0; x2 < n; x2++) {
                    for (int y2 = 0; y2 < n; y2++) {
                        if (x1 == x2 && y1 == y2) continue;
                        swap(w[x1][y1], w[x2][y2]);
                        check(x1, y1, x2, y2);
                        swap(w[x1][y1], w[x2][y2]);
                    }
                }
            }
        }
    }
    map<int, vector<int>> x, y;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += w[i][j];
        }
        x[sum].push_back(i);
    }
    for (int j = 0; j < n; j++) {
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += w[i][j];
        }
        y[sum].push_back(j);
    }
    vector<int> a, b;
    for (auto [s, c]: x) {
        if (c.size() == 1) {
            a.push_back(c[0]);
        }
    }
    for (auto [s, c]: y) {
        if (c.size() == 1) {
            b.push_back(c[0]);
        }
    }
    if (a.size() >= 2) {
        for (int i = 0; i < a.size(); i++) {
            for (int j = i + 1; j < a.size(); j++) {
                int sum1 = 0, sum2 = 0;
                for (int in = 0; in < n; in++) {
                    sum1 += w[a[i]][in];
                    sum2 += w[a[j]][in];
                }
                for (int x1 = 0; x1 < n; x1++) {
                    for (int y1 = 0; y1 < n; y1++) {
                        if (sum1 - sum2 == 2 * (w[a[i]][x1] - w[a[j]][y1])) {
                            cout << a[i] + 1 << ' ' << x1 + 1 << '\n' << a[j] + 1 << ' ' << y1 + 1;
                            return 0;
                        }
                    }
                }
            }
        }
    } else {
        for (int i = 0; i < b.size(); i++) {
            for (int j = i + 1; j < b.size(); j++) {
                int sum1 = 0, sum2 = 0;
                for (int in = 0; in < n; in++) {
                    sum1 += w[in][b[i]];
                    sum2 += w[in][b[j]];
                }
                for (int x1 = 0; x1 < n; x1++) {
                    for (int y1 = 0; y1 < n; y1++) {
                        if (sum1 - sum2 == 2 * (w[x1][b[i]] - w[y1][b[j]])) {
                            cout << x1 + 1 << ' ' << b[i] + 1 << '\n' << y1 + 1 << b[j] + 1;
                            return 0;
                        }
                    }
                }
            }
        }
    }
}
