#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;
const int INF = 1e9;

#define int long long

int bin_pow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans = ans * a % MOD;
        }
        n /= 2;
        a = a * a % MOD;
    }
    return ans;
}


vector <int> ans;
vector <vector <int>> gr;
vector <int> lvl, tin, tout;
vector <int> h;
vector <int> clst;
int timer = 0;

struct Node {
    int l, r, mx;
};

const int MAXQ = 1e6;

Node t[MAXQ];
int tSz = 1;

int addV(int l, int r) {
    t[tSz++] = {0, 0, 0};
    return tSz - 1;
}

void upd(int v, int l, int r, int ind, int x) {
    if (l + 1 == r) {
        t[v].mx = x;
        return;
    }
    int mid = (l + r) / 2;
    if (ind < mid) {
        if (t[v].l == 0) t[v].l = addV(l, mid);
        upd(t[v].l, l, mid, ind, x);
    } else {
        if (t[v].r == 0) t[v].r = addV(mid, r);
        upd(t[v].r, mid, r, ind, x);
    }
    t[v].mx = max(t[t[v].l].mx, t[t[v].r].mx);
}

int get(int v, int l, int r, int ql, int qr) {
    if (v == 0) return 0;
    if (l >= qr || r <= ql) return 0;
    if (l >= ql && r <= qr) return t[v].mx;
    int mid = (l + r) / 2;
    return max(get(t[v].l, l, mid, ql, qr), get(t[v].r, mid, r, ql, qr));
}
int n;

void dfs(int v) {
    tin[v] = timer++;
    if (gr[v].size() == 0) {
        clst[v] = h[v];
        ans[v] = 1;
    }

    for (int& u : gr[v]) {
        h[u] = h[v] + 1;
        dfs(u);
        clst[v] = min(clst[u], clst[v]);
    }
    tout[v] = timer++;
    if (gr[v].size() > 0) {
        ans[v] = get(lvl[clst[v]], 0, 2 * n, tin[v], tout[v]) + 1;
        upd(lvl[h[v]], 0, 2 * n, tin[v], ans[v]);
    }
}

void solveB() {
    cin >> n;
    t[0].mx = 0;

    tin.resize(n);
    tout.resize(n);
    ans.resize(n);
    gr.resize(n);
    lvl.resize(n + 1);
    for (int i = 0; i < n + 1; ++i) {
        lvl[i] = addV(0, 2 * n);
    }
    h.resize(n);
    clst.assign(n, INF);

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;

        gr[p].push_back(i);
    }

    h[0] = 0;
    dfs(0);

    cout << ans[0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solveB();
    }
}
