#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN = 200001;

vector<vector<int>> g;

vector<int> leaf;

void precalc(int v){
    if(g[v].empty()) return;
    leaf[v] = MAXN;
    for(auto to : g[v]){
        precalc(to);
        leaf[v] = min(leaf[v], leaf[to]+1);
    }
}

int ans = 0;

void solve(int v, int timer, int res){
    //cout << v << " " << timer << " " << res << '\n';
    ans = max(ans, res);
    if(g[v].empty()) return;
    ans = max(ans, res);
    for(auto to : g[v]){
        if(timer == 0){
            solve(to, leaf[v]-1, res+1);
        }
        else{
            solve(to, timer-1, res);
        }
    }
}

signed main() {
    int n;
    cin >> n;
    g.resize(n);
    leaf.resize(n);
    for(int i = 1; i < n; i++){
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    precalc(0);
    solve(0, 0, 0);
    cout << ans;
}



