#include <bits/stdc++.h>

using namespace std;
#define int int_fast64_t

mt19937 rnd(23);
const int MOD = 1e9 + 7;
const int INF = 2e18;

int ans1;

int binpow(int n, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int c = binpow(n, p / 2);
        return c * c % MOD;
    } else {
        return n * binpow(n,p - 1) % MOD;
    }
}

void solve(int n, int one, int two, int zero, int now) {
    if (n == 0) {
        ans1++;
        return;
    }
    if (now == 1 && two == 0 && one <= 2 && one >= 1 && zero > 0) {
        ans1 += zero + 1;
        return;
    }
    if (now == 0 && one == 0 && two <= 2 && two >= 1 && zero > 0) {
        ans1 += zero + 1;
        return;
    }
    if (two == 0 && one == 0) {
        ans1++;
        return;
    }
    if (now == 0 && two == 1 && one == 1) {
        return;
    }
    if (one && (now + 1) % 3) {
        solve(n - 1, one - 1, two, zero, (now + 1) % 3);
    }
    if (two && (now + 2) % 3) {
        solve(n - 1, one, two - 1, zero, (now + 2) % 3);
    }
    if (zero) {
        solve(n - 1, one, two, zero - 1, now);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        cnt[a % 3]++;
    }
//    int n = abs((int) rnd()) % 32;
//    vector<int> cnt(3);
//    for (int i = 0; i < n; i++) {
//        int a = abs((int) rnd()) % 3;
//        cnt[a]++;
//    }
    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    int ans;
    if (abs(cnt[1] - cnt[2]) <= 2 && abs(cnt[1] - cnt[2]) > 0) {
        ans = (fact[n - 1] * binpow(fact[n - cnt[0] - 1], MOD - 2) % MOD) * binpow(fact[cnt[0]], MOD - 2);
        ans %= MOD;
        ans *= fact[cnt[0]];
        ans %= MOD;
        ans *= fact[cnt[1]];
        ans %= MOD;
        ans *= fact[cnt[2]];
        ans %= MOD;
        cout << ans;
    } else {
        ans = 0;
        cout << ans;
    }
//    if (cnt[1]) {
//        solve(n - 1, cnt[1] - 1, cnt[2], cnt[0], 1);
//    }
//    if (cnt[2]) {
//        solve(n - 1, cnt[1], cnt[2] - 1, cnt[0], 2);
//    }
//
//    ans1 *= fact[cnt[0]];
//    ans1 %= MOD;
//    ans1 *= fact[cnt[1]];
//    ans1 %= MOD;
//    ans1 *= fact[cnt[2]];
//    ans1 %= MOD;
//    if (ans1 != ans) {
//        cout << n << "\n";
//        for (int i : cnt) {
//            cout << i << " ";
//        }
//        cout << "\n" << ans << " " << ans1 << "\n";
//    }
    return 0;
}
