#include <bits/stdc++.h>

using ll = long long;

#define ff first
#define ss second

const int MAXN = 1e5;

std::vector<int>g[MAXN];
int h[MAXN];
int dp[MAXN];
std::pair<int, int> l[MAXN];
std::vector<int>H[MAXN];
int tin[MAXN];
int tout[MAXN];
int T = 0;

void dfs1(int v) {
    tin[v] = T++;
    H[h[v]].push_back(v);
    for (auto i : g[v]) {
        h[i] = h[v] + 1;
        dfs1(i);
        l[v] = std::min(std::make_pair(l[i].ff + 1, l[i].ss), l[v]);
    }
    if (g[v].empty()) {
        l[v] = {0, v};
    }
    tout[v] = T++;
}

std::deque<int> dfs2(int v) {
    std::deque<int>d;
    for (auto i : g[v]) {
        std::deque<int>d1 = dfs2(i);
        if (d1.size() > d.size()) {
            std::swap(d, d1);
        }
        for (int j = 0; j < d1.size(); ++j) {
            d[j] = std::max(d[j], d1[j]);
        }
    }
    if (g[v].empty()) {
        return {0};
    }
//    for (const auto &item: H[h[v] + l[v].ff]) {
//        if (tin[v] < tin[item] && tout[v] > tout[item]) {
//            dp[v] = std::max(dp[v], dp[item]);
//        }
//    }
    d.push_front(0);
    dp[v] = d[0] = d[l[v].ff] + 1;
    return d;
}

void solve() {
    int n; std::cin >> n;
    for (int i = 0; i < n; ++i) {
        l[i] = {n + 1, n};
    }
    for (int i = 1; i <= n - 1; ++i) {
        int p; std::cin >> p;
        g[p - 1].push_back(i);
    }
    dfs1(0);
    dfs2(0);
    std::cout << dp[0] << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}
