#include <bits/stdc++.h>

using ll = long long;

void solve() {
    int n; std::cin >> n;
    std::vector<std::vector<ll>>a(n, std::vector<ll>(n));
    std::vector<ll>c(n), r(n), C, R;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            std::cin >> a[i][j];
            c[i] += a[i][j];
            r[j] += a[i][j];
        }
    }
    ll s = n * (n * n + 1) / 2;
    for (int i = 0; i < n; ++i) {
        if (c[i] != s) {
            C.push_back(i);
        }
        if (r[i] != s) {
            R.push_back(i);
        }
    }
    if (C.empty()) {
        for (int i = 0; i < n; ++i) {
            if (a[i][R[0]] - a[i][R[1]] + r[R[1]] == s && a[i][R[1]] - a[i][R[0]] + r[R[0]] == s) {
                std::cout << i + 1 << ' ' << R[0] + 1 << '\n' << i + 1 << ' ' << R[1] + 1 << '\n';
                return;
            }
        }
        exit(1);
    }
    if (R.empty()) {
        for (int i = 0; i < n; ++i) {
            if (a[C[0]][i] - a[C[1]][i] + c[C[1]] == s && a[C[1]][i] - a[C[0]][i] + c[C[0]] == s) {
                std::cout << C[0] + 1 << ' ' << i + 1 << '\n' << C[1] + 1 << ' ' << i + 1 << '\n';
                return;
            }
        }
        exit(1);
    }
    ll d = a[C[0]][R[0]] - a[C[1]][R[1]];
    if (d + c[C[1]] == s && d + r[R[1]] == s) {
        std::cout << C[0] + 1 << ' ' << R[0] + 1 << '\n' << C[1] + 1 << ' ' << R[1] + 1 << '\n';
        return;
    }
    std::cout << C[1] + 1 << ' ' << R[0] + 1 << '\n' << C[0] + 1 << ' ' << R[1] + 1 << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}
