#include <iostream>

using namespace std;

using ll = long long;
const ll MOD = 1000000007;

ll a[1001][1001];
ll pref[1001][1001];

ll alpha(int n)
{
    if (n < 0) return 0;
    return pref[n][n];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i <= 1000; i++) for (int j = 0; j <= 1000; j++)
    {
        a[i][j] = 0;
        pref[i][j] = 0;
    }
    a[0][0] = 1;
    pref[0][0] = 1;
    for (int i = 1; i <= 1000; i++) for (int j = 1; j <= i; j++)
    {
        if (j <= i - j) a[i][j] = pref[i - j][j];
        else a[i][j] = pref[i - j][i - j];
        pref[i][j] = (pref[i][j - 1] + a[i][j])%MOD;
    }

    int n;
    cin >> n;
    ll mex = 1, basa = 0;
    ll ans = 0;
    while (basa <= n)
    {
        ans += mex*((alpha(n - basa) - alpha(n - basa - mex) + MOD)%MOD);
        ans %= MOD;

        basa += mex;
        mex++;
    }
    cout << ans;
    return 0;
}
