#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll MAXN = 5001, MOD = 1e9 + 7;

ll dp[MAXN][MAXN];

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < MAXN; ++i) {
        dp[i][0] = 1;
    }
    for (ll i = 1; i < MAXN; ++i) {
        for (ll j = 1; j < MAXN; ++j) {
            for (ll c = 0; c <= 2; ++c) {
                if (j - c > -1) {
                    dp[i][j] += dp[i - 1][j - c];
                    if (dp[i][j] >= MOD) {
                        dp[i][j] -= MOD;
                    }
                }
            }
        }
    }
    ll ans = 1;
    for (ll i = 1; i < n; ++i) {
        ans *= dp[i][i + 1];
        ans %= MOD;
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}