#include <iostream>
#include <algorithm>
#include <string>
#include <bitset>
#include <map>
#include <vector>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()
using ll = long long;

int n;

vector<int> ln;
vector<vector<int>> graph;
int dst(int v) {
	if (graph[v].size() == 0) {
		ln[v] = 0;
		return 1;
	}
	int mx = n;
	for (auto& i : graph[v])
		mx = min(dst(i), mx);
	ln[v] = mx;
	return mx + 1;
}
int ans = 0;
vector<int> res;
void dfs(int v, vector<int>& nums, int h, int mx) {
	int lnCl = ln[v];
	if (lnCl == 0) return;
	res[v] = max(mx, nums[h]);
	ans = max(ans, res[v]);
	int bef = nums[h + lnCl];
	nums[h + lnCl] = max(nums[h + lnCl], res[v] + 1);
	for (auto& i : graph[v])
		dfs(i, nums, h + 1, res[v]);
	nums[h + lnCl] = bef;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;

	ln.resize(n);
	res.resize(n, 0);
	graph = vector<vector<int>> (n);
	for (int i = 1; i < n; i++)
	{
		int a;
		cin >> a;
		a--;
		graph[a].push_back(i);
	}
	vector<int> nums(n, 0);
	dst(0);
	dfs(0, nums, 0, 0);
	cout << ans + 1;
}

