#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    int sum = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    int need = sum / n;

    int r1 = -1, r2 = -1;
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < n; j++) {
            cur += a[i][j];
        }
        if (cur != need) {
            if (r1 == -1) {
                r1 = i;
            } else {
                r2 = i;
            }
        }
    }

    int c1 = -1, c2 = -1;
    for (int j = 0; j < n; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            cur += a[i][j];
        }
        if (cur != need) {
            if (c1 == -1) {
                c1 = j;
            } else {
                c2 = j;
            }
        }
    }

    if (r1 == -1) { // в одной строке
        int sum1 = 0, sum2 = 0;
        for (int i = 0; i < n; i++) {
            sum1 += a[i][c1];
            sum2 += a[i][c2];
        }
        for (int i = 0; i < n; i++) {
            sum1 -= a[i][c1];
            sum1 += a[i][c2];
            sum2 -= a[i][c2];
            sum2 += a[i][c1];
            if (sum1 == sum2) {
                cout << i + 1 << ' ' << c1 + 1 << '\n';
                cout << i + 1 << ' ' << c2 + 1 << '\n';
                return;
            }
            sum1 += a[i][c1];
            sum1 -= a[i][c2];
            sum2 += a[i][c2];
            sum2 -= a[i][c1];
        }
    } else if (c1 == -1) { // в одной столбце
        int sum1 = 0, sum2 = 0;
        for (int j = 0; j < n; j++) {
            sum1 += a[r1][j];
            sum2 += a[r2][j];
        }
        for (int j = 0; j < n; j++) {
            sum1 -= a[r1][j];
            sum1 += a[r2][j];
            sum2 -= a[r2][j];
            sum2 += a[r1][j];
            if (sum1 == sum2) {
                cout << r1 + 1 << ' ' << j + 1 << '\n';
                cout << r2 + 1 << ' ' << j + 1 << '\n';
                return;
            }
            sum1 += a[r1][j];
            sum1 -= a[r2][j];
            sum2 += a[r2][j];
            sum2 -= a[r1][j];
        }
    } else {
        auto b = a;
        swap(b[r1][c1], b[r2][c2]);
        bool ok = true;
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < n; j++) {
                cur += b[i][j];
            }
            ok &= cur == need;
        }
        for (int j = 0; j < n; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                cur += b[i][j];
            }
            ok &= cur == need;
        }
        if (ok) {
            cout << r1 + 1 << ' ' << c1 + 1 << '\n';
            cout << r2 + 1 << ' ' << c2 + 1 << '\n';
        } else {
            cout << r1 + 1 << ' ' << c2 + 1 << '\n';
            cout << r2 + 1 << ' ' << c1 + 1 << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}