#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define gen(a,b) uniform_int_distribution<int>(a,b)(rng)
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

struct Fenwick {
    int n;
    vector<int> a;

    Fenwick(int n) : n(n), a(n + 1) {}
    void add(int x, int v) {
        for (x++; x <= n; x += x & -x) {
            a[x - 1] += v;
        }
    }
    int get(int x) {
        int res = 0;
        for (x++; x >= 1; x -= x & -x) {
            res += a[x - 1];
        }
        return res;
    }
    int get(int l, int r) {
        if(r < l)return 0;
        return get(r) - get(l - 1);
    }
};
void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    Fenwick cnt(n),bbabb(n),bbb(n);
    for(int i = 0; i < n; i++) {
        if(i + 5 - 1 < n) {
            if(s.substr(i, 5) == "bbabb") {
                bbabb.add(i, 1);
            }
        }
        if(i + 3 - 1 < n) {
            if(s.substr(i, 3) == "bbb") {
                bbb.add(i, 1);
            }
        }
        if(s[i] == 'a') {
            cnt.add(i,1);
        }
    }
    auto ch=  [&](int l, int r) {
        if(r - l + 1 == 1) {
            if(s[l] == 'a')return true;
            else {
                return false;
            }
        }
        if(s[l] == 'b' && s[l + 1] == 'b') {
            return false;
        }
        if(s[r] == 'b' && s[r - 1] == 'b') {
            return false;
        }
        int colbbb = bbb.get(l,r - 2);
        int colbbabb = bbabb.get(l, r - 4);
        if(colbbb || colbbabb)return false;
        int cola = cnt.get(l,r);
        int colb = (r- l+1) - cola;
        if(cola < colb) return false;
        return true;
    };
    int q;
    cin >> q;
    for(int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if(t == 1) {
            int id;
            cin >> id;
            id--;
            if(s[id]=='b') {
                cnt.add(id,1);
                s[id] = 'a';
            } else {
                cnt.add(id, -1);
                s[id] = 'b';
            }
            for(int nah = max(id - 4, 0ll); nah <= id; nah++) {
                if(bbb.get(nah,nah) == 1) {
                    bbb.add(nah, -1);
                }
                if(bbabb.get(nah,nah) == 1) {
                    bbabb.add(nah, -1);
                }
                if(nah + 5 - 1 < n) {
                    if(s.substr(nah, 5) == "bbabb") {
                        bbabb.add(nah, 1);
                    }
                }
                if(nah + 3 - 1 < n) {
                    if(s.substr(nah, 3) == "bbb") {
                        bbb.add(nah, 1);
                    }
                }
            }
        } else {
            int l,r;
            cin >> l >> r;
            l--,r--;
            if(ch(l,r)) {
                cout << "YES" << endl;
            }else {
                cout << "NO" << endl;
            }
        }

    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}