#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()

int n;
vector<vector<int>> graph;
vector<int> dist;

void dfs(int v, int d = 0) {
    dist[v] = d;
    for (auto& to : graph[v]) {
        dfs(to, d + 1);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    graph.assign(n, vector<int>());
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        graph[x].emplace_back(i);
    }
    dist.assign(n, 0);
    dfs(0);
    vector<int> leaf;
    for (int i = 0; i < n; ++i) {
        if (graph[i].empty()) leaf.emplace_back(i);
    }
    sort(all(leaf), [&](int& a, int& b){return dist[a] < dist[b];});
    int z = dist[leaf.back()];
    int s = 0, k = 0;
    while (k < leaf.size() && s + dist[leaf[k]] <= z) {
        s += dist[leaf[k++]];
    }
    cout << k + (s != z) << endl;

    return 0;
}
