#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;

ll mod = 1e9 + 7;

ll mult(ll a, ll b) {
    return a*b%mod;
}

ll binpow(ll a, int b) {
    if (b == 0) return 1;
    if (b == 1) return a;
    ll aa = binpow(mult(a,a), b/2);
    if (b % 2 == 0)
        return aa;
    return mult(aa, a);
}

ll rev(ll x) {
    return binpow(x, mod-2);
}

vector<ll> fa;
vector<ll> far;

void facalc() {
    fa = {1, 1};
    for (int i = 0; i < 5010; i++)
        fa.emplace_back(mult(fa.back(), fa.size()));
    for (ll i : fa)
        far.emplace_back(rev(i));
}

ll cnk(ll n, ll k) {
    return mult(mult(fa[n], far[k]), far[n-k]);
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    facalc();

    int n; cin >> n;
    vector<int> d(3);
    for(int i = 0; i < n; ++i) {
        ll buf;
        cin >> buf;
        d[buf % 3]++;
    }

    int y = d[1];
    int z = d[2];
    int x = d[0];
    if((d[1] - d[2]) % 3 == 0)
    {
        cout << 0;
    } else {
        ll a = mult(fa[x], fa[y]);
        ll b = mult(fa[z], cnk(n-1, x));
        cout << mult(a, b);
    }
}
