#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using vi = vector<int>;
#define f first
#define s second

ll mod = 1e9 + 7;

ll MXX = 1e15;

map<int, vi> xx, yy;
vi ansx = {0, 0};
vi ansy = {0, 0};

int md2(int x) {
    return (x % 2) != 0;
}

int mx(const vi &q) {
    return max(q[0], q[1]);
}

int get_ans() {
    return std::max(mx(ansx), mx(ansy));
}

void updateX(int x, int y, int d) {
    vi *p = &yy[y];
    int was = mx(*p);
    (*p)[md2(x)] += d;
    int now = mx(*p);
    ansx[md2(y)] += now-was;
}

void updateY(int x, int y, int d) {
    vi *p = &xx[x];
    int was = mx(*p);
    (*p)[md2(y)] += d;
    int now = mx(*p);
    ansy[md2(x)] += now-was;
}

set<pi> sq;

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y; cin >> x >> y;

        int s0 = sq.size();
        sq.emplace(x, y);
        if (sq.size() != s0) {
            if (xx.find(x) == xx.end())
                xx[x] = {0, 0};
            if (yy.find(y) == yy.end())
                yy[y] = {0, 0};

            updateX(x, y, 1);
            updateY(x, y, 1);
        } else {
            sq.erase({x, y});

            updateX(x, y, -1);
            updateY(x, y, -1);
        }
        cout << get_ans() << "\n";
    }
}
