#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
#define int ll
const int MOD = (int)1e9+7;

int fact[5001];

ll bin_pow(int a, int n){
    ll res = 1;
    while(n){
        if(n & 1){
            res *= a;
            res %= MOD;
        }
        a *= a;
        a %= MOD;
        n >>= 1;
    }
    return res;
}

ll divide(int a, int b){
    return (a * bin_pow(b, MOD-2)) % MOD;
}

ll get_c_n_k(int n, int k){
    ll a = fact[n-k]*fact[k];
    a %= MOD;
    return divide(fact[n], a);
}


void solve() {
    fact[0] = 1;
    for(int i = 1; i <= 5000; ++i){
        fact[i] = fact[i-1] * i;
        fact[i] %= MOD;
    }
    int n;
    cin>>n;
    vector<int> dp(n+1);
    dp[n] = 1;
    for(int i = n-1; i >= 1; --i){
        dp[i] = dp[i+1];
        ll cnt = 0;
        for(int x = 0; x < i; ++x){
            if((i+1-x) % 2 == 0){
                ll a = 1;
                a *= get_c_n_k(i, x);
                a %= MOD;
                a *= get_c_n_k(i-x, (i+1-x)/2);
                a %= MOD;
                cnt += a;
            }
        }
        dp[i] *= cnt;
    }
    cout << dp[1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}