#include <bits/stdc++.h>
using ll = long long;
using namespace std;

constexpr int mod = 1e9 + 7;

int binpow(int a, int n) {
    int res = 1;
    while (n > 0) {
        if (n % 2 == 1) {
            res = (res * 1ll * a) % mod;
        }
        n /= 2;
        a = (a * 1ll * a) % mod;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> v(n);
    map<int, int> cnt;
    for (int &i : v) {
        cin >> i;
        i %= 3;
        ++cnt[i];
    }
    if (cnt[0] == n) {
        cout << 0;
        return 0;
    }
    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; ++i) {
        fact[i] = (fact[i - 1] * 1ll * i) % mod;
    }
    vector<int> rfact(n + 1);
    for (int i = 0; i <= n; ++i) {
        rfact[i] = binpow(fact[i], mod - 2);
    }
    int ans = (fact[n - 1] * 1ll * rfact[n - 1 - cnt[0]]) % mod;
    if (cnt[1] == cnt[2] || abs(cnt[2] - cnt[1]) > 2) {
        cout << 0;
    } else {
        cout << (((ans * 1ll * fact[cnt[1]]) % mod) * 1ll * fact[cnt[2]]) % mod;
    }
    return 0;
}
