#include <bits/stdc++.h>
#define int long long
using namespace std;

constexpr int mod = 1e9 + 7;

int cnt_pref[1001][1001];
int cnt_suff[1001][1001];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        cnt_pref[i][i] = 1;
        cnt_suff[i][i] = 1;
    }

    for (int s = 1; s <= n; s++) {
        for (int i = 1; i <= n; i++) {
            cnt_pref[s][i] += cnt_pref[s][i - 1];
            if (cnt_pref[s][i] >= mod) {
                cnt_pref[s][i] -= mod;
            }
        }

        for (int i = 1; i <= n; i++) {
            if (s + i <= n) {
                cnt_pref[s + i][i] += cnt_pref[s][i];
                if (cnt_pref[s + i][i] >= mod) {
                    cnt_pref[s + i][i] -= mod;
                }
            }
        }
    }

    for (int s = 1; s <= n; s++) {
        for (int i = n; i >= 1; i--) {
            cnt_suff[s][i] += cnt_suff[s][i + 1];
            if (cnt_suff[s][i] >= mod) {
                cnt_suff[s][i] -= mod;
            }
        }

        for (int i = 1; i <= n; i++) {
            cnt_suff[s + i][i] += cnt_suff[s][i];
            if (cnt_suff[s + i][i] >= mod) {
                cnt_suff[s + i][i] -= mod;
            }
        }
    }

    int ans = 0;

    for (int i = 1; i <= n + 1; i++) {
        for (int l = 0; l <= n; l++) {
            int left;

            if (l == 0) {
                left = (i == 1 ? 1 : 0);
            } else {
                int sum_before = (1 + i - 1) * (i - 1) / 2;
                if (sum_before > l) {
                    left = 0;
                } else if (sum_before == l) {
                    left = 1;
                } else {
                    left = cnt_pref[l - sum_before][i - 1];
                }
            }

            int right = (l == n ? 1 : cnt_suff[n - l][i + 1]);

            int cnt = left * right % mod;
            cnt *= i;
            cnt %= mod;

            ans += cnt;

            if (ans >= mod) {
                ans -= mod;
            }
        }
    }

    cout << ans << '\n';
    return 0;
}
