#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
const ll MOD = 1e9+7;

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> l(n+1, vector<ll>(n+1, 0));
    vector<vector<ll>> r(n+1, vector<ll>(n+1, 0));
    l[0][0]=1;
    r[0][0] = 1;
    for (ll i = 1;i<=n;i++){
        ll x = i;
        l[i]=l[i-1];
        for (ll j = 0;j+x<=n;j++){
            l[i][j+x]=(l[i][j] + l[i][j+x]) % MOD;
        }
        x=n+1-i;
        r[i]=r[i-1];
        for (ll j = 0;j+x<=n;j++){
            r[i][j+x]=(r[i][j]+r[i][j+x]) % MOD;
        }
    }
    ll ans = 0;
    for (ll m = 1;m<=n + 1;m++){
        ll nab = n - m * (m - 1) / 2;
        if (m == n + 1){
            if (nab >= 0) ans = (ans + m * l[m-1][nab]) % MOD;
            break;
        }
        ll res = 0;
        for (ll sm = 0;sm <= nab;sm++){
            res = (res + l[m-1][sm] * r[n-m][nab - sm]) % MOD;
        }
        ans = (ans + res * m) % MOD;
    }
    cout << ans << "\n";
}
