#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int Inf = 0x4f4f4f4f;
const ll inf = 1144000000000000000;

const int maxn = 200005;
vector<int> g[maxn], layers[maxn << 2];
int d[maxn], ldist[maxn], tin[maxn], tout[maxn], timer, prefsum[maxn];
int dfs1(int v) {
    tin[v] = timer++;
    ldist[v] = Inf;
    if (g[v].size() == 0) {
        return ldist[v] = 0;
    }
    for (auto e : g[v])
        ldist[v] = min(ldist[v], dfs1(e) + 1);
    tout[v] = timer++;
    return ldist[v];
}

int tr[maxn << 2];
void upd(int v, int l, int r, int ql, int qr) {
    if (l == r) {
        tr[v] = qr;
        return;
    }
    if ((l + r) / 2 >= ql)
        upd(v * 2 + 1, l, (l + r) / 2, ql, qr);
    else
        upd(v * 2 + 2, (l + r) / 2 + 1, r, ql, qr);
    tr[v] = max(tr[v * 2 + 1], tr[v * 2 + 2]);
}
int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l > qr || r < ql) {
        return 0;
    }
    return max(get(v * 2 + 1, l, (l + r) / 2, ql, qr),
               get(v * 2 + 2, (l + r) / 2 + 1, r, ql, qr));
}

void solve() {
    memset(d, 0x4f, sizeof d);
    d[0] = 0;
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        --x;
        g[x].push_back(i + 1);
    }
    queue<int> q;
    q.push(0);
    while (q.size()) {
        int t = q.front();
        q.pop();
        layers[d[t]].push_back(t);
        for (auto e : g[t]) {
            q.push(e);
            d[e] = d[t] + 1;
        }
    }
    for (int i = 1; i < maxn; ++i)
        prefsum[i] = prefsum[i - 1] + layers[i - 1].size();
    dfs1(0);
    for (int i = maxn - 1; i >= 0; --i) {
        int idx = -1;
        for (auto e : layers[i]) {
            idx++;
            int d = i + ldist[e] + (e != 0);
            if (!layers[d].size())
                continue;
            int l = -1, r = layers[d].size();
            while (r - l > 1) {
                int mi = (l + r) / 2;
                if (tin[layers[d][mi]] > tin[e])
                    r = mi;
                else
                    l = mi;
            }
            if (r == layers[d].size())
                continue;
            int fst = r;
            l = fst - 1, r = layers[d].size();
            while (r - l > 1) {
                int mi = (l + r) / 2;
                if (tout[layers[d][mi]] > tout[e])
                    r = mi;
                else
                    l = mi;
            }
            int lst = r;
            if (lst == fst)
                continue;
            upd(0, 0, maxn - 1, prefsum[i] + idx, get(0, 0, maxn - 1, prefsum[d] + fst, prefsum[d] + lst - 1) + 1);
        }
    }
    cout << get(0, 0, maxn - 1, 0, 0);
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    // cin >> Tc;
    while (Tc--)
        solve(), cout << '\n';
}
/*
10
1 1 1 2 3 4 6 7 9
2

6
1 1 2 3 5
2

4
1 1 3
2

2
1 2
1


*/