#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ld = long double;
using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (ll) x.size()
#define szof(x) (ll) x.size()

const ll M = 1e9 + 7;

const int MAXN = 5005;
ll dp[MAXN][MAXN + 1];

void solve() {
    int n;
    cin >> n;
    int ans = 1;
    dp[0][0] = dp[0][1] = 1;
    for (int i = 1; i < n - 1; ++i) {
        dp[i][0] = dp[i][1] = 1;
        for (int j = 2; j <= i + 1; ++j) {
            cout << dp[i][j] << " ";
            dp[i][j] = ((ll) dp[i - 1][j] + dp[i - 1][j - 1] + dp[i - 1][j - 2]) % M;
        }
        cout << "\n";
    }
    cout << ans;
}

void solve2() {
    for (int i = 0; i < MAXN; ++i) {
        dp[i][0] = 1;
    }
    for (int i = 1; i < MAXN; ++i) {
        for (int j = 1; j < MAXN; ++j) {
            dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]) % M;
            if (j >= 2) {
                dp[i][j] = (dp[i][j] + dp[i - 1][j - 2]) % M;
            }
        }
    }
    int n;
    cin >> n;
//
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j <= n; ++j) {
//            cout << dp[i][j] << ' ';
//        }
//        cout << '\n';
//    }
    ll ans = 1;
    for (int i = 2; i <= n; ++i) {
        ans = (ans * dp[i - 1][i]) % M;
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve2(), cout << '\n';
    return 0;
}
