#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

const int N = 2e5;
vector<int> g[N];
int sz[N], d[N];
int dp[N];
int mnd[N], mxd[N];
map<int, int> m[N];

void norm(int v) {
    sz[v] = 1;
    for (int u : g[v]) {
        norm(u);
        sz[v] += sz[u];
    }
    sort(all(g[v]), [&](int v, int u){
        return sz[v] > sz[u];
    });
}

void dfs(int v) {
    if (g[v].empty()) {
        mxd[v] = mnd[v] = d[v];
        dp[v] = 1;
        m[v][d[v]] = dp[v];
        return;
    }
    mnd[v] = 1e9;
    for (int u : g[v]) {
        d[u] = d[v] + 1;
        dfs(u);
        mxd[v] = max(mxd[v], mxd[u]);
        mnd[v] = min(mnd[v], mnd[u]);
    }
    swap(m[v], m[g[v][0]]);
    for (int u : g[v])
        if (u != g[v][0]) {
            for (auto kv : m[u])
                m[v][kv.first] = max(m[v][kv.first], kv.second);
        }
    if (mxd[v] != mnd[v])
        dp[v] = 1 + m[v][mnd[v]];
    else
        dp[v] = 1;//m[v][mnd[v]];
    m[v][d[v]] = dp[v];
}

inline void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    norm(0);
    dfs(0);
    cout << dp[0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}