#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <set>

using namespace std;
using ll = long long;

const int mod = 1e9 + 7;

void stupid(vector<vector<ll>> vec) {
	for (ll i1 = 0; i1 < 3; i1++) {
		for (ll j1 = 0; j1 < 3; j1++) {
			for (ll i2 = 0; i2 < 3; i2++) {
				for (ll j2 = 0; j2 < 3; j2++) {
					if (i1 == i2 && j1 == j2) continue;
					swap(vec[i1][j1], vec[i2][j2]);

					set<ll> sums;

					for (ll i = 0; i < 3; i++) {
						ll sm = 0;
						for (ll j = 0; j < 3; j++) {
							sm += vec[i][j];
						}
						sums.insert(sm);
					}
					for (ll j = 0; j < 3; j++) {
						ll sm = 0;
						for (ll i = 0; i < 3; i++) {
							sm += vec[i][j];
						}
						sums.insert(sm);
					}

					if (sums.size() == 1) {
						cout << i1 + 1 << " " << j1 + 1 << endl << i2 + 1 << " " << j2 + 1 << endl;
						return;
					}

					swap(vec[i1][j1], vec[i2][j2]);
				}
			}
		}
	}
}

int main() {
	ll n; cin >> n;
	vector<vector<ll>> vec(n, vector<ll>(n));

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < n; j++) {
			cin >> vec[i][j];
		}
	}

	if (n == 3) {
		stupid(vec);
		return 0;
	}

	vector<ll> vsum(n), gsum(n);
	unordered_map<ll, ll> vcnt, gcnt;

	for (ll i = 0; i < n; i++) {
		ll sm = 0;
		for (ll j = 0; j < n; j++) sm += vec[i][j];
		gsum[i] = sm;
		gcnt[sm]++;
	}
	for (ll j = 0; j < n; j++) {
		ll sm = 0;
		for (ll i = 0; i < n; i++) sm += vec[i][j];
		vsum[j] = sm;
		vcnt[sm]++;
	}

	ll cor = -1;
	for (auto p : vcnt) {
		if (p.second > 1) cor = p.first;
	}

	ll i1 = -1, i2 = -1, j1 = -1, j2 = -1;
	for (ll i = 0; i < n; i++) {
		if (gsum[i] != cor) {
			i2 = i1;
			i1 = i;
		}
	}
	for (ll j = 0; j < n; j++) {
		if (vsum[j] != cor) {
			j2 = j1;
			j1 = j;
		}
	}

	if (i1 != -1 && j1 != -1) {
		cout << i1 + 1 << " " << j1 + 1 << " " << endl << i2 + 1 << " " << j2 + 1 << endl;
	} else {
		if (i1 != -1) {
			ll nd = abs(gsum[i1] - gsum[i2]) / 2;
			for (ll j = 0; j < n; j++) {
				ll delta = abs(vec[i1][j] - vec[i2][j]);
				if (delta == nd) {
					cout << i1 + 1 << " " << j + 1 << endl << i2 + 1 << " " << j + 1 << endl;
					return 0;
				}
			}
		} else {
			ll nd = abs(vsum[j1] - vsum[j2]) / 2;
			for (ll i = 0; i < n; i++) {
				ll delta = abs(vec[i][j1] - vec[i][j2]);
				if (nd == delta) {
					cout << i + 1 << " " << j1 + 1 << endl << i + 1 << " " << j2 + 1 << endl;
					return 0;
				}
			}
		}
	}
}