#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <set>

using namespace std;
using ll = long long;

const int mod = 1e9 + 7;

void stupid(vector<vector<ll>> vec) {
	for (ll i1 = 0; i1 < 3; i1++) {
		for (ll j1 = 0; j1 < 3; j1++) {
			for (ll i2 = 0; i2 < 3; i2++) {
				for (ll j2 = 0; j2 < 3; j2++) {
					if (i1 == i2 && j1 == j2) continue;
					swap(vec[i1][j1], vec[i2][j2]);

					set<ll> sums;

					for (ll i = 0; i < 3; i++) {
						ll sm = 0;
						for (ll j = 0; j < 3; j++) {
							sm += vec[i][j];
						}
						sums.insert(sm);
					}
					for (ll j = 0; j < 3; j++) {
						ll sm = 0;
						for (ll i = 0; i < 3; i++) {
							sm += vec[i][j];
						}
						sums.insert(sm);
					}

					if (sums.size() == 1) {
						cout << i1 + 1 << " " << j1 + 1 << endl << i2 + 1 << " " << j2 + 1 << endl;
						return;
					}

					swap(vec[i1][j1], vec[i2][j2]);
				}
			}
		}
	}
}

int main() {

	ll n; cin >> n;
	
	unordered_map<ll, ll> xton;
	unordered_map<ll, ll> xtoc;
	unordered_map<ll, ll> yton;
	unordered_map<ll, ll> ytoc;

	unordered_map<ll, bool> used;

	ll anscx = 0, ansnx = 0, anscy = 0, ansny = 0;

	for (ll i = 0; i < n; i++) {
		ll x, y; cin >> x >> y;
		ll h = x * 1e9 + y;

		bool b = used[h];
		used[h] = !b;

		if (x % 2 == 0) {
			anscx -= max(xtoc[x], xton[x]);
		}
		else {
			ansnx -= max(xtoc[x], xton[x]);
		}
		if (y % 2 == 0) {
			anscy -= max(ytoc[y], yton[y]);
		}
		else {
			ansny -= max(ytoc[y], yton[y]);
		}

		if (b) {
			if (y % 2 == 0) {
				xtoc[x]--;
			}
			else {
				xton[x]--;
			}
			if (x % 2 == 0) {
				ytoc[y]--;
			}
			else {
				yton[y]--;
			}
		} else {

			if (y % 2 == 0) {
				xtoc[x]++;
			}
			else {
				xton[x]++;
			}
			if (x % 2 == 0) {
				ytoc[y]++;
			}
			else {
				yton[y]++;
			}
		}

		if (x % 2 == 0) {
			anscx += max(xtoc[x], xton[x]);
		}
		else {
			ansnx += max(xtoc[x], xton[x]);
		}
		if (y % 2 == 0) {
			anscy += max(ytoc[y], yton[y]);
		}
		else {
			ansny += max(ytoc[y], yton[y]);
		}

		ll ans = max(anscx, max(ansnx, max(ansny, anscy)));
		cout << ans << endl;
	}

}