#include <bits/stdc++.h>
#define int long long
const int inf=1e17;
using namespace std;

void opt(){
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int c=1<<17;
struct segtree{
    string s1;
    vector<int>l1;
    vector<vector<vector<int>>> seg;
    segtree(string s){
        s1=s;
        while(s1.size()<c){
            s1+='a';
        }
        l1.assign(2*c,0);
        seg.assign(2*c,vector<vector<int>>(2,vector<int>(2,0)));
        for(int i=c;i<2*c;i++){
            if(s1[i-c]=='a'){
                seg[i][0][0]=1;
                seg[i][0][1]=1;
                seg[i][1][0]=1;
            } else{
                seg[i][0][1]=1;
                seg[i][1][0]=1;
            }
            l1[i]=i-c;
        }
        for(int i=c-1;i>0;i--){
            upd(i);
        }
    }
    vector<vector<int>> merge(const vector<vector<int>>& a, const vector<vector<int>>& b, int pos){
        if(a[0][0]==-1) return b;
        if(b[0][0]==-1) return a;
        vector<vector<int>> ans(2,vector<int>(2,0));
        ans[0][0]=(a[0][0]&&b[0][0])||(a[0][1]&&b[1][0] && s1[pos]!=s1[pos+1]);
        ans[0][1]=(a[0][0]&&b[0][1])||(a[0][1]&&b[1][1] && s1[pos]!=s1[pos+1]);
        ans[1][0]=(a[1][0]&&b[0][0])||(a[1][1]&&b[1][0] && s1[pos]!=s1[pos+1]);
        ans[1][1]=(a[1][0]&&b[0][1])||(a[1][1]&&b[1][1] && s1[pos]!=s1[pos+1]);
        return ans;
    }
    void upd(int v){
        l1[v]=l1[2*v];
        seg[v]=merge(seg[2*v],seg[2*v+1],l1[2*v+1]-1);
    }
    void change(int v){
        v/=2;
        if(!v) return;
        upd(v);
        change(v);
    }
    vector<vector<int>> get(int v, int l, int r, int lv, int rv){
        if(l<=lv && rv<=r){
            return seg[v];
        }
        if(lv>=r || l>=rv){
            return {{-1,-1},{-1,-1}};
        }
        int mid=(lv+rv)/2;
        return merge(get(2*v,l,r,lv,mid),get(2*v+1,l,r,mid,rv),l1[2*v+1]-1);
    }
};
int32_t main() {
    opt();
    int n;
    cin>>n;
    string s;
    cin>>s;
    segtree d(s);
    int q;
    cin>>q;
    for(int i=0;i<q;i++){
        int type;
        cin>>type;
        if(type==1){
            int j;
            cin>>j;
            d.seg[c+j-1][0][0]^=1;
            if(d.s1[j-1]=='a'){
                d.s1[j-1]='b';
            } else {
                d.s1[j-1]='a';
            }
            d.change(c+j-1);
        } else {
            int l,r;
            cin>>l>>r;
            if(d.get(1,l-1,r,0,c)[0][0]){
                cout<<"YES\n";
            } else {
                cout<<"NO\n";
            }
        }
    }
    return 0;
}
