#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, INF = 1e9 + 7, ans, maxim = 0;
vector<vector<ll>> a;
vector<ll> level, max_down;
vector<bool> used;

void input() {
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll dhd;
        cin >> dhd;
        a[i + 1].push_back(dhd - 1);
        a[dhd - 1].push_back(i + 1);
    }
}

void dfs(ll u, ll tek) {
    used[u] = true;
    level[u] = tek;
    max_down[u] = INF;
    maxim = max(maxim, level[u]);
    for (ll i = 0; i < a[u].size(); i++) {
        if (!used[a[u][i]]) {
            dfs(a[u][i], tek + 1);
            max_down[u] = min(max_down[a[u][i]] + 1, max_down[u]);
        }
    }
    if (a[u].size() == 1 && u != 0) {
        max_down[u] = 0;
    }
}

ll rec(ll u, ll clock, ll tek_ans) {
    //cout << u << " " << clock << " " << tek_ans << " " << max_down[u] << endl;
    if (a[u].size() == 1 && u != 0) {
        return tek_ans;
    }
    ll smthh = 0;
    if (clock == 0) {
        clock = max_down[u];
        smthh = 1;
    }
    used[u] = true;
    ll x = 0;
    for (ll i = 0; i < a[u].size(); i++) {
        if (!used[a[u][i]]) {
            x = max(rec(a[u][i], clock - 1, tek_ans + smthh), x);
        }
    }
    return x;
}

void solve() {
    used.assign(n, false);
    level.assign(n, 0);
    max_down.assign(n, 0);
    dfs(0, 0);
    used.assign(n, false);
    ans = rec(0, 0, 0);
}

void output() {
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
