#include <bits/stdc++.h>

using namespace std;
using ll = long long;

//#define int long long
ll n;

ll pr(vector<ll> &sums, vector<ll> &sume) {

    vector<pair<ll, ll>> sk;
    for (int i = 0; i < n; ++i) {
        sk.push_back({sums[i], (ll) 0});
    }
    std::sort(sk.begin(), sk.end());
    if (sk[0].first != sk[n - 1].first) {
        return 0;
    }
    sk.clear();
    for (int j = 0; j < n; ++j) {
        sk.push_back({sume[j], (ll) 0});
    }
    std::sort(sk.begin(), sk.end());
    if (sk[0].first != sk[n - 1].first) {
        return 0;
    }
    return 1;
}


ll pr(vector<vector<ll>> &a) {
    vector<pair<ll, ll>> sk;
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        for (int j = 0; j < n; ++j) {
            sum += a[i][j];
        }
        sk.emplace_back(sum, i);
    }
    std::sort(sk.begin(), sk.end());
    if (sk[0].first != sk[n - 1].first) {
        return 0;
    }
    sk.clear();
    for (int j = 0; j < n; ++j) {
        ll sum = 0;
        for (int i = 0; i < n; ++i) {
            sum += a[i][j];
        }
        sk.emplace_back(sum, j);
    }
    std::sort(sk.begin(), sk.end());
    if (sk[0].first != sk[n - 1].first) {
        return 0;
    }
    return 1;
}

void solve() {
    cin >> n;
    vector<vector<ll>> a(n, vector<ll>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    ll s1 = -1;
    ll s2 = -1;
    ll e1 = -1;
    ll e2 = -1;
    vector<pair<ll, ll>> sk;
    vector<ll> sums(n);
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        for (int j = 0; j < n; ++j) {
            sum += a[i][j];
        }
        sk.emplace_back(sum, i);
        sums[i] = sum;
    }
    std::sort(sk.begin(), sk.end());
    ll sk1 = -1;
    ll sk2 = -1;
    s1 = sk[0].second;
    s2 = sk[n - 1].second;
    sk1 = sk[0].first;
    sk2 = sk[n - 1].first;
    sk.clear();
    vector<ll> sume(n);
    for (int j = 0; j < n; ++j) {
        ll sum = 0;
        for (int i = 0; i < n; ++i) {
            sum += a[i][j];
        }
        sk.emplace_back(sum, j);
        sume[j] = sum;
    }
    std::sort(sk.begin(), sk.end());
    e1 = sk[0].second;
    e2 = sk[n - 1].second;
    ll ek1 = sk[0].first;
    ll ek2 = sk[n - 1].first;
    if (ek1 == ek2) {
        for (int j = 0; j < n; ++j) {
            ll w = a[s1][j] - a[s2][j];
            sums[s1] += w;
            sums[s2] -= w;
            if (pr(sums, sume)) {
                cout << s1 + 1 << " " << j + 1 << '\n';
                cout << s2 + 1 << " " << j + 1 << '\n';
                return;
            }
        }
        while (true);
    }
    if (sk1 == sk2) {
        for (int i = 0; i < n; ++i) {
            ll w = a[i][e1] - a[i][e2];
            sume[e1] += w;
            sume[e2] -= w;
            if (pr(sums, sume)) {
                cout << i + 1 << " " << e1 + 1 << '\n';
                cout << i + 1 << " " << e2 + 1 << '\n';
                return;
            }
        }
        while (true);
    }
    {
        ll i1 = s1;
        ll j1 = e1;
        ll i2 = s1;
        ll j2 = e2;
        swap(a[i1][j1], a[i2][j2]);
        if (pr(a)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n';
            cout << i2 + 1 << " " << j2 + 1 << '\n';
            return;
        }
        swap(a[i1][j1], a[i2][j2]);
    }
    {
        ll i1 = s1;
        ll j1 = e1;
        ll i2 = s2;
        ll j2 = e2;
        swap(a[i1][j1], a[i2][j2]);
        if (pr(a)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n';
            cout << i2 + 1 << " " << j2 + 1 << '\n';
            return;
        }
        swap(a[i1][j1], a[i2][j2]);
    }
    {
        ll i1 = s2;
        ll j1 = e1;
        ll i2 = s1;
        ll j2 = e2;
        swap(a[i1][j1], a[i2][j2]);
        if (pr(a)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n';
            cout << i2 + 1 << " " << j2 + 1 << '\n';
            return;
        }
        swap(a[i1][j1], a[i2][j2]);
    }
    {
        ll i1 = s2;
        ll j1 = e1;
        ll i2 = s2;
        ll j2 = e2;
        swap(a[i1][j1], a[i2][j2]);
        if (pr(a)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n';
            cout << i2 + 1 << " " << j2 + 1 << '\n';
            return;
        }
        swap(a[i1][j1], a[i2][j2]);
    }
    {
        ll i1 = s1;
        ll j1 = e1;
        ll i2 = s2;
        ll j2 = e1;
        swap(a[i1][j1], a[i2][j2]);
        if (pr(a)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n';
            cout << i2 + 1 << " " << j2 + 1 << '\n';
            return;
        }
        swap(a[i1][j1], a[i2][j2]);
    }
    {
        ll i1 = s1;
        ll j1 = e2;
        ll i2 = s2;
        ll j2 = e2;
        swap(a[i1][j1], a[i2][j2]);
        if (pr(a)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n';
            cout << i2 + 1 << " " << j2 + 1 << '\n';
            return;
        }
        swap(a[i1][j1], a[i2][j2]);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
