#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
    for (t &e : a) {
        din >> e;
    }
    return din;
}
const ll inf = 1e9 * 2023 + 11;

map<ll, ll> asks;

ll ask(ll d) {
    if (asks.find(d) == asks.end()) {
        cout << "? " << d << endl;
        //ll res = __lg(1 + d);
        ll res;
        cin >> res;
        asks[d] = res;
        return res;
    } else {
        return asks[d];
    }
}

ll qpaw(ll a, ll n) {
    if (n == 0) {
        return 1;
    } else {
        ll tmp = qpaw(a, n / 2);
        tmp *= tmp;
        tmp *= (n & 1 ? a : 1);
        return tmp;
    }
}

signed main() {
    ll n;
    cin >> n;
    vector<ll> d(3);
    for (ll it = 0; it < 3; it++) {
        ll l = 0, r = inf;
        for (ll m = l + (r - l) / 2; l + 1 < r; m = l + (r - l) / 2) {
            if (ask(m) > n + it) {
                r = m;
            } else {
                l = m;
            }
        }
        d[it] = r;
    }
    ll b = (d[2] - d[1]) / (d[1] - d[0]);
    ll x = qpaw(b, n) - d[0];
    cout << "! " << x << ' ' << b << endl;
}