#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define pb push_back
#define all(a) a.begin(), a.end()
#define ve vector
#define F first
#define S second

void solve2();
void solve1();
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve1();
    return 0;
}


void gcd(ll a, ll b, ll &x, ll &y) {
    if (b == 0) {
        x = 1;
        y = 0;
        return;
    } gcd(b, a % b, y, x);
    y = y - (a/b)*x;
}

ll obr(ll a, ll mod) {
    ll x = 0, y = 0;
    gcd(a, mod, x, y);
    return (x % mod + mod) % mod;
}

void solve1() {
    ll n;
    cin >> n;
    ll mod = 1e9 + 7;
    ve<ll> ans(3, 0);
    for (int i = 0; i < n; ++i) {
        int x; cin >> x;
        ans[x % 3]++;
    }
    ve<ll> fact(n+1, 1);
    for (int k = 1; k <= n; ++k) {
        fact[k] = (fact[k-1]*k) % mod;
    }
    if (ans[0] == n || ans[1] == ans[2] || abs(ans[1]-ans[2]) > 2) {
        cout << 0;
        return;
    }
    cout << (((((fact[n-1]*obr(fact[n-ans[0]-1], mod)) % mod) * fact[ans[1]]) % mod) * fact[ans[2]]) % mod;
}

vector<vector<ll>> g;
vector<ll> used, dp;
void do_dp(ll v) {
    ll cnt = 1e18;
    for (auto u : g[v]) {
        do_dp(u);
        cnt = min(cnt, dp[u] + 1);
    }
    if (cnt != 1e18) {
        dp[v] = cnt;
    }
}
ll ans = 0;
vector<ll> dist;
void dfs(ll v) {
    dist.push_back(v);
    for (auto u : g[v]) {
        dfs(u);
    }
    if ((int)g[v].size() == 0) {
        ll cnt = 0, ind = 0;
        while (ind < ll(dist.size()) - 1) {
            if (ind + dp[dist[ind]] < dist.size()) {
                cnt++;
            }
            ind += dp[dist[ind]];
        }
        ans = max(ans, cnt);
    }
    dist.pop_back();
}
void solve2() {
    ll n;
    cin >> n;
    g.resize(n);
    used.resize(n);
    dp.resize(n);
    for (int i = 1; i < n; i++) {
        ll v;
        cin >> v;
        v--;
        g[v].push_back(i);
    }
    do_dp(0);
    dfs(0);
    cout << ans;
}