#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define f first
#define s second
#define pb push_back
#define nl endl
#define in insert
#define pb push_back

using namespace std;

typedef long long ll;

#define int long long

const int N = 2e3 + 100;
const int oo = 1e9 + 7;

struct X{
    int dp[3][3];
    bool emp = 1;

    X() {
        emp = 0;
    }

    X(char c) {
        for (int i = 0; i < 3; i++)
        for (int j = 0; j < 3; j++) dp[i][j] = 0;
        if (c == 'a') {

            dp[0][0] = 1;
            dp[2][0] = 1;
            dp[0][2] = 1;
        } else {
            dp[1][0] = 1;
            dp[0][1] = 1;
        }
    }

    X unite(X x) {
        if (!emp) return x;
        if (!x.emp) return *this;
        X ans;
        ans.emp = 1;
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                ans.dp[i][j] = 0;
                if (dp[i][0] && x.dp[0][j]) ans.dp[i][j] = 1;
                if (dp[i][2] && x.dp[1][j]) ans.dp[i][j] = 1;
                if (dp[i][1] && x.dp[2][j]) ans.dp[i][j] = 1;
            }
        }
        return ans;
    }
};

string s;

struct tree {
    tree *L = NULL, *R = NULL;
    int l, r, mdl;
    X val;


    tree(int _l, int _r) : l(_l), r(_r) {
        mdl = (l + r) >> 1;
        if (l == r) {
            val = X(s[l]);
            return;
        }
        L = new tree(l, mdl);
        R = new tree(mdl + 1, r);
        val = L -> val.unite(R -> val);
    }

    void upd(int x) {
        if (l == r) {
            val = X(s[l]);
            return;
        }
        if (x <= mdl) L -> upd(x);
        else R -> upd(x);
        val = val;
        val = L -> val.unite(R -> val);
    }

    X get(int _l, int _r) {
        if (_l > _r) return X();
        if (_l == l && _r == r) return val;
        return L -> get(_l, min(mdl, _r)).unite(R -> get(max(mdl + 1, _l), _r));
    }
};

main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    cin >> s;
    tree *t = new tree(0, n - 1);
    int q;
    cin >> q;
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int pos;
            cin >> pos, pos--;
            if (s[pos] == 'a') s[pos] = 'b';
            else                s[pos] = 'a';
            t -> upd(pos);
        } else {
            int l, r;
            cin >> l >> r;
            l--, r--;
            cout << ((t -> get(l, r).dp[0][0] ? "YES\n" : "NO\n"));
        }
    }
}
