#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;

#define int long long
#define ll unsigned long long
#define vll vector<ll>
#define vi vector<int>
#define eol '\n'
#define Fastio(){ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);}

#define print(arr){for(auto x: arr){cout << x << " ";} cout << '\n';}
const int mod = 1e9 + 7;

ll sum_x[1010], sum_y[1010];
ll a[1010][1010];

void solve_f() {
    int n;
    cin >> n;

    ll sm = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll x;
            cin >> x;
            sm += x;
            a[i][j] = x;
            sum_x[i] += x;
            sum_y[j] += x;
        }
    }
    sm = n * (n * n + 1) / 2;
//
//    print(sum_x);
//    print(sum_y);
    vi x, y;
    for (int i = 0; i < n; i++) {
        if (sum_x[i] != sm) {
            x.push_back(i);
        }
        if (sum_y[i] != sm) {
            y.push_back(i);
        }
    }
//    print(x)
//    print(y)
//    cout << "___________\n\n";

    if (x.empty()) { // в одной строке
        for (int i = 0; i < n; i++) {
            if (sum_y[y[1]] - a[i][y[1]] + a[i][y[0]] == sm) {
                cout << i + 1 << " " << y[1] + 1 << eol << i + 1 << " " << y[0] + 1 << eol;
                return;
            }
        }
    }
    if (y.empty()) {
        for (int j = 0; j < n; j++) {
            if (sum_x[x[1]] - a[x[1]][j] + a[x[0]][j] == sm) {
                cout << x[0] + 1 << " " << j + 1 << eol << x[1] + 1 << " " << j + 1 << eol;
                return;
            }
        }
    }

    if (x.empty() && y.empty()) return;

    if (sum_x[x[0]] - a[x[0]][y[0]] + a[x[1]][y[1]] == sm) {
        cout << x[0] + 1 << " " << y[0] + 1 << eol << x[1] + 1 << " " << y[1] + 1 << eol;
        return;
    }
    if (sum_x[x[1]] - a[x[0]][y[1]] + a[x[1]][y[0]] == sm) {
        cout << x[0] + 1 << " " << y[1] + 1 << eol << x[1] + 1 << " " << y[0] + 1 << eol;
        return;
    }


}

signed main() {
    Fastio();
    solve_f();
}