#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

using ll = long long;

const ll maxb = 2023;

ll query(ll d) {
    cout << "? " << d << endl;
    ll ans;
    cin >> ans;
    return ans;
}

ll first_with(ll d) {
    ll lo = 1, hi = 1e9; // sus

    while (hi - lo > 1) {
        ll m = (lo + hi) / 2;

        if (query(m) >= d) hi = m;
        else lo = m;
    }

    return hi;
}

int main() {
    ll n;
    cin >> n;

    // to next digit
    ll d1 = first_with(n + 1);
    ll d2 = first_with(n + 2);
    ll d3 = first_with(n + 3);

    ll base_p = (d3 - d2) / (d2 - d1);

    ll x = 1;
    for (ll i = 0; i < n; i++) {
        x *= base_p;
    }

    x -= d1;

    cout << "! " << x << " " << base_p << endl;
}