#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n, vector<ll>(n));

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

    vector<ll> sumh(n);

    ll r1, r2;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            sumh[i] += a[i][j];
        }

        if (sumh[i] > (ll)(n * (n * n + 1) / 2)) {
            r1 = i + 1;
        }
        if (sumh[i] < (ll)(n * (n * n + 1) / 2)) {
            r2 = i + 1;
        }
    }

    vector<ll> sumv(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            sumv[j] += a[i][j];
        }
    }

    ll c1, c2;
    for (ll i = 0; i < n; ++i) {
        if (sumv[i] > (ll)(n * (n * n + 1) / 2)) {
            c1 = i + 1;
        }
        if (sumv[i] < (ll)(n * (n * n + 1) / 2)) {
            c2 = i + 1;
        }
    }

    cout << r1 << ' ' << c1 << '\n' << r2 << ' ' << c2 << '\n';
}