#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll

const int INF = 1e9;

vector<vector<int>> g;
vector<int> to_leaf, on_h;


void dfs1(int v) {
    if (g[v].size() == 0) {
        to_leaf[v] = 0;
        return;
    }
    for (auto i : g[v]) {
        dfs1(i);
        to_leaf[v] = min(to_leaf[v], to_leaf[i] + 1);
    }
}

int dfs2(int v, int h) {
    if (g[v].size() == 0)
        return on_h[h];
    int prev = on_h[h + to_leaf[v]];
    on_h[h + to_leaf[v]] = max(on_h[h + to_leaf[v]], on_h[h] + 1);
    int ans = 0;
    for (auto i : g[v])
        ans = max(ans, dfs2(i, h + 1));
    on_h[h + to_leaf[v]] = prev;
    return ans;
}

signed main() {
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        g[x - 1].push_back(i);
    }

    to_leaf.resize(n, INF);
    on_h.resize(n, 0);
    dfs1(0);
    cout << dfs2(0, 0);
}