#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll

const int MOD = 1e9 + 7;


int solve1(int n) {
    vector<vector<int>> dp1(n + 3, vector<int>(n + 1)); //dp1[n][last] - кол-во разбинений n с наибольшим слагаемым <=last
    vector<int> splits(n + 1); //splits[n] - кол-во разбинений n
    vector<vector<int>> dp2(n + 1, vector<int>(n + 1)); //dp2[n][last] - кол-вл разбинений n с наибольшим слагаемым last и mex-ом last+1
    for (int last = n + 2; last >= 1; last--) {
        if (last < n + 2)
            dp1[last] = dp1[last + 1];
        dp1[last][0] = 1;
        for (int i = last; i <= n; i++)
            dp1[last][i] = (dp1[last][i] + dp1[last][i - last]) % MOD;
    }
    dp1[0] = dp1[1];

    dp2[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int mx = 1; mx <= i; mx++)
            dp2[i][mx] = (dp2[i - mx][mx] + dp2[i - mx][mx - 1]) % MOD;
    }

    int ans = 0;
    for (int mex = 1; mex <= n + 1; mex++) {
        for (int less_sum = 0; less_sum <= n; less_sum++)
            ans = (ans + (mex * (dp2[less_sum][mex - 1] * dp1[mex + 1][n - less_sum]) % MOD) % MOD) % MOD;
    }

    return ans;
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    cout << solve1(n);
}