#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> adj(n);
    vector<deque<int>> val(n);
    vector<int> depth(n), dp(n), minLeaf(n), fa(n);

    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        adj[fa[i] = p].push_back(i);
    }

    for (int i = 1; i < n; ++i) {
        depth[i] = depth[fa[i]] + 1;
    }

    for (int i = n - 1; i >= 0; --i) {
        if (adj[i].empty()) {
            minLeaf[i] = depth[i];
        } else {
            minLeaf[i] = 1e9;
            for (int to : adj[i]) {
                minLeaf[i] = min(minLeaf[i], minLeaf[to]);
                if (size(val[to]) > size(val[i])) {
                    swap(val[to], val[i]);
                }
                for (int t = 0; t < size(val[to]); ++t) {
                    val[i][t] = max(val[i][t], val[to][t]);
                }
            }
            int f = minLeaf[i] - depth[i];
            dp[i] = 1 + val[i][f - 1];
        }
//        cout << dp[i] << " " << val[i].size() << endl;
        val[i].push_front(dp[i]);
    }
//    cout << endl;

    cout << dp[0] << '\n';

    return 0;
}