#define _CRT_SECURE_NO_WARNINGS

//#pragma  GCC optimize("O3, unroll-loops")
//#pragma GCC target("avx2, bmi, bmi2, lzcnt, popcnt")
//#pragma GCC optimize("trapv")
#include <bits/stdc++.h>

using namespace std;

#define stdin stdout

using lld = long long;
using lf = long double;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const ll mod = 1e9 + 7;

auto now_rand = chrono::high_resolution_clock::now();
mt19937 rnd(now_rand.time_since_epoch().count());

#define int ll

lld p[200'002], s[200'002], leaf[200'002];
vector<lld> g[200'002];

inline void dfsFindS(lld v, lld deep) {
    s[v] = deep;
    ++deep;
    for (lld it : g[v])
        dfsFindS(it, deep);
}

inline void dfsLeaf(lld v) {
    if (g[v].size() == 0)
        leaf[v] = v;
    else {
        for (lld it : g[v])
            dfsLeaf(it);
        leaf[v] = leaf[g[v][0]];
        for (lld it : g[v])
            if (s[leaf[it]] < s[leaf[v]])
                leaf[v] = leaf[it];
    }
}

inline lld dpSolve(lld v, lld counter) {
    lld result = 0, maxChild = 0;
    if (g[v].size() == 0)
        return 0;
    if (counter == 0) {
        counter = s[leaf[v]] - s[v] + 1;
        ++result;
    }
    for (lld it : g[v])
        maxChild = max(maxChild, dpSolve(it, counter - 1));
    return maxChild + result;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);
    // Shablon
    lld n, i;
    scanf("%lld", &n);
    for (i = 1; i < n; ++i) {
        scanf("%lld", &p[i]);
        --p[i];
        g[p[i]].push_back(i);
    }
    dfsFindS(0, 0);
    dfsLeaf(0);
    printf("%lld", dpSolve(0, 0));
    return 0;
}
