#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;
const ll N = 5001;

inline ll add(ll a, ll b) {
    ll x = a + b;
    if (x >= MOD) x -= MOD;
    return x;
}

inline ll mult(ll a, ll b) {
    return (ll)(1ll * a * b % MOD);
}

ll power(ll a, ll p) {
    if (p == 0) return 1;
    if (p == 1) return a;
    ll t = power(a, p >> 1);
    return mult(mult(t, t), power(a, p & 1));
}

vector<ll> f(N), rf(N);

inline ll c(ll n, ll k) {
    return mult(f[n], mult(rf[k], rf[n - k]));
}

ll func(ll n) {
    ll ans = 0;
    //if (n % 2 == 1) {
    //    ll tw = (n + 1) / 2;
    //    ans = mult(f[n], mult(rf[tw], rf[n - tw]));
    //}
    for (ll i = (n + 1) % 2; i <= n; i += 2) {
        if (i % 2 == n % 2) continue;
        ll tw = (n + 1 - i) / 2;
        ll zr = n - i - tw;
        //cout << i << " " << tw << " " << zr << endl;
        ans = add(ans, mult(f[n], mult(mult(rf[zr], rf[tw]), rf[i])));
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    f[0] = 1;
    for (ll i = 1; i < N; ++i) {
        f[i] = mult(f[i - 1], i);
    }
    rf[N - 1] = power(f[N - 1], MOD - 2);
    for (ll i = N - 2; i >= 0; --i) {
        rf[i] = mult(rf[i + 1], i + 1);
    }
    func(3);
    ll n;
    cin >> n;
    if (n == 1) {
        cout << 1;
        return 0;
    }
    vector<ll> dp(n);
    dp[0] = dp[1] = 1;
    for (ll i = 2; i < n; ++i) {
        dp[i] = mult(dp[i - 1], func(i));
    }
    //for (auto el : dp) {
    //    cout << el << " ";
    //}
    //cout << endl;
    cout << dp[n - 1];
}

