#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template<typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    forn(i, n) forn(j, n) cin >> a[i][j];
    vector<ll> sum_row(n), sum_col(n);
    forn(i, n) forn(j, n) sum_row[i] += a[i][j], sum_col[j] += a[i][j];

    ll need = n * (n * n + 1) / 2;
    auto check = [&](int sx1, int sy1, int sx2, int sy2) -> bool {
        return (sum_row[sx1] - a[sx1][sy1] + a[sx2][sy2] == need &&
                sum_row[sx2] - a[sx2][sy2] + a[sx1][sy1] == need &&
                sum_col[sy1] - a[sx1][sy1] + a[sx2][sy2] == need &&
                sum_col[sy2] - a[sx2][sy2] + a[sx1][sy1] == need);
    };

    int x1 = -1, y1 = -1, x2 = -1, y2 = -1;
    forn(i, n) {
        if (sum_row[i] != need) x1 == -1 ? x1 = i : x2 = i;
        if (sum_col[i] != need) y1 == -1 ? y1 = i : y2 = i;
    }

    if (x1 == -1) {
        forn(i, n) {
            if (check(i, y1, i, y2)) {
                cout << i + 1 _ y1 + 1 << nl << i + 1 _ y2 + 1 << nl;
                return;
            }
        }
    } else if (y1 == -1) {
        forn(i, n) {
            if (check(x1, i, x2, i)) {
                cout << x1 + 1 _ i + 1 << nl << x2 + 1 _ i + 1 << nl;
                return;
            }
        }
    } else {
        if (check(x1, y1, x2, y2)) cout << x1 + 1 _ y1 + 1 << nl << x2 + 1 _ y2 + 1 << nl;
        else if (check(x1, y2, x2, y1)) cout << x1 + 1 _ y2 + 1 << nl << x2 + 1 _ y1 + 1 << nl;
    }

}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}

