#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template <typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll mod = 1e9 + 7;

ll gcd(ll a, ll b, ll &x, ll &y){
    if (!a) {
        x = 0, y = 1;
        return b;
    }
    ll x1, y1, g = gcd(b % a, a, x1, y1);
    x = y1 - b / a * x1, y = x1;
    return g;
}

ll rev(ll n){
    ll x, y;
    gcd(n, mod, x, y);
    return (x % mod + mod) % mod;
}

void solve(){
    int n;
    cin >> n;
    vector<ll> cnt(3);
    forn(i, n){
        int x;
        cin >> x;
        cnt[x % 3]++;
    }

    ll res = 1;
    if (1 <= abs(cnt[2] - cnt[1]) && abs(cnt[2] - cnt[1]) <= 2) {
        for (int i = 2; i <= cnt[1]; i++) res *= i, res %= mod;
        for (int i = 2; i <= cnt[2]; i++) res *= i, res %= mod;
        for (int i = n - 1; i > n - 1 - cnt[0]; i--) res *= i; res %= mod;
        cout << res << nl;
    } else {
        cout << 0 << nl;
    }

}

signed main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while(tt--) solve();
}

