#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define eb emplace_back
#define pb push_back
const int N = 1001, MOD = 1e9 + 7;

bool check(vector<vector<int>> &a, int n) {
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    sort(all(sum1));
    sort(all(sum2));
    return sum1.front() == sum1.back() && sum2.front() == sum2.back() && sum1.front() == sum2.front();
}

int dp[N] = {0};

int cnt(int banned, int n) {
    fill(dp, dp + N, 0);
    dp[0] = 1;
    for (int j = 1; j <= n; ++j) {
        if (j == banned) continue;
        for (int prev_sum = 0; prev_sum + j <= n; ++prev_sum) {
            dp[prev_sum + j] = (dp[prev_sum] + dp[prev_sum + j]) % MOD;
        }
    }
    return dp[n];
}

void solve() {
    int n, s = 0, answer = 0;
    cin >> n;
    for (int i = 0; ; ++i) {
        s += i;
        if (s > n) break;
        answer = (answer + (i + 1) * cnt(i + 1, n - s)) % MOD;
    }
    cout << answer << '\n';
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}
