#include <bits/stdc++.h>
using namespace std;
 
#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if(false) cerr
#endif
 
typedef long long ll;

int n;
vector<vector<int>> adj;
vector<int> mx_dep, mn_dep, who_mx;
vector<int> dp;

void dfs(int v) {
    mx_dep[v] = 0;
    mn_dep[v] = 1e9;
    who_mx[v] = -1;
    for (int u : adj[v]) {
        dfs(u);
        if (mx_dep[u] + 1 > mx_dep[v]) {
            who_mx[v] = u;
            mx_dep[v] = max(mx_dep[v], mx_dep[u] + 1);
        }
        mn_dep[v] = min(mn_dep[v], mn_dep[u] + 1);
    }
    if (adj[v].empty()) mn_dep[v] = 0;
}


int dfs2(int v, int your_time) {
    if (adj[v].empty()) {
        int to_add = 0;
        if (your_time == 0) {
            to_add = 1;
        }
        return to_add;
    }
    if (your_time != 0) {
        int mx = 0;
        for (int u : adj[v]) {
            mx = max(dfs2(u, your_time - 1), mx);
        }
        return mx;
    }
    int mx = 0;
    for (int u : adj[v]) {
        mx = max(mx, dfs2(u, mn_dep[v] - 1));
    }
    return mx + 1;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> n;
    adj.assign(n, {});
    mx_dep.assign(n, 0);
    mn_dep.assign(n, 0);
    who_mx.assign(n, -1);
    
    for (int i= 1; i < n; ++i) {
        int p;
        cin >> p, --p;
        adj[p].push_back(i);
    }
    dfs(0);
    for (int x : mn_dep) debug << x << ' ';
    debug << endl;
    cout << dfs2(0, mn_dep[0]);
    return 0;
}