#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pp pair<ll,ll>

using namespace std;

template<class T> istream& operator>>(istream& is,vector<T>& arr) { for(auto &i:arr) is>>i; return is;}
template<class T> ostream& operator<<(ostream& os,vector<T>& arr) { for(auto &i:arr) os<<i<<" "; return os;}


signed main()
{
  ios_base::sync_with_stdio(0);
  cin.tie(0);

    int n;
    cin >> n;
    const int maxn = 5005;
    const int mod = 1e9 + 7;
    ll dp[maxn][maxn]{};

    for(int i=0;i<=n;i++) {
        dp[0][i] = 1;
    }

    for(int i=1;i<=n;i++) {
        for(int j=1;j<=n;j++) {
            // j родитель
            dp[i][j] = dp[i][j - 1];
            if (i - 1 >= 0) {
                dp[i][j] += dp[i-1][j-1];
                if(dp[i][j] >= mod) dp[i][j] -= mod;
            }
            if (i - 2 >= 0) {
                dp[i][j] += dp[i-2][j-1];
                if(dp[i][j] >= mod) dp[i][j] -= mod;
            }
        }
    }

    ll ans = 1;

    for(int i=1;i<n;i++) {
        ans = (ans * dp[i + 1][i]) % mod;
    }

    cout << ans << endl;

    return 0;
}
