#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
#define sz(v) (int)v.size()
typedef pair<int, int> pii;

pair<int, int> get(const vector<int>& a) {
    int minind = 0, maxind = 0;
    for (int i = 0; i < a.size(); ++i) {
        if (a[minind] > a[i])
            minind = i;
        if (a[maxind] < a[i])
            maxind = i;
    }
    return {minind, maxind};
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (auto& i : a)
        for (auto& j : i)
            cin >> j;

    vector<int> col(n), str(n);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j) {
            str[i] += a[i][j];
            col[j] += a[i][j];
        }

    auto [xs, ys] = get(str);
    auto [xc, yc] = get(col);

    if (xs == ys) {
        for (int i = 0; i < n; ++i)
            if (a[i][xc] - a[i][yc] == (col[xc] - col[yc]) / 2) {
                cout << i + 1 << " " << xc + 1 << endl;
                cout << i + 1 << " " << yc + 1 << endl;
                return;
            }
    } else if (xc == yc) {
        for (int i = 0; i < n; ++i)
            if (a[xs][i] - a[ys][i] == (str[xs] - str[ys]) / 2) {
                cout << xs + 1 << " " << i + 1 << endl;
                cout << ys + 1 << " " << i + 1 << endl;
                return;
            }
    } else {
        cout << xs + 1 << " " << xc  + 1 << endl;
        cout << ys + 1 << " " << yc  + 1 << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}