#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

void solve() {
    int n;
    cin >> n;

    set<pii> s;

    map<int, vector<int>> cntx, cnty;
    int sumx[2] = {0, 0}, sumy[2] = {0, 0};

    while (n--) {
        int x, y;
        cin >> x >> y;

        if (!s.count({x, y})) {
            s.insert({x, y});

            if (!cntx.count(x))
                cntx[x] = {0ll, 0ll};
            if (!cnty.count(y))
                cnty[y] = {0, 0};

            sumx[x % 2] -= max(cntx[x][0], cntx[x][1]);
            sumy[y % 2] -= max(cnty[y][0], cnty[y][1]);

            ++cntx[x][y % 2];
            ++cnty[y][x % 2];

            sumx[x % 2] += max(cntx[x][0], cntx[x][1]);
            sumy[y % 2] += max(cnty[y][0], cnty[y][1]);
        } else {
            s.erase({x, y});

            sumx[x % 2] -= max(cntx[x][0], cntx[x][1]);
            sumy[y % 2] -= max(cnty[y][0], cnty[y][1]);

            --cntx[x][y % 2];
            --cnty[y][x % 2];

            sumx[x % 2] += max(cntx[x][0], cntx[x][1]);
            sumy[y % 2] += max(cnty[y][0], cnty[y][1]);
        }

        //cout << sumx[0] << " " << sumx[1] << " " << sumy[0] << " " << sumy[1] << endl;

        cout << max(max(sumx[0], sumx[1]), max(sumy[0], sumy[1])) << "\n";
    }
}

signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}