#include <bits/stdc++.h>
using namespace std;

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) a -= MOD;
    return a;
}

int mult(int a, int b) { return (a * 1ll * b) % MOD; }

int binpow(int a, int b) {
    if (!b) return 1;
    int c = binpow(a, b / 2);
    return (b % 2 == 1 ? mult(a, mult(c, c)) : mult(c, c));
}

int divide(int a, int b) { return mult(a, binpow(b, MOD - 2)); }

int main() {
    int n;
    cin >> n;

    int a[n], c[3] = {};

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        c[a[i] % 3]++;
    }

    int ans = 0;

    int fact[n + 2];

    fact[0] = 1;
    for (int i = 1; i <= n; i++) fact[i] = mult(fact[i - 1], i);

    bool b1 = 0;

    if (c[2] && c[1] < 2) b1 = 1;
    if (!(c[1] - c[2] == 1 || c[1] - c[2] == 2)) b1 = 1;

    bool b2 = 0;

    if (c[1] && c[2] < 2) b2 = 2;
    if (!(c[2] - c[1] == 1 || c[2] - c[1] == 2)) b2 = 1;

    if (c[1] && !b1) {
        c[1]--, n--;
        int e = divide(fact[n], fact[c[1] + c[2]]);
        e = mult(e, fact[c[1]]);
        e = mult(e, fact[c[2]]);
        ans = add(ans, mult(e, c[1] + 1));
        c[1]++, n++;
    }

    if (c[2] && !b2) {
        c[2]--, n--;
        int e = divide(fact[n], fact[c[1] + c[2]]);
        e = mult(e, fact[c[1]]);
        e = mult(e, fact[c[2]]);
        ans = add(ans, mult(e, c[2] + 1));
        c[2]++, n++;
    }

    cout << ans;
}
