#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define sz(x) (int)x.size()

using namespace std;
const int N = 1001;
int n, SUM;
int a[N][N], sumc[N], sumr[N];

bool check()
{
    set<int> s;
    for(int i = 0; i < n; i++)
    {
        int sum1 = 0, sum2 = 0;
        for(int j = 0; j < n; j++)
            sum1 += a[i][j], sum2 += a[j][i];
        s.insert(sum1);
        s.insert(sum2);
    }
    return (sz(s) == 1);
}

bool check(int x1, int y1, int x2, int y2)
{
    int sumrx1 = sumr[x1], sumrx2 = sumr[x2],  sumcy1 = sumc[y1], sumcy2 = sumc[y2];
    sumrx1 = sumrx1 - a[x1][y1] + a[x2][y2];
    sumrx2 = sumrx2 + a[x1][y1] - a[x2][y2];
    sumcy1 = sumcy1 - a[x1][y1] + a[x2][y2];
    sumcy2 = sumcy2 + a[x1][y1] - a[x2][y2];
    return (sumrx1 == SUM && sumrx2 == SUM && sumcy1 == SUM && sumcy2 == SUM);
}

int32_t main() {
    cin >> n;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cin >> a[i][j];
    if(n <= 4)
    {
        for(int x1 = 0; x1 < n; x1++)
            for(int y1 = 0; y1 < n; y1++)
                for(int x2 = x1; x2 < n; x2++)
                    for(int y2 = y1; y2 < n; y2++)
                    {
                        swap(a[x1][y1], a[x2][y2]);
                        if(check())
                        {
                            cout << x1 + 1 << " " << y1 + 1 << endl;
                            cout << x2 + 1 << " " << y2 + 1;
                            return 0;
                        }
                        swap(a[x1][y1], a[x2][y2]);
                    }
        return 0;
    }
    map<int, int> cnt;
    for(int i = 0; i < n; i++)
    {
        int sum1 = 0, sum2 = 0;
        for(int j = 0; j < n; j++)
            sum1 += a[i][j], sum2 += a[j][i];
        cnt[sum1]++;
        cnt[sum2]++;
    }
    for(auto i : cnt)
        if(i.y > cnt[SUM])
            SUM = i.x;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            sumr[i] += a[i][j], sumc[i] += a[j][i];
    vector<int> badr, badc;
    for(int i = 0; i < n; i++)
        if(sumr[i] != SUM)
            badr.push_back(i);
    for(int i = 0; i < n; i++)
        if(sumc[i] != SUM)
            badc.push_back(i);
    for(int x1 : badr)
        for(int y1 : badc)
            for(int x2 : badr)
                for(int y2 : badr)
                    if(check(x1, y1, x2, y2))
                    {
                        cout << x1 + 1 << " " << y1 + 1 << endl;
                        cout << x2 + 1 << " " << y2 + 1;
                    }
}
