#include <iostream>
#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define int ll
#define str string
#define vec vector
#define all(x) x.begin(),x.end()

bool is_good(vec<vec<int>> &x) {
    int n = x.size();
    int needsum = accumulate(all(x[0]), 0ll);
    for (auto &i: x) {
        if (accumulate(all(i), 0ll) != needsum)return false;
    }
    for (int i = 0; i < n; ++i) {
        int cursum = 0;
        for (int j = 0; j < n; ++j) {
            cursum += x[j][i];
        }
        if (cursum != needsum)return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vec<vec<int>> x(n, vec<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> x[i][j];
        }
    }
    if (n <= 10) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < n; ++k) {
                    for (int l = 0; l < n; ++l) {
                        if (i != k || j != l) {
                            swap(x[i][j], x[k][l]);
                            if (is_good(x)) {
                                cout << i + 1 << ' ' << j + 1 << '\n';
                                cout << k + 1 << ' ' << l + 1 << '\n';
                                return;
                            }
                            swap(x[i][j], x[k][l]);
                        }
                    }
                }
            }
        }
    }
    vec<int> tryi;
    vec<int> tryj;
    int needsum = 0;
    for (int i = 1; i <= n * n; ++i) {
        needsum += i;
    }
    needsum /= n;
    vec<int> sumsi;
    vec<int> sumsj;
    for (int i = 0; i < n; ++i) {
        sumsi.emplace_back(accumulate(all(x[i]), 0ll));
        if (accumulate(all(x[i]), 0ll) != needsum) {
            tryi.emplace_back(i);
        }
        int cursum = 0;
        for (int j = 0; j < n; ++j) {
            cursum += x[j][i];
        }
        sumsj.emplace_back(cursum);
        if (cursum != needsum) {
            tryj.emplace_back(i);
        }
    }
    for (auto i: tryi) {
        for (auto j: tryj) {
            for (auto k: tryi) {
                for (auto l: tryj) {
                    if (i != k || j != l) {
                        swap(x[i][j], x[k][l]);
                        if (is_good(x)) {
                            cout << i + 1 << ' ' << j + 1 << '\n';
                            cout << k + 1 << ' ' << l + 1 << '\n';
                            return;
                        }
                        swap(x[i][j], x[k][l]);
                    }
                }
            }
        }
    }
    if (tryi.empty()) {
        for (int i = 0; i < n; ++i) {
            for (auto j: tryj) {
                for (auto k: tryj) {
                    if (j != k) {
                        int a = x[i][j];
                        int b = x[i][k];
                        sumsj[j] -= a;
                        sumsj[j] += b;
                        sumsj[k] += a;
                        sumsj[k] -= b;
                        if (sumsj[j] == needsum && sumsj[k] == needsum) {
                            cout << i + 1 << ' ' << j + 1 << '\n';
                            cout << i + 1 << ' ' << k + 1 << '\n';
                            return;
                        }
                        sumsj[j] += a;
                        sumsj[j] -= b;
                        sumsj[k] -= a;
                        sumsj[k] += b;
                    }
                }
            }
        }
    }
    if (tryj.empty()) {
        for (int i = 0; i < n; ++i) {
            for (auto j: tryi) {
                for (auto k: tryi) {
                    if (j != k) {
                        int a = x[j][i];
                        int b = x[k][i];
                        sumsi[j] -= a;
                        sumsi[j] += b;
                        sumsi[k] += a;
                        sumsi[k] -= b;
                        if (sumsi[j] == needsum && sumsi[k] == needsum) {
                            cout << j + 1 << ' ' << i + 1 << '\n';
                            cout << k + 1 << ' ' << i + 1 << '\n';
                            return;
                        }
                        sumsi[j] += a;
                        sumsi[j] -= b;
                        sumsi[k] -= a;
                        sumsi[k] += b;
                    }
                }
            }
        }
    }

}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    solve();
    return 0;
}
