#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
//#define int long long
int mod = 1e9 + 7;

struct Fast {
    vector<ll> f;/*

    ll bp(ll x, int n) {
        if (n == 0) return 1;
        if (n % 2) return x * bp(x, n - 1) % mod;
        ll d = bp(x, n / 2);
        return d * d % mod;
    }

    ll C(int n, int k) {
        if (k > n) return 0;
        return f[n] * bp(f[k], mod - 2) % mod * bp(f[n - k], mod - 2) % mod;
    }*/

    void solve() {
        int n;
        cin >> n;
        f.resize(n + 2, 1);
        for (int i = 2; i <= n; i++) f[i] = f[i - 1] * i % mod;
        vector<vector<int>> C(n + 1, vector<int>(n + 1));
        for (int i = 0; i <= n; i++) C[i][0] = 1;
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                C[i][j] = ((ll) C[i - 1][j] + C[i - 1][j - 1]) % mod;
            }
        }
        ll ans = 1;
        for (int i = 2; i <= n; i++) {
            ll x = 0;
            for (int j = 0; j <= i - 1; j++) {
                if (j > i - 1 || i - 1 - j < i - (i - 1 - j)) continue;
                ll y = C[i - 1][j];
                y *= C[i - 1 - j][i - (i - 1 - j)];
                y %= mod;
                x += y;
                x %= mod;
            }
            ans *= x;
            ans %= mod;
        }
        cout << ans;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}
