#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
#define int long long
int mod = 1e9 + 7;

struct Fast {
    vector<ll> f;/*

    ll bp(ll x, int n) {
        if (n == 0) return 1;
        if (n % 2) return x * bp(x, n - 1) % mod;
        ll d = bp(x, n / 2);
        return d * d % mod;
    }

    ll C(int n, int k) {
        if (k > n) return 0;
        return f[n] * bp(f[k], mod - 2) % mod * bp(f[n - k], mod - 2) % mod;
    }*/

    void solve() {
        ll n;
        cin >> n;
        vector<vector<ll>> a(n, vector<ll>(n));
        ll need = (1 + n * n) * n / 2;
        for (auto &i: a) for (auto &j: i) cin >> j;
        vector<ll> bad_str, bad_st;
        for (int i = 0; i < n; i++) {
            ll sum = 0;
            for (int j = 0; j < n; j++) {
                sum += a[i][j];
            }
            if (sum != need) {
                bad_str.push_back(i);
            }
        }
        for (int j = 0; j < n; j++) {
            ll sum = 0;
            for (int i = 0; i < n; i++) {
                sum += a[i][j];
            }
            if (sum != need) {
                bad_st.push_back(j);
            }
        }
        if (bad_str.empty()){
            ll st1 = bad_st[0];
            ll st2 = bad_st[1];
            for (int i = 0; i < n; i++){
                swap(a[i][st1], a[i][st2]);
                ll sum1 = 0, sum2=  0;
                for (int j = 0; j < n; j++){
                    sum1 += a[j][st1];
                    sum2 += a[j][st2];
                }
                if (sum1 == need && sum2 == need){
                    cout << i + 1 << ' ' << st1 + 1 << '\n' << i + 1 << ' ' << st2 + 1 << '\n';
                    return;
                }
                swap(a[i][st1], a[i][st2]);
            }
        }
        if (bad_st.empty()){
            ll str1 = bad_str[0];
            ll str2 = bad_str[1];
            for (int i = 0; i < n; i++){
                swap(a[str1][i], a[str2][i]);
                ll sum1 = 0, sum2=  0;
                for (int j = 0; j < n; j++){
                    sum1 += a[str1][j];
                    sum2 += a[str2][j];
                }
                if (sum1 == need && sum2 == need){
                    cout << str1 + 1 << ' ' << i + 1 << '\n' << str2 + 1 << ' ' << i + 1 << '\n';
                    return;
                }
                swap(a[str1][i], a[str2][i]);
            }
        }
        for (auto str1: bad_str) {
            for (auto str2: bad_str) {
                for (auto st1: bad_st) {
                    for (auto st2: bad_st) {
                        swap(a[str1][st1], a[str2][st2]);
                        bool ok = true;
                        for (int i = 0; i < n; i++) {
                            ll sum = 0;
                            for (int j = 0; j < n; j++) {
                                sum += a[i][j];
                            }
                            if (sum != need) {
                                ok = false;
                                break;
                            }
                        }
                        if (ok) {
                            for (int j = 0; j < n; j++) {
                                ll sum = 0;
                                for (int i = 0; i < n; i++) {
                                    sum += a[i][j];
                                }
                                if (sum != need) {
                                    ok = false;
                                    break;
                                }
                            }
                        }
                        if (ok) {
                            cout << str1 + 1 << ' ' << st1 + 1 << '\n' << str2 + 1 << ' ' << st2 + 1 << '\n';
                            return;
                        }
                        swap(a[str1][st1], a[str2][st2]);
                    }
                }
            }
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}
