#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
#define int long long
int mod = 1e9 + 7;


struct Fast {
    vector<ll> f;

    int mul(int a, int b) {
        return 1ll * a * b % mod;
    }

    int add(int a, int b) {
        return (a + b < mod ? a + b : a + b - mod);
    }

    int sub(int a, int b) {
        return (a - b < 0 ? a - b + mod : a - b);
    }

    int binP(int a, ll n) {
       if (n == 0) return 1;
       if (n % 2) return mul(a, binP(a, n - 1));
       return binP(mul(a, a), n / 2);
    }

    int c(int n, int k){
        return mul(f[n], binP(mul(f[k], f[n - k]), mod - 2));
    }

    void solve() {
        ll n;
        cin >> n;
        vector<ll> a(n);
        ll c1 = 0, c2 = 0, c0 = 0;
        for (auto &it: a) {
            cin >> it;
            c1 += it % 3 == 1;
            c2 += it % 3 == 2;
            c0 += it % 3 == 0;
        }
        if (abs(c1 - c2) > 2 || c1 == c2) {
            cout << 0;
            return;
        }
        f.resize(n + 1, 1);
        for (ll i = 1; i <= n; i++) {
            f[i] = mul(f[i - 1], i);
        }
        int r1 = mul(f[c1], f[c2]);
        int cc = c(n - 1, c0);
        cout << mul(r1, mul(f[c0], cc));
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}
