#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9;

#define int long long
#define pi pair<int, int>
int cnt[10][10];

void solveF() {
    int n;
    cin >> n;
    vector<vector<ll>> a(n, vector<ll>(n));
    vector<ll> b(n), c(n);
    ll s = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            b[i] += a[i][j];
            c[j] += a[i][j];
            s += a[i][j];
        }
    }
    ll ss = s / n;
    ll i1 = -1, i2 = -1;
    for (int i = 0; i < n; i++) {
        if (b[i] != ss) {
            if (i1 == -1) {
                i1 = i;
            } else {
                i2 = i;
            }
        }
    }
    ll j1 = -1, j2 = -1;
    for (int i = 0; i < n; i++) {
        if (c[i] != ss) {
            if (j1 == -1) {
                j1 = i;
            } else {
                j2 = i;
            }
        }
    }
    if (i2 != -1) {
        for (int J1 = 0; J1 < n; J1++) {
            for (int J2 = 0; J2 < n; J2++) {
                b[i1] -= a[i1][J1];
                c[J1] -= a[i1][J1];
                b[i2] -= a[i2][J2];
                c[J2] -= a[i2][J2];

                b[i2] += a[i1][J1];
                c[J2] += a[i1][J1];
                b[i1] += a[i2][J2];
                c[J1] += a[i2][J2];
                if (b[i1] != ss || b[i2] != ss || c[J1] != ss || c[J2] != ss) {

                    b[i1] += a[i1][J1];
                    c[J1] += a[i1][J1];
                    b[i2] += a[i2][J2];
                    c[J2] += a[i2][J2];

                    b[i2] -= a[i1][J1];
                    c[J2] -= a[i1][J1];
                    b[i1] -= a[i2][J2];
                    c[J1] -= a[i2][J2];
                } else {
                    cout << i1 + 1 << " " << J1 + 1 << '\n';
                    cout << i2 + 1 << " " << J2 + 1 << '\n';
                    return;
                }
            }
        }
    } else {
        for (int I1 = 0; I1 < n; I1++) {
            for (int I2 = 0; I2 < n; I2++) {
                b[I1] -= a[I1][j1];
                c[j1] -= a[I1][j1];
                b[I2] -= a[I2][j2];
                c[j2] -= a[I2][j2];

                b[I2] += a[I1][j1];
                c[j2] += a[I1][j1];
                b[I1] += a[I2][j2];
                c[j1] += a[I2][j2];
                if (b[I1] != ss || b[I2] != ss || c[j1] != ss || c[j2] != ss) {

                    b[I1] += a[I1][j1];
                    c[j1] += a[I1][j1];
                    b[I2] += a[I2][j2];
                    c[j2] += a[I2][j2];

                    b[I2] -= a[I1][j1];
                    c[j2] -= a[I1][j1];
                    b[I1] -= a[I2][j2];
                    c[j1] -= a[I2][j2];
                } else {
                    cout << I1 + 1 << " " << j1 + 1 << '\n';
                    cout << I2 + 1 << " " << j2 + 1 << '\n';
                    return;
                }
            }
        }
    }

}

void solveI() {
    set<pi > st;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (st.count({x, y})) {
            st.erase({x, y});
            cnt[x & 1][y & 1]--;
        } else {
            st.insert({x, y});
            cnt[x & 1][y & 1]++;
        }
        cout << max(max(cnt[0][1], cnt[0][0]), max(cnt[1][0], cnt[1][1])) << "\n";
    }
}
const int N = 1e6+9;
struct node {
    int sum, pref, suff, ans, sz;
};
node combine(node a, node b) {
    node c;
    c.sum = a.sum + b.sum;
    c.sz = a.sz + b.sz;
    c.pref = a.sum == a.sz ? a.sum + b.pref : a.pref;
    c.suff = b.sum == b.sz ? b.sum + a.suff : b.suff;
    c.ans = max(max(a.ans, b.ans), a.suff + b.pref);
    return c;
}
node d[N];
void make(int lx, int rx, int v, int pos, char c) {
    if (rx - lx == 1) {
        if (c == 'a') d[v] = {0, 0, 0, 0, 1};
        else d[v] = {1, 1, 1, 1, 1};
        return;
    }
    int m = (lx + rx) / 2;
    if (pos < m) make(lx, m, 2 * v + 1, pos, c);
    else make(m, rx, 2 * v + 2, pos, c);
    d[v] = combine(d[2 * v + 1], d[2 * v + 2]);
}
node Z = {0, 0, 0, 0, 0};
node get(int lx, int rx, int v, int l, int r) {
    if (l >= rx || lx >= r) return Z;
    if (l <= lx && rx <= r) return d[v];
    int m = (lx + rx) / 2;
    return combine(get(lx, m, 2 * v + 1, l, r), get(m, rx, 2 * v + 2, l, r));
}
void solveL() {
    int n;
    string s;
    cin >> n >> s;
    int q;
    cin >> q;
    int kol = 1;
    while (kol < n) kol *= 2;
    for (int i = kol - 1; i < kol - 1 + n; i++) {
        if (s[i - kol + 1] == 'a') d[i] = {0, 0, 0, 0, 1};
        else d[i] = {1, 1, 1, 1, 1};
    }
    for (int i = kol - 1 + n; i < 2 * kol - 1; i++) d[i] = {0, 0, 0, 0, 0};
    for (int i = kol - 2; i > -1; i--) d[i] = combine(d[2 * i + 1], d[2 * i + 2]);
    for (int o = 0; o < q; o++) {
        int t;
        cin >> t;
        if (t == 1) {
            int pos;
            cin >> pos;
            pos--;
            s[pos] = s[pos] == 'a' ? 'b' : 'a';
            make(0, kol, 0, pos, s[pos]);
        } else {
            int l, r;
            cin >> l >> r;
            l--;
            if (r - l == 1) {
                cout << (s[l] == 'a' ? "YES\n" : "NO\n");
                continue;
            } else {
                if (s[l] == 'b' && s[l + 1] == 'b') {
                    cout << "NO\n";
                    continue;
                }
                if (s[r - 2] == 'b' && s[r - 1] == 'b') {
                    cout << "NO\n";
                    continue;
                }
            }
            node res = get(0, kol, 0, l, r);
            if (res.sum > r - l - res.sum || res.ans >= 3) {
                cout << "NO\n";
                continue;
            }
            cout << "YES\n";
        }
    }
}
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solveL();
    }


    return 0;
}
