#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9;

#define int long long
#define pi pair<int, int>

int R = (1 << 17);

vector<int> db(R * 2);

void st(int v, int l, int r, int i) {
    if (l == i && l + 1 == r) {
        db[v] = (db[v] + 1) % 2;
        return;
    }
    if (i < l || i >= r) {
        return;
    }
    st(v * 2, l, (r + l) / 2, i);
    st(v * 2 + 1, (r + l) / 2, r, i);
    db[v] = db[v * 2] + db[v * 2 + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return db[v];
    }
    if (r <= ql || l >= qr) {
        return 0;
    }
    return get(v * 2, l, (r + l) / 2, ql, qr) + get(v * 2 + 1, (r + l) / 2, r, ql, qr);
}

vector<bool> ds(R * 2);

bool get2(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return ds[v];
    }
    if (r <= ql || l >= qr) {
        return true;
    }
    return get2(v * 2, l, (r + l) / 2, ql, qr) && get2(v * 2 + 1, (r + l) / 2, r, ql, qr);
}

void st2(int v, int l, int r, int i, bool val) {
    if (l == i && l + 1 == r) {
        ds[v] = val;
        return;
    }
    if (i < l || i >= r) {
        return;
    }
    st2(v * 2, l, (r + l) / 2, i, val);
    st2(v * 2 + 1, (r + l) / 2, r, i, val);
    ds[v] = ds[v * 2] && ds[v * 2 + 1];
}


set<pair<pair<int, int>, bool>> sl, sr;

void add(int l, int r, bool ans) {
    sl.insert({{l, r}, ans});
    st2(1, 0, R, l, ans);
}

void del(int l, int r, bool ans) {
    sl.erase({{l, r}, ans});
    st2(1, 0, R, l, true);
}

void solveL() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        if (s[i] == 'b') {
            st(1, 0, R, i);
        }
    }
//    vector<pair<int> aaa;
    int l = 0;
    for (int i = 1; i <= n; i++) {
        if (i == n) {
            int r = i - 1;
            int k = (r - l + 1);
            int kb = get(1, 0, R, l, r + 1);
            int ka = k - kb;
            add(l, r, ka >= kb);
            l = i;
        } else if (s[i] == 'b' && s[i - 1] == 'b') {
            int r = i - 1;
            int k = (r - l + 1);
            int kb = get(1, 0, R, l, r + 1);
            int ka = k - kb;
            add(l, r, ka >= kb);
            l = i;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int I;
            cin >> I;
            I--;
            auto x = sl.lower_bound({{I + 1, -1}, 0});
            x--;
            auto x1 = *x;
            int l = x1.first.first;
            int r = x1.first.second;
            vector<vector<int>> tod = {{x1.first.first, x1.first.second, x1.second}};
//            del(x1.first.first, x1.first.second, x1.second);
            if (x1.first.first == I && I > 0) {
                x--;
                auto x2 = *x;
                l = x2.first.first;
                tod.push_back({x2.first.first, x2.first.second, x2.second});
//                del();
                x++;
            }
            if (x1.first.second == I && I + 1 < n) {
                x++;
                auto x2 = *x;
                r = x2.first.second;
                tod.push_back({x2.first.first, x2.first.second, x2.second});
                x--;
            }
            for (auto xxx: tod) {
                del(xxx[0], xxx[1], xxx[2]);
            }
            set<int> aaa;
            if (I > 0) {
                aaa.insert(I);
            }
            if (I + 1 < n) {
                aaa.insert(I + 1);
            }
            aaa.insert(r + 1);
            st(1, 0, R, I);
            if (s[I] == 'a') {
                s[I] = 'b';
            } else {
                s[I] = 'a';
            }
            for (int i: aaa) {
                if (i == r + 1) {
                    int r1 = i - 1;
                    int k = (r1 - l + 1);
                    int kb = get(1, 0, R, l, r1 + 1);
                    int ka = k - kb;
                    add(l, r1, ka >= kb);
                    l = i;
                } else if (s[i] == 'b' && s[i - 1] == 'b') {
                    int r1 = i - 1;
                    int k = (r1 - l + 1);
                    int kb = get(1, 0, R, l, r1 + 1);
                    int ka = k - kb;
                    add(l, r1, ka >= kb);
                    l = i;
                }
            }


        } else {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            auto x1 = sl.lower_bound({{l + 1, -1}, 0});
            x1--;
            int l1, r1;
            if (x1->first.first == l) {
                l1 = l;
            } else {
                l1 = x1->first.second + 1;
            }
            auto x2 = sl.lower_bound({{r, -1}, 0});
            while (x2->first.first > r) {
                x2--;
            }
            if (x2->first.second > r) {
                if (x2 == sl.begin()) {
                    r1 = -1;
                } else {
                    r1 = x2->first.first - 1;
                }
            } else {
                r1 = x2->first.second;
            }
//            r1 = x2->first.second;
            bool ok = get2(1, 0, R, l1, r1 + 1);
            int k1 = l1 - l;
            int kb1 = get(1, 0, R, l, l1);
            if (kb1 > (k1 - kb1)) {
                ok = false;
            }
            k1 = r - r1;
            kb1 = get(1, 0, R, r + 1, r1 + 1);
            if (kb1 > (k1 - kb1)) {
                ok = false;
            }
            if (ok) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
}

#define pb push_back
#define fi first
#define se second
const int N = 1e6 + 9;
int x[N], y[N];
vector<int> vec[N];

void solveJ() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vec[a].pb(b);
        vec[b].pb(a);
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solveL();
    }


    return 0;
}
