#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int maxn = 5005, mod = 1'000'000'007;

int c[maxn][maxn];

void pre_calc() {
    for (int i = 0; i < maxn; ++i) {
        for (int j = 0; j <= i; ++j) {
            if (j == 0 || i == j) c[i][j] = 1;
            else c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % mod;
        }
    }
}

void solve () {
    pre_calc();
    int n; cin >> n;
    int ans = 1;
    for (int l = 1; l < n; ++l) {
        int cnt = 0;
        for (int i = 0; i < (l + 1) / 2; ++i) {
            cnt = (cnt + c[l][i] * c[l - i][i + 1]) % mod;
        }
        ans = ans * cnt % mod;
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}