#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int maxn = 1'000'000, mod = 1'000'000'007;

int binpow(int a, int b) {
    int ans = 1, e = a;
    while (b > 0) {
        if (b & 1) ans = ans * e % mod;
        b >>= 1; e = e * e % mod;
    }
    return ans;
}

int inv(int x) { return binpow(x, mod - 2); }

int fact[maxn], infact[maxn];

void pre_calc() {
    fact[0] = infact[0] = 1;
    for (int i = 1; i < maxn; ++i) {
        fact[i] = fact[i - 1] * i % mod;
        infact[i] = infact[i - 1] * inv(i) % mod;
    }
}

int c(int n, int k) {
    return fact[n] * infact[k] % mod * infact[n - k] % mod;
}

void solve () {
    int n; cin >> n; pre_calc();
    int kz = 0, ko = 0, kt = 0;
    for (int i = 0; i < n; ++i) {
        int x; cin >> x;
        if (x % 3 == 0) kz++;
        else if (x % 3 == 1) ko++;
        else kt++;
    }
    if (kt == ko || abs(kt - ko) >= 3) {
        cout << 0;
        return;
    }
    cout << c(n - 1, kz) * fact[kt] % mod * fact[ko] % mod * fact[kz] % mod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}