#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int mod = 1'000'000'007;

void solve () {
    int n;
    cin >> n;
    map<pair<int, int>, int> mp;

    vector<vector<int>> cnt(2, vector<int>(2, 0));

    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (mp[{x, y}]) {
            cnt[x & 1][y & 1]--;
            mp[{x, y}]--;
        } else {
            cnt[x & 1][y & 1]++;
            mp[{x, y}]++;
        }

        cout << max({cnt[0][0], cnt[0][1], cnt[1][0], cnt[1][1]}) << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}