#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

int ask (int i, string u) {
    cout << "? " << i + 1 << " " << u << endl;
    int res;
    cin >> res;
    return res;
}

void solve () {
    int n;
    cin >> n;
    if (n == 0) {
        exit(0);
    }
    int k = (n / 3) * 3;
    string ans(n, '?');
    for (int i = 0; i < k; i += 3) {
        int A = ask(i, "aa");
        int B = ask(i, "ba");
        int C = ask(i + 1, "ba");
        int D = ask(i + 1, "bb");

        // first

        if (A == B) {
            ans[i] = 'c';
        } else if (A > B) {
            ans[i] = 'a';
        } else {
            ans[i] = 'b';
        }

        // third

        if (C == D) {
            ans[i + 2] = 'c';
        } else if (C > D) {
            ans[i + 2] = 'a';
        } else {
            ans[i + 2] = 'b';
        }

        int E = min(A, B);
        int F = min(C, D);

        if (E == F) {
            ans[i + 1] = 'c';
        } else if (E > F) {
            ans[i + 1] = 'a';
        } else {
            ans[i + 1] = 'b';
        }
    }

    if (n % 3 == 1) {
        int last = n - 2;
        string z = string(1, ans[last]);
        int A = ask(last, z + 'a');
        int B = ask(last, z + 'b');
        if (A == B) {
            ans[last + 1] = 'c';
        } else if (A > B) {
            ans[last + 1] = 'a';
        } else {
            ans[last + 1] = 'b';
        }
    } else if (n % 3 == 2) {
        int last = n - 2;
        int A = ask(last, "aa");
        int B = ask(last, "bb");
        if (A == 2) {
            ans[last] = ans[last + 1] = 'a';
        } else if (B == 2) {
            ans[last] = ans[last + 1] = 'b';
        } else if (A == 0 && B == 0) {
            ans[last] = ans[last + 1] = 'c';
        } else {
            if (A == 0) {
                // нету a
                int C = ask(last, "ba");
                if (C == 0) {
                    ans[last] = 'c';
                    ans[last + 1] = 'b';
                } else {
                    ans[last] = 'b';
                    ans[last + 1] = 'c';
                }
            } else if (B == 0) {
                // нету b
                int C = ask(last, "ab");
                if (C == 0) {
                    ans[last] = 'c';
                    ans[last + 1] = 'a';
                } else {
                    ans[last] = 'a';
                    ans[last + 1] = 'c';
                }
            } else {
                // нету c
                int C = ask(last, "ac");
                if (C == 0) {
                    ans[last] = 'b';
                    ans[last + 1] = 'a';
                } else {
                    ans[last] = 'a';
                    ans[last + 1] = 'b';
                }
            }
        }
    }

    cout << "! " << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
//    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (true) {
        solve();
    }

    return 0;
}