#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using vi = vector<ll>;

const int N = 1005;
ll a[N][N];
ll p[N];
ll v[N];
void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
		cin >> a[i][j];
	}
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)p[i] += a[i][j];
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)v[i] += a[j][i];
	ll s = n * (n * n + 1) / 2;
	vector<ll> pos, posv;
	for (int i = 0; i < n; ++i) {
		if (p[i] != s) {
			pos.push_back(i);
		}
		if (v[i] != s) {
			posv.push_back(i);
		}
	}
	if (pos.empty() && posv.empty()) {
		cout << "1 1\n1 1\n";
		return;
	}
	if (!pos.empty()) {
		int x = pos[0], y = pos[1];
		for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
			if (p[x] - a[x][i] + a[y][j] == s && p[y] - a[y][j] + a[x][i] == s) {
				cout << x + 1 << ' ' << i + 1 << '\n' << y + 1 << ' ' << j + 1 << '\n';
				return;
			}
		}
	}
	else {
		int x = posv[0], y = posv[1];
		for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
			if (v[x] - a[i][x] + a[j][y] == s && v[y] + a[i][x] - a[j][y] == s) {
				cout << i + 1 << ' ' << x + 1 << '\n' << j + 1 << ' ' << y + 1 << '\n';
				return;
			}
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

}