#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll

#define vc vector

const int N = 1 << 17;
string s;

struct node {
    char x, y = 'r';
    bool can[2][2]{};
    bool tmp;
};
node t[N * 2];

node merge(node a, node b) {
    if (a.y == 'r') return b;
    if (b.y == 'r') return a;
    node ans;
    ans.x = a.x, ans.y = b.y;
    for (int x = 0; x < 2; ++x) {
        for (int y = 0; y < 2; ++y) {
            ans.can[x][y] |= a.can[x][0] && b.can[0][y];
            if (a.y != b.x) ans.can[x][y] |= a.can[x][1] && b.can[1][y];
        }
    }
    return ans;
}

void build(int l = 0, int r = N - 1, int v = 1) {
    if (l == r) {
        t[v].x = t[v].y = s[l];
        t[v].can[0][0] = s[l] == 'a';
        t[v].can[0][1] = t[v].can[1][0] = true;
        return;
    }
    int mid = (l + r) / 2;
    build(l, mid, v * 2);
    build(mid + 1, r, v * 2 + 1);
    t[v] = merge(t[v * 2], t[v * 2 + 1]);
}

void ch(int i, int l = 0, int r = N - 1, int v = 1) {
    if (l == r) {
        t[v].x = t[v].y = s[l];
        t[v].can[0][0] = s[l] == 'a';
        t[v].can[0][1] = t[v].can[1][0] = true;
        return;
    }
    int mid = (l + r) / 2;
    if (i <= mid) ch(i, l, mid, v * 2);
    else ch(i, mid + 1, r, v * 2 + 1);
    t[v] = merge(t[v * 2], t[v * 2 + 1]);
}

node get(int l_, int r_, int l = 0, int r = N - 1, int v = 1) {
    if (l_ <= l && r <= r_) return t[v];
    if (r_ < l || r < l_) return node();
    int mid = (l + r) / 2;
    return merge(
            get(l_, r_, l, mid, v * 2),
            get(l_, r_, mid + 1, r, v * 2 + 1)
    );
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int _;
    cin >> _;
    cin >> s;
    for (int i = 0; i < N; ++i) s.push_back('a');
    build();
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            cout << vc<string>{"NO\n", "YES\n"}[get(l - 1, r - 1).can[0][0]];
        } else {
            int i;
            cin >> i;
            --i;
            if (s[i] == 'a') s[i] = 'b';
            else s[i] = 'a';
            ch(i);
        }
    }
}