#include <bits/stdc++.h>

using i64 = long long;

i64 power(i64 x, i64 st) {
    if (!st) {
        return 1LL;
    }
    i64 y = power(x, st / 2);
    y *= y;
    if (st % 2) {
        y *= x;
    }
    return y;
}

void solve() {
    int k;
    std::cin >> k;
    auto ask = [&](i64 d) {
        std::cout << "? " << d << std::endl;
        int x;
        std::cin >> x;
        return x;
    };
    constexpr int K = 41;
    i64 low = 0, high = 1LL << K;
    while (high - low > 1) {
        i64 mid = (low + high) / 2;
        int p = ask(mid);
        if (p == k) {
            low = mid;
        } else {
            high = mid;
        }
    }
    i64 d1 = high;
    low = 0, high = 1LL << (K + 10);
    while (high - low > 1) {
        i64 mid = (low + high) / 2;
        int p = ask(d1 + mid);
        if (p == k + 1) {
            low = mid;
        } else {
            high = mid;
        }
    }
    i64 d2 = high;
    int B = -1;
    for (int b = 2; b <= 2023; b++) {
        if (power(b, k) * (b - 1) == d2) {
            B = b;
            break;
        }
    }
    std::cout << "! " << power(B, k + 1) - d1 - d2 << " " << B << "\n";
}

signed main() {
    solve();
}
