#include <bits/stdc++.h>

using i64 = long long;

#define pb push_back
#define int long long

const int mod = 1000000007;

using namespace std;

int bin_pow(int x, int st){
    if(st == 0){
        return 1;
    }
    if(st % 2 == 0){
        int h = bin_pow(x, st/2);
        return (h*h)%mod;
    }
    else{
        int h = bin_pow(x, st-1);
        return (h*x)%mod;
    }
}

void solve() {
    vector<int>fact{1};
    for(int i=1; i<=100010; i++){
        fact.pb((fact[i-1]*i)%mod);
    }

    int n;
    cin >> n;
    vector<int>a(n);
    int k0=0, k1=0, k2=0;
    for(int i=0; i<n; i++){
        cin >> a[i];
        if(a[i]%3 == 0){
            k0++;
        }
        else if(a[i]%3 == 1){
            k1++;
        }
        else{
            k2++;
        }
    }

    if(abs(k1-k2)>2){
        cout << 0;
        return;
    }

    int ans = (fact[k1]*fact[k2])%mod;
    for(int i=k1+k2; i<=n-1; i++){
        ans *= i;
        ans %= mod;
    }

    map<int, int>cnt_a;
    for(int i=0; i<n; i++){
        cnt_a[a[i]]++;
    }

    for(auto [x, cnt]:cnt_a){
        ans *= bin_pow(fact[cnt], mod-2);
        ans %= mod;
    }
    cout << ans;
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
