#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int binpow(int a, int b) {
    if (b == 0)
        return 1;
    int c = binpow(a, b / 2);
    c = c * c % mod;
    if (b % 2 == 1)
        c = c * a % mod;
    return c;
}

int findd(int b, int x) {
    int au = 1;
    for (int i = 0; i < x - 1; ++i) {
        au *= b;
    }
    int au2 = 1;
    for (int i = 0; i < x; ++i) {
        au2 *= b;
    }
    return au2 - au;
}

int findxuy(int b, int k) {
    int au = 1;
    for (int i = 0; i < k; ++i) au *= b;
    return au;
}

void solve() {
    // cout << findd(2, 3) << ' ' << findd(2, 1) << endl;
    int n;
    cin >> n;
    int t = 0;
    for (int i = 59; i >= 0; --i) {
        cout << "? " << (t + (1ll << i)) << endl;
        int tt;
        cin >> tt;
        if (tt == n) t += (1ll << i);
    }
    int l = 0, r = 2023;

    while (r - l > 1) {
        int m = (l + r) / 2;
        cout << "? " << (t + 1 + findd(m, n + 1)) << endl;
        int au;
        cin >> au;
        if (au >= n + 2) {
            r = m;
        }
        else l = m;
    }
    cout << "! " <<  findxuy(r, n) - t - 1 << ' ' << r << endl;

}

signed main() {

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}