#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

vector<int> s(vector<pair<int, int>> upd) {
    set<pair<int, int>> used;
    map<int, pair<int, int>> mp;
    vector<int> res;
    int ch = 0, nc = 0;
    for (int i = 0; i < upd.size(); ++i) {
        if (!used.count(upd[i])) {
            if (upd[i].first % 2 == 1) {
                if (upd[i].second % 2 == 1) {
                    if (mp[upd[i].first].second >= mp[upd[i].first].first)
                        ++nc;
                    ++mp[upd[i].first].second;
                } else {
                    if (mp[upd[i].first].second <= mp[upd[i].first].first)
                        ++nc;
                    ++mp[upd[i].first].first;
                }
            } else {
                if (upd[i].second % 2 == 1) {
                    if (mp[upd[i].first].second >= mp[upd[i].first].first)
                        ++ch;
                    ++mp[upd[i].first].second;
                } else {
                    if (mp[upd[i].first].second <= mp[upd[i].first].first)
                        ++ch;
                    ++mp[upd[i].first].first;
                }
            }
            used.insert(upd[i]);
        } else {
            if (upd[i].first % 2 == 1) {
                if (upd[i].second % 2 == 1) {
                    if (mp[upd[i].first].second > mp[upd[i].first].first)
                        --nc;
                    --mp[upd[i].first].second;
                } else {
                    if (mp[upd[i].first].second < mp[upd[i].first].first)
                        --nc;
                    --mp[upd[i].first].first;
                }
            } else {
                if (upd[i].second % 2 == 1) {
                    if (mp[upd[i].first].second > mp[upd[i].first].first)
                        --ch;
                    --mp[upd[i].first].second;
                } else {
                    if (mp[upd[i].first].second < mp[upd[i].first].first)
                        --ch;
                    --mp[upd[i].first].first;
                }
            }
            used.erase(upd[i]);
        }
        res.push_back(max(ch, nc));
    }
    return res;
}

void solve() {
    int q;
    cin >> q;
    vector<pair<int, int>> a1, a2;
    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        a1.push_back({x, y});
        a2.push_back({y, x});
    }
    auto r1 = s(a1), r2 = s(a2);
    for (int i = 0; i < q; ++i)
        cout << max(r1[i], r2[i]) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}