#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
//#ifdef LOCAL
//    freopen("input.txt","r",stdin);
//#endif
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

const ll MOD = 1e9 + 7;
ll ans[5010];
ll fact[5010];

ll h[100];

ll bin_pow(ll n, ll pow) {
    h[0] = 1;
    h[1] = n;
    for (ll i = 2; i <= 30; i++) {
        h[i] = (h[i - 1] * h[i - 1]) % MOD;
    }
    ll an = 1;
    ll i = 1;
    while (pow) {
        if (pow & 1) {
            an *= h[i];
            an %= MOD;
        }
        pow /= 2;
        i++;
    }
    return an;
}

ll devision(ll n, ll k) {
    return (n * bin_pow(k, MOD - 2)) % MOD;
}


void count_fact() {
    fact[0] = 1;
    for (ll i = 1; i < 5010; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
    }
}

ll C(ll n, ll k) {
    if (k == 0 || k == n) {
        return 1;
    }
    if (k < 0 || k > n || n < 0) {
        return 0;
    }
    return devision(devision(fact[n], fact[k]), fact[n - k]);
}

void solve() {
    ll n, m, k, l, r, i, j;
    cin >> n;
    count_fact();
    ans[0] = 1;
    ans[1] = 1;
    for (i = 2; i < n; i++) {
        ans[i] = 0;
        for (j = 0; j <= (i + 1) / 2; j++) {
            k = i + 1 - 2 * j;
            ans[i] += (C(i, k) * C(i - k, j)) % MOD;
        }
        ans[i] %= MOD;
        ans[i] *= ans[i - 1];
        ans[i] %= MOD;
    }
    cout << ans[n - 1];
}
