#include <bits/stdc++.h>
 
using namespace std;
 
const int N = 2e5 + 7;
vector <int> g[N];
map <pair <int, int>, int> ans;
 
int get_ans(int v, int u) {
    if (ans.find({v, u}) != ans.end()) {
        return ans[{v, u}];
    }

    int cur_ans = 1;
    for (int vv : g[v]) {
        if (g[vv].empty()) {
            continue;
        }
        for (int uu : g[u]) {
            if (g[uu].empty()) {
                cur_ans = max(cur_ans, 1 + get_ans(vv, vv));
            } else {
                cur_ans = max(cur_ans, get_ans(vv, uu));
            }
        }
    }
    ans[{v, u}] = cur_ans;
    return cur_ans;
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    cout << get_ans(1, 1) << '\n';
    return 0;
}