#include <bits/stdc++.h>
 
using namespace std;
 
const int N = 2e5 + 7;
int tin[N];
int dp[N];
vector <int> g[N];
vector <pair <int, int>> on_depth[N]; // <dp, tin>
int last_l[N];
int last_r[N];
int mem[N];
int T = 0;
 
int get_max(int d, int tin_thresh) {
    auto &layer = on_depth[d];
    if (last_r[d] == (int) layer.size() && (last_l[d] == 0 || layer[last_l[d] - 1].second < tin_thresh)) {
        return mem[d];
    }
    int ans = 0;
    int uk = layer.size() - 1;
    while (uk >= 0 && layer[uk].second >= tin_thresh) {
        ans = max(ans, layer[uk--].first);
    }
    last_r[d] = layer.size();
    last_l[d] = uk + 1;
    mem[d] = ans;
    return ans;
}
 
int dfs(int v, int d = 0) {
    dp[v] = 0;
    tin[v] = T++;
    
    if (g[v].empty()) {
        on_depth[d].emplace_back(0, tin[v]);
        return d;
    }
 
    int min_leaf_depth = -1;
    for (int u : g[v]) {
        int rec_min_leaf_depth = dfs(u, d + 1);
        if (min_leaf_depth == -1 || rec_min_leaf_depth < min_leaf_depth) {
            min_leaf_depth = rec_min_leaf_depth;
        }
    }

    dp[v] = 1 + get_max(min_leaf_depth, tin[v]);
    on_depth[d].emplace_back(dp[v], tin[v]);
    return min_leaf_depth;
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
        last_l[i + 1] = last_r[i + 1] = -1;
    }
    dfs(1);
    cout << dp[1] << '\n';
    return 0;
}