#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

ll MOD = 1e9 + 7;
vector < ll > F(5002);

ll calc(ll n, ll a, ll b, ll c) {
    return (F[n] / ((((F[a] * F[b]) % MOD)* F[c]) % MOD)) % MOD;
}

ll C(ll n) {
    ll ans = 0;
    for(int i = 0; i * 2 <= 1 + n; i++) {
        ll two = i, one = n - two * 2;
        if(one < 0) {
            continue;
        }
        if(one + two * 2 != n) {
            continue;
        }
        ll zero = n - 1 - one - two;
        if(zero < 0) {
            continue;
        }
        ans = (ans + calc(n - 1, one, two, zero)) % MOD;
    }
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    F[0] = F[1] = 1;
    for(int i = 2;i < F.size();i++){
        F[i] = (i * F[i - 1]) % MOD;
    }
    ll n, res = 1;
    cin >> n;
    for(int i = 1; i <= n; i++) {
        res = (res * C(i)) % MOD;
        if(res < 0) {
            res += MOD;
        }
        if(!res) res = 1;
    }
    cout << res;
    return 0;
}
