#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

const int maxn = 1000 + 5;
const int mod = 1e9 + 7;

int n, sms[maxn], sms2[maxn], a[maxn][maxn];

bool check(int p1, int r1, int p2, int r2) {
    int temp = a[p1][r1];
    a[p1][r1] = a[p2][r2];
    a[p2][r2] = temp;
    set<int> sums;
    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            sum += a[i][j];
        }
        sums.insert(sum);
    }
    int kek[n + 2];
    for (int i = 1; i <= n; i++) {
        kek[i] = 0;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            kek[j] += a[i][j];
        }
    }
    for (int i = 1; i <= n; i++) {
        sums.insert(kek[i]);
    }
    temp = a[p1][r1];
    a[p1][r1] = a[p2][r2];
    a[p2][r2] = temp;
    if (sums.size() == 1) {
        return 1;
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
        }
    }
    if (n == 3) {
        for (int p1 = 1; p1 <= n; p1++) {
            for (int r1 = 1; r1 <= n; r1++) {
                for (int p2 = 1; p2 <= n; p2++) {
                    for (int r2 = 1; r2 <= n; r2++) {
                        if (p1 == p2 && r1 == r2) continue;
                        if (check(p1, r1, p2, r2)) {
                            cout << p1 << ' ' << r1 << '\n';
                            cout << p2 << ' ' << r2 << '\n';
                            return 0;
                        }
                    }
                }
            }
        }
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
           sms[j] += a[i][j];
        }
    }
    map <int, int> mp, mpp;
    for (int i = 1; i <= n; i++) {
        mp[sms[i]]++;
        mpp[sms[i]] = i;
    }
    int pos1 = -1, pos2 = -1;
    for (auto [x, y] : mp) {
        if (y == 1) {
            if (pos1 == -1) {
                pos1 = mpp[x];
            }
            else {
                pos2 = mpp[x];
            }
        }
    }
    if (pos2 == -1) pos2 = pos1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            sms2[i] += a[i][j];
        }
    }
    map <int, int> mp2, mpp2;
    for (int i = 1; i <= n; i++) {
        mp2[sms2[i]]++;
        mpp2[sms2[i]] = i;
    }
    int pos12 = -1, pos22 = -1;
    for (auto [x, y] : mp2) {
        if (y == 1) {
            if (pos12 == -1) {
                pos12 = mpp2[x];
            }
            else {
                pos22 = mpp2[x];
            }
        }
    }
    if (pos22 == -1) pos22 = pos12;
    if (check(pos1, pos12, pos2, pos22)) {
        cout << pos1 << ' ' << pos12 << '\n' << pos2 << ' ' << pos22;
        return 0;
    }
    if (check(pos1, pos22, pos2, pos12)) {
        cout << pos1 << ' ' << pos22 << '\n' << pos2 << ' ' << pos12;
        return 0;
    }
    assert(1 == 0);
}
/*
4
1 2 3 4
3 2 4 1
3 4 1 2
4 1 2 3

 * */