#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;

const int M = 1e9 + 7;

int n;
string s;
struct node{
    int l, r, lz, rz, sz, s;
};
node t[400005];
node un(node a, node b){
    if(a.sz == 0)return b;
    if(b.sz == 0)return a;
    node c;
    c.sz = a.sz + b.sz;
    c.s = a.s + b.s;
    c.l = a.l;
    c.r = b.r;
    c.lz = a.lz;
    c.rz = b.rz;
    if(a.r != b.l && !a.rz && !b.lz){
        c.s--;
        if(a.sz == 1)c.lz = 1;
        if(b.sz == 1)c.rz = 1;
    }
    return c;
}
void build(int v=1, int tl=1, int tr=n){
    if(tl == tr){
        if(s[tl] == 'b')t[v].l = t[v].r = t[v].sz = t[v].s = 1;
        else t[v].sz = 1;
        return;
    }

    int tm = (tl+tr)/2;
    build(v+v, tl, tm);
    build(v+v+1, tm+1, tr);
    t[v] = un(t[v+v], t[v+v+1]);
}
void upd(int pos, int v=1, int tl=1, int tr=n){
    if(tl == tr){
        if(s[tl] == 'b')t[v].l = t[v].r = t[v].s = 1;
        else t[v].l = t[v].r = t[v].s = 0;
        t[v].lz = 0;
        t[v].rz = 0;
        return;
    }
    int tm = (tl+tr)/2;
    if(pos <= tm)upd(pos, v+v, tl, tm);
    else upd(pos, v+v+1, tm+1, tr);
    t[v] = un(t[v+v], t[v+v+1]);
}
node get(int l, int r, int v=1, int tl=1, int tr=n){
    if(l <= tl && tr <= r)return t[v];
    if(tr < l || r < tl)return {0, 0, 0, 0, 0};
    int tm = (tl+tr)/2;
    return un(get(l, r, v+v, tl, tm), get(l, r, v+v+1, tm+1, tr));
}
signed main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   cout.tie(0);
   cin >> n >> s;
   s=' '+s;
   build();
   int q;
   cin >> q;
   while(q--){
    int tt;
    cin >> tt;
    if(tt == 1){
        int pos;
        cin >> pos;
        if(s[pos] == 'a')s[pos] = 'b';
        else s[pos] = 'a';
        upd(pos);
    }
    else{
        int l, r;
        cin >> l >> r;
        node x = get(l, r);
        if(x.s)cout << "NO\n";
        else cout << "YES\n";
    }
   }

return 0;
}
