#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define len(s) s.size()

const int maxn = 2e5+7 , mod = 1e9 + 7;

int dp[maxn];
int fact[maxn];
int inv[maxn];

int binpow(int a, int n){
    if(n == 0) return 1;
    if(n % 2 == 1) return (binpow(a, n - 1) * a) % mod;
    else{
        int b = binpow(a, n / 2);
        return (b * b) % mod;
    }
}

int cnk(int n, int k){
    return ((fact[n] * inv[n - k]) % mod * inv[k]) % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    fact[1] = 1;
    inv[1] = binpow(1, mod - 2);
    for(int i = 2; i <= n; i++) fact[i] = (fact[i - 1] * i) % mod;
    for(int i = 2; i <= n; i++) inv[i] = binpow(fact[i], mod - 2);
    dp[1] = 1;
    dp[2] = 1;
    dp[3] = 2;
    for(int i = 4; i <= n; i++){
        int cnt = 0;
        for(int k = 1; k <= i / 2; k++){
            cnt += cnk(i - 1, k);
        }
        dp[i] = dp[i - 1] * cnt;
    }
    cout << dp[n];
}