#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
#define int ll
#define sz(x) (int)x.size()
#define speed ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#define pb push_back
const int N = 2e5+5;
const int inf = (ll)1e9 + 100;
const int mod = 1e9 + 7;

int mult(int a, int b){
    return a * 1LL * b % mod;
}

int sum(int a, int b){
    if(a + b >= mod)
        return a + b - mod;
    if(a + b < 0)
        return a + b + mod;
    return a + b;
}

int binpow(int a, int n){
    if(n == 0)
        return 1;
    if(n % 2){
        int b = binpow(a, n - 1);
        return mult(a, b);
    }else{
        int b = binpow(a, n / 2);
        return mult(b, b);
    }
}

int n, md[N], dp[N], dp1[N];
vector<int> g[N];

void dfs1(int v = 1){
    md[v] = inf;
    for(auto u : g[v]){
            dfs1(u);
            md[v] = min(md[u] + 1, md[v]);
    }
    if(md[v] == inf)
        md[v] = 0;
}

void dfs3(int v, int curd, int d, vector<int> &ret){
    if(d == curd){
        ret.pb(v);
        return;
    }
    for(auto u : g[v]){
        dfs3(u, curd + 1, d, ret);
    }
}

void dfs2(int v = 1){
    vector<int> go = {};
    dfs3(v, 0, md[v], go);
    for(auto u : go){
        if(u == v)
            continue;
        dp[u] = dp[v] + 1;
        dfs2(u);
    }
}

void dfs4(int v = 1){
    int cnt = sz(g[v]);
    if(cnt == 0)
        return;
    dp1[v] = max(dp1[v], dp[v]);
    for(auto u : g[v]){
        dp1[u] = max(dp1[v], dp1[u]);
        dfs4(u);
    }
}

void solve(){
    dp[1] = 1;
    cin >> n;
    for(int i = 2; i <= n; i++){
        int p;
        cin >> p;
        g[p].pb(i);
    }
    dfs1();

    dfs2();
    dfs4();
    int mx = 0;
    for(int i = 1; i <= n; i++)
        if(sz(g[i]) == 0)
            mx = max(mx, dp1[i]);
    cout << mx << '\n';
}
signed main(){
    //speed;
    solve();
}
