#include <iostream>
#include <map>
#include <algorithm>

typedef long long i64;

using namespace std;

#define AVG(a, b) ((a / 2) + (b / 2) + ((a & 1) * (b & 1)))
map<i64, i64> rq;

i64 bp(i64 l, i64 r, i64 tg)
{
	while ((r - l) > 1) {
		i64 m = AVG(l, r);
		cout << "? " << m << endl;
		cin >> rq[m];
		if (rq[m] >= tg)
			r = m;
		else
			l = m;
	}
	return l;
}

i64 pow(i64 b, i64 p) {
	if (b < 2) return b;
	if (p == 0) return 1;
	if (p == 1) return b;
	if (p == 2) return b * b;
	if ((p % 2) == 0)
		return pow(pow(b, p / 2), 2);
	return pow(b, p - 1) * b;
}

int main()
{
	cin >> rq[0];
	i64 w = bp(1, 1e18, rq[0] + 1) + 1;
	i64 l = 1, r = 1e18;
	for (auto i : rq) { 
		if (i.second > rq[0] + 1) {
			r = min(r, i.first);
		} else {
			l = max(l, i.first);
		}
	}
	i64 ww = bp(l, r, rq[0] + 2) + 1;
	l = 1, r = 1e18;
	for (auto i : rq) {
		if (i.second > rq[0] + 2) {
			r = min(r, i.first);
		}
		else {
			l = max(l, i.first);
		}
	}
	i64 www = bp(l, r, rq[0] + 3) + 1;
	i64 b = (www - ww) / (ww - w);
	i64 x = pow(b, rq[0]) - w;
	cout << "! " << x << ' ' << b << endl;
	return 0;
}