#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int maxn = 1e3 + 1;
int n;
int a[maxn][maxn];
ll col[maxn], row[maxn];

bool isgood(int i1, int j1, int k1, int t1) {
    swap(a[i1][j1], a[k1][t1]);
    bool fl = 0;
    set<int> col1, row1;
    fill(row, row + n, 0);
    fill(col, col + n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        col1.insert(col[i]);
        row1.insert(row[i]);
    }
    swap(a[i1][j1], a[k1][t1]);
    if (col1.size() == 1 && row1.size() == 1) {
        cout << i1 + 1 << ' ' << j1 + 1 << ' ' << k1 + 1 << ' ' << t1 + 1 << '\n';
        exit(0);
    }
    return 0;
}

void solve1() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                for (int t = 0; t < n; t++) {
                    if (isgood(i, j, k, t)) {
                        cout << i + 1 << ' ' << j + 1 << ' ' << '\n' << k + 1 << ' ' << t + 1 << '\n';
                        exit(0);
                    }
                }
            }
        }
    }
}

bool isgood1(int i, int j, int k, int t) {
    if ((a[i][j] - a[k][t]) * 2 == (row[i] - row[k]) && (a[i][j] - a[k][t]) * 2 == (col[j] - col[t])) {
        cout << i << ' ' << j << ' ' << k << ' ' << t;
        exit(0);
    }
    return 0;
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    if (n < 5) {
        solve1();
        exit(0);
    }
    solve();
}
