#include <iostream>
#include <algorithm>
#include <numeric>
#include <math.h>
#include <cmath>
#include <string>
#include <map>
#include <vector>

using namespace std;
const long long mod = 1000000007;
vector<long long>ftr(10000);
long long fact(long long a) {
	return ftr[a];
}
 
long long egcd(long long a, long long b, long long& x, long long& y) {
    if (a == 0) { x = 0; y = 1; return b; }
    long long x1, y1; int d = egcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1; y = x1;
    return d;
}
 
long long revmod(int n, int m) {
    long long x, y;
    long long g = egcd(n, m, x, y);
    return ((x%m) + m) % m;
}
 
long long moddiv(long long x, long long y) {
    return ((x % mod) * revmod(y, mod)) % mod;
}
long long cnk(long long n, long long k) {
    return moddiv(moddiv(fact(n),fact(k)),fact(n - k));
}

int main()
{
	ftr[0] = 1;
	for (long long i = 1; i < 10000; i++)
		ftr[i] = (ftr[i - 1] * i) % mod;
	long long n, k, ans = 1;
	cin >> n;
	n--;
	for (long long i = 1; i <= n; i++) {
		long long q = i + 1, part = 0, modi = 1;
		while (q >= 2) {
			q -= 2;
			part = (part + (cnk(i, modi) * cnk(i - modi, q)) % mod) % mod;
			modi++;
		}
		ans = (ans * part) % mod;
	}
	cout << ans << endl;
}
