﻿#include <vector>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t);
    } else {
        ll t = bin_pow(a, n - 1);
        return (t * a);
    }
}
void solve() {
    string s;
    cin >> s;
    int n; cin >> n;
    map<char, int > no_used, cur;
    for (int i = 0; i < n; i++) {
        char c; int x;
        cin >> c >> x;
        no_used[c] = x;
    }
    debug(s.size());
    int ans = 0;
    for (int i = 0; i < s.size(); i++) {
        if (no_used.count(s[i]) == 0) {
            ans++;
        } else {
            while (true) {
                if (cur[s[i]] % (no_used[s[i]]) == 0) {
                    ans++;
                    cur[s[i]]++;
                }
                else {
                    ans++;
                    cur[s[i]]++;
                    break;
                }
            }
        }
    }
    cout << ans << endl;
}
signed main() {
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
2
00000010001011
*/