#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

int div_ceil(int a, int b){
    if(a%b){
        return a/b+1;
    }
    return a/b;
}

void solve() {
    string s, tmp;
    cin>>s;
    int n;
    cin>>n;
    unordered_map<char,int> m;
    unordered_map<char,int> rate;
    string c;
    int x;
    for(int i=0;i<n;i++){
        cin>>c>>x;
        rate[c[0]]=x;
    }
    for(char el:s){
        m[el]++;
    }
    ll sum=0;
    for(auto&& el:m){
        if(rate.find(el.first)!=rate.end()){
            el.second+=div_ceil(el.second,rate[el.first]-1);
        }
        sum+=el.second;
    }
    cout<<sum;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}