#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <cstdint>
#include <cassert>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

const ll MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    int cnt[3];
    fill(cnt, cnt + 3, 0);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        cnt[x % 3]++;
    }
    ll q = 1, fact1 = 1, fact2 = 1;
    for (int i = 0; i < cnt[0]; ++i) {
        q = (q * (n - cnt[0])) % MOD;
    }
    for (int i = 2; i <= cnt[1]; ++i) {
        fact1 = (fact1 * i) % MOD;
    }
    for (int i = 2; i <= cnt[2]; ++i) {
        fact2 = (fact2 * i) % MOD;
    }
    q = (q * fact1) % MOD;
    q = (q * fact2) % MOD;
    int ones = 1, twos = 0, r = 1;
    for (int i = 0; cnt[1] >= ones && cnt[2] >= twos && i < n - cnt[0] - 1; ++i) {
        if ((r + 1) % 3) {
            ones++;
            r = (r + 1) % 3;
        } else {
            twos++;
            r = (r + 2) % 3;
        }
    }
    ll ans = 0;
    if (cnt[1] == ones && cnt[2] == twos) {
        ans += q;
    }
    ones = 0, twos = 1, r = 2;
    for (int i = 0; cnt[1] >= ones && cnt[2] >= twos && i < n - cnt[0] - 1; ++i) {
        if ((r + 1) % 3) {
            ones++;
            r = (r + 1) % 3;
        } else {
            twos++;
            r = (r + 2) % 3;
        }
    }
    if (cnt[1] == ones && cnt[2] == twos) {
        ans += q;
    }
    cout << ans % MOD;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}