#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

int a, b, c;

int p(int x) {
    if (x < 5)
        return a;
    if (x < 10)
        return b;
    return c;
}

void solve() {
    vector<int> x(3);
    cin >> x[0] >> x[1] >> x[2] >> a >> b >> c;
    int ans = INT32_MAX;
    do {
        int f1 = p(x[0] + x[1] + x[2]), f2 = p(x[0] + x[1]) + p(x[2]), f3 = p(x[0]) + p(x[1] + x[2]), f4 = p(x[0]) + p(x[1]) + p(x[2]);
        ans = min(ans, f1);
        ans = min(ans, f2);
        ans = min(ans, f3);
        ans = min(ans, f4);
    } while (next_permutation(x.begin(), x.end()));
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}