#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

int n;

bool check(vector<vector<ll>> a) {
    vector<ll> sumh(n);
    vector<ll> sumv(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            sumh[i] += a[i][j];
            sumv[j] += a[i][j];
        }
    }

    bool flagH = *max_element(sumh.begin(), sumh.end()) != *min_element(sumh.begin(), sumh.end());
    bool flagV = *max_element(sumv.begin(), sumv.end()) != *min_element(sumv.begin(), sumv.end());

    if (flagH || flagV) return false;
    return true;
}

void solve3() {
    vector<vector<ll>> a(n, vector<ll>(n));
    cin >> a;
    for (int i1 = 0; i1 < n; ++i1) {
        for (int j1 = 0; j1 < n; ++j1) {
            for (int i2 = 0; i2 < n; ++i2) {
                for (int j2 = 0; j2 < n; ++j2) {
                    if (make_pair(i1, j1) == make_pair(i2, j2)) continue;
                    swap(a[i1][j1], a[i2][j2]);

                    if (check(a)){
                        cout << i1 + 1 << " " << j1 + 1 << "\n" << i2 + 1 << " " << j2 + 1 << "\n";
                        return;
                    }
                    swap(a[i1][j1], a[i2][j2]);
                }
            }
        }
    }
}

signed main() {
#ifdef LOCAL

#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    cin >> n;

    if (n == 3){
        solve3();
        return 0;
    }
    vector<vector<ll>> a(n, vector<ll>(n));
    cin >> a;

    vector<ll> sumh(n);
    vector<ll> sumv(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            sumh[i] += a[i][j];
            sumv[j] += a[i][j];
        }
    }

    bool flagH = *max_element(sumh.begin(), sumh.end()) != *min_element(sumh.begin(), sumh.end());
    bool flagV = *max_element(sumv.begin(), sumv.end()) != *min_element(sumv.begin(), sumv.end());

    map<ll, int> hcnt, vcnt;
    for (int i = 0; i < n; ++i) {
        hcnt[sumh[i]]++;
        vcnt[sumv[i]]++;
    }

    vector<int> pI(2, -1);
    if (flagH) {
        for (int i = 0; i < n; ++i) {
            if (hcnt[sumh[i]] != n - 2) {
                if (pI[0] == -1) pI[0] = i;
                else pI[1] = i;
            }
        }
    }

    vector<int> pJ(2, -1);
    if (flagV) {
        for (int i = 0; i < n; ++i) {
            if (vcnt[sumv[i]] != n - 2) {
                if (pJ[0] == -1) pJ[0] = i;
                else pJ[1] = i;
            }
        }
    }

    if (flagH && flagV) {
        for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < 2; ++j) {
                swap(a[pI[i]][pJ[j]], a[pI[1 - i]][pJ[1 - j]]);
                if (check(a)) {
                    cout << pI[i] + 1 << " " << pJ[j] + 1 << "\n" << pI[1 - i] + 1 << " " << pJ[1 - j] + 1 << "\n";
                    return 0;
                }
                swap(a[pI[i]][pJ[j]], a[pI[1 - i]][pJ[1 - j]]);
            }
        }
    } else if (flagH) {
        for (int i = 0; i < n; ++i) {
            swap(a[pI[0]][i], a[pI[1]][i]);
            if (check(a)) {
                cout << pI[i] + 1 << " " << i + 1 << "\n" << pI[1 - i] + 1 << " " << i + 1 << "\n";
                return 0;
            }
            swap(a[pI[0]][i], a[pI[1]][i]);
        }
    } else if (flagV) {
        for (int i = 0; i < n; ++i) {
            swap(a[i][pJ[0]], a[i][pJ[1]]);
            if (check(a)) {
                cout << i + 1 << " " << pJ[0] + 1 << "\n" << i + 1 << " " << pJ[1] + 1 << "\n";
                return 0;
            }
            swap(a[i][pJ[0]], a[i][pJ[1]]);
        }
    }
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion