#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL

#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    int x, y, z, a, b, c;
    cin >> x >> y >> z >> a >> b >> c;

    function<int(vector<int>)> cost = [&](vector<int> arr){
        int cost = 0;
        for (auto val: arr){
            if (val < 5) cost += a;
            else if (val < 10) cost += b;
            else cost += c;
        }
        return cost;
    };

    cout << min({
       cost({x, y, z}),
       cost({x + y, z}),
       cost({x, y + z}),
       cost({x + z, y}),
       cost({x + y + z}),
    });
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion