#include <bits/stdc++.h>

using namespace std;
#define int long long
const int mod = 1e9 + 7;
int ans=1;

int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int t = bin_pow(a, n / 2);
        return (t * t) % mod;
    }
    return (a * bin_pow(a, n - 1)) % mod;
}

int prod(int a, int b) {
    return (a * b) % mod;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin>>n;
    int sum;
    vector<int> F(5e3 + 1), F_inv(5e3 + 1);
    F[0] = 1;
    for (int i = 1; i <= 5e3; ++i) {
        F[i] = (F[i - 1] * i) % mod;
    }
    F_inv.back() = bin_pow(F.back(), mod - 2);
    for (int i = 5e3 - 1; i >= 0; --i) {
        F_inv[i] = (F_inv[i + 1] * (i + 1)) % mod;
    }
    for (int i=1;i<n;i++){
        sum = 0;
        for (int k = 1; k <= (i + 1) / 2; ++k) {
            sum += prod(prod(prod(F[i], F_inv[i - k]), prod(F_inv[k], F[i - k])), prod(F_inv[i + 1 - 2 * k],F_inv[k - 1]));
        }
        ans *= sum;
        ans %= mod;
    }
    cout << ans;
}

