#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

typedef long long ll;

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

void solve()
{
	long long n;
	cin >> n;

	vector<vector<long long>> dpr(n + 3, vector<long long>(n + 1));
	dpr[n + 1][0] = dpr[n + 2][0] = 1;
	for (long long x = n; x >= 1; x--)
	{
		dpr[x] = dpr[x + 1];
		for (long long xx = x; xx <= n; xx += x)
		{
			for (long long i = n; i >= xx; i--)
			{
				dpr[x][i] = (dpr[x][i] + dpr[x + 1][i - xx]) % MOD;
			}
		}
	}

	vector<vector<long long>> dpl(n + 1, vector<long long>(n + 1));
	dpl[0][0] = 1;
	for (long long x = 1; x <= n; x++)
	{
		for (long long xx = x; xx <= n; xx += x)
		{
			for (long long i = xx; i <= n; i++)
			{
				dpl[x][i] = (dpl[x][i] + dpl[x - 1][i - xx]) % MOD;
			}
		}
	}

	long long ans = 0;
	for (long long mex = 1; mex <= n + 1; mex++)
	{
		for (long long left = 0; left <= n; left++)
		{
			long long right = n - left;
			long long add = (dpl[mex - 1][left] * dpr[mex + 1][right]) % MOD;
			add = (add * mex) % MOD;
			ans = (ans + add) % MOD;
		}
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
