#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll INF = 1e18 + 1;
#define int long long
#define endl "\n"

vector <vector <int>> sm;
vector <int> dp;
vector <int> m;
vector <int> h;

void dfs1(int v, int height, int p = -1){
    h[v] = height;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        dfs1(to, height + 1, v);
        m[v] = min(m[to] + 1, m[v]);
    }
    if (m[v] == INF)
        m[v] = 0;
}

map <int, int> dfs(int v, int p = -1){
    map <int, int> res;
    vector <map <int, int>> g;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        g.push_back(dfs(to, v));
        if ((int)g[0].size() < (int)g.back().size())
            swap(g[0], g.back());
    }
    if (g.empty()){
        dp[v] = 0;
        return {{h[v], 0}};
    }
    swap(g[0], res);
    for (int i = 1; i < (int)g.size(); i++){
        for (auto j:g[i]){
            res[j.first] = max(res[j.first], j.second);
        }
    }
    dp[v] = res[h[v] + m[v]] + 1;
    res[h[v]] = max(res[h[v]], dp[v]);
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    sm.resize(n);
    dp.resize(n);
    h.resize(n);
    m.resize(n, INF);
    for (int i = 0; i < n - 1; i++){
        int p;
        cin >> p;
        p--;
        sm[i + 1].push_back(p);
        sm[p].push_back(i + 1);
    }
    dfs1(0, 0, -1);
//    cout << 243534 << endl;
    dfs(0, -1);
    cout << dp[0];
}
