#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;

#define int long long

int bin_pow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans = ans * a % MOD;
        }
        n /= 2;
        a = a * a % MOD;
    }
    return ans;
}

vector <int> fact, inv_fact;

int cnk(int n, int k) {
    return fact[n] * inv_fact[k] % MOD * inv_fact[n - k] % MOD;
}

void solve() {
    const int MAX = 5050;
    fact.resize(MAX);
    inv_fact.resize(MAX);
    fact[0] = 1;
    for (int i = 1; i < MAX; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    inv_fact[MAX - 1] = bin_pow(fact[MAX - 1], MOD - 2);
    for (int i = MAX - 2; i >= 0; i--) {
        inv_fact[i] = inv_fact[i + 1] * (i + 1) % MOD;
    }

    int n;
    cin >> n;

    int ans = 1;
    for (int i = 2; i <= n; i++) {
        int cnt = 0;
        for (int j = i - 1; j >= (i + 1) / 2; j--) {
            cnt += cnk(i - 1, j) * cnk(j, i - j) % MOD;
            cnt %= MOD;
        }
        ans = ans * cnt % MOD;
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
