#include <bits/stdc++.h>
using namespace std;
#define int long long
vector<vector<int>> tree;
void update(int l_b, int r_b, int p, int m, int s) {
    //cout << l_b << " " << r_b << "\n";
    if (l_b == r_b - 1) {
        if (s == 0) {
            tree[m] = {1, 1, 0};
        } else {
            tree[m] = {2, 0, 3};
        }
        return;
    }
    int m_b = (l_b + r_b) / 2;
    if (p < m_b) {
        update(l_b, m_b, p, 2 * m + 1, s);
    } else {
        update(m_b, r_b, p, 2 * m + 2, s);
    }
    for (int i = 0; i < 3; i++) {
        if (tree[2 * m + 1][i] == 0) {
            tree[m][i] = tree[2 * m + 2][0];
        }
        if (tree[2 * m + 1][i] == 1) {
            tree[m][i] = tree[2 * m + 2][1];
        }
        if (tree[2 * m + 1][i] == 2) {
            tree[m][i] = tree[2 * m + 2][2];
        }
        if (tree[2 * m + 1][i] == 3) {
            tree[m][i] = 3;
        }
    }
}
int get(int l_b, int r_b, int l, int r, int s, int m){
    //cout << l_b << " " << r_b << " " << l << " " << r << " " << m << " " << s << "\n";
    if(s == 3){
        return 3;
    }
    if(l == l_b && r == r_b){
        return tree[m][s];
    }
    int m_b = (l_b + r_b) / 2;
    if(r <= m_b){
        return get(l_b, m_b, l, r, s, 2 * m + 1);
    }
    if(l >= m_b){
        return get(m_b, r_b, l, r, s, 2 * m + 2);
    }
    return get(m_b, r_b, m_b, r, get(l_b, m_b, l, m_b, s, 2 * m + 1), 2 * m + 2);
}
signed main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    tree.assign(4 * n + 10, {3, 3, 3});
    for(int i = 0; i < n; i++){
        if(s[i] == 'a'){
            update(0, n, i, 0, 0);
        }
        else{
            update(0, n, i, 0, 1);
        }
    }
    int m;
    cin >> m;
    for(int i = 0; i < m; i++){
        int op;
        cin >> op;
        if(op == 1){
            int k;
            cin >> k;
            k--;
            if(s[k] == 'a'){
                update(0, n, k, 0, 1);
                s[k] = 'b';
            }
            else{
                update(0, n, k, 0, 0);
                s[k] = 'a';
            }
        }
        if(op == 2){
            int l, r;
            cin >> l >> r;
            l--;
            int p = get(0, n, l, r, 0, 0);
            if(p == 2 || p == 3){
                cout << "NO\n";
            }
            else{
                cout << "YES\n";
            }
            //cout << tree[5][2] << "\n";
        }
    }
}
