#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define first fi
#define second se
#define push_back pb

const ll MOD = 1'000'000'000 + 7;
const ll INF = 1e18;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        return ans * ans % MOD;
    } else {
        return n * bin_pow(n, k - 1) % MOD;
    }
}

void solve()
{
    ll n;
    cin >> n;
    vector <vector <ll>> vec(n, vector <ll> (n));

    ll sm = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            cin >> vec[i][j];
            sm += vec[i][j];
        }
    }
    sm /= n;

    int x1 = -1;
    int x2 = -1;
    int y1 = -1;
    int y2 = -1;

    vector <ll> smx(n);
    vector <ll> smy(n);

    for (int i = 0; i < n; i++)
    {
        ll s = 0;
        for (int j = 0; j < n; j++)
        {
            s += vec[i][j];
        }
        smy[i] = s;
        if (s != sm)
        {
            if (y1 == -1)
            {
                y1 = i;
            }
            else
            {
                y2 = i;
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        ll s = 0;
        for (int j = 0; j < n; j++)
        {
            s += vec[j][i];
        }
        smx[i] = s;
        if (s != sm)
        {
            if (x1 == -1)
            {
                x1 = i;
            }
            else
            {
                x2 = i;
            }
        }
    }

    if (x1 == -1)
    {
        for (int i = 0; i < n; i++)
        {
            if (smy[y1] - vec[y1][i] + vec[y2][i] == sm)
            {
                cout << y1 + 1 << ' ' << i + 1 << '\n' << y2 + 1 << ' ' << i + 1;
                return;
            }
        }
    }
    if (y1 == -1)
    {
        for (int i = 0; i < n; i++)
        {
            if (smx[x1] - vec[i][x1] + vec[i][x2] == sm)
            {
                cout << i + 1 << ' ' << x1 + 1 << '\n' << i + 1 << ' ' << x2 + 1;
                return;
            }
        }
    }
    cout << y1 + 1 << ' ' << x1 + 1 << '\n' << y2 + 1 << ' ' << x2 + 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
