#include <bits/stdc++.h>

using ll = long long;

const int M = 1e9 + 7;

ll pow(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    ll x = pow(a, b / 2);
    x *= x; x %= M;
    if (a & 1) {
        x *= a;
        x %= M;
    }
    return x;
}

void solve() {
    int n; std::cin >> n;
    std::vector<int>c(3);
    for (int i = 0; i < n; ++i) {
        int a; std::cin >> a;
        c[a % 3]++;
    }
    if (c[0] == n) {
        std::cout << "0\n";
        return;
    }
    if (n == 1) {
        if (c[0] == 0) {
            std::cout << "1\n";
        } else {
            std::cout << "0\n";
        }
        return;
    }
    ll ans = 0;
    ll cc = 1;
    for (ll i = 1; i <= c[0]; ++i) {
        cc *= pow(i, M - 2); cc %= M;
        cc *= (n - i); cc %= M;
    }
    if (c[1] == c[2] + 2 || c[1] == c[2] + 1) {
        ans += cc;
    }
    if (c[2] == c[1] + 2 || c[2] == c[1] + 1) {
        ans += cc;
    }
    ans %= M;
    ll pr = 1;
    for (ll i = 1; i <= n; ++i) {
        pr *= i; pr %= M;
        if (i == c[1]) {
            ans *= pr;
            ans %= M;
        }
        if (i == c[2]) {
            ans *= pr;
            ans %= M;
        }
        if (i == c[0]) {
            ans *= pr;
            ans %= M;
        }
    }
    std::cout << ans << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}
