#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
using ll = long long;
#define int long long

const int MAXN = 1000 + 1;
const int SQRT = 40;

int dp[MAXN][MAXN][SQRT];

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    const int mod = 1e9 + 7;
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            for (int k = 0; k < SQRT; k++) {
                dp[i][j][k] = 0;
            }
        }
    }
    int n;
    cin >> n;
    dp[0][0][0] = 1;
    dp[0][0][1] = 1;
//    dp[0][0][2] = 1;


    for (int i = 1; i <= n; i++) {
        for (int lst = 0; lst <= i; lst++) {
            for (int mex = 1; mex < SQRT; mex++) {
                if (lst == mex - 1) {
                    for (int fr = 0; fr <= lst; fr++) {
                        if (fr == lst) {
                            dp[i][lst][mex] += dp[i - lst][lst][mex];
                        } else {
                            dp[i][lst][mex] += dp[i - lst][fr][mex - 1];
                        }
//                        dp[i][lst][mex] += dp[i - lst][fr][mex];
//                        dp[i][lst][mex] %= mod;
                    }
                } else {
                    for (int fr = 0; fr <= lst; fr++) {
                        dp[i][lst][mex] += dp[i - lst][fr][mex];
                        dp[i][lst][mex] %= mod;
                    }
                }

            }
        }
    }

    int ans = 0;
    for (int mex = 1; mex <= SQRT; mex++) {
        // sum dp[n][i][mex]
        for (int lst = 1; lst <= n; lst++) {
            ans += dp[n][lst][mex];
            if (ans >= mod) {
                ans -= mod;
            }
        }
    }
    cout << ans << '\n';
}