#include <bits/stdc++.h>
#define int ll
#define F first
#define S second
#define pb push_back


using namespace std;

typedef long long ll;
const int N = 2e5 + 10;
const int mod = 1e9 + 7;

vector < int > g[N];
vector < int > ver[N];
int tin[N], sz[N], num[N], h[N];
int min_h[N];


int timer = 1;
int n;


void dfs(int v){
    ver[h[v]].pb(v);
    sz[v] = 1;
    tin[v] = timer++;
    min_h[v] = n + 100;

    for(auto to : g[v]){
        h[to] = h[v] + 1;
        dfs(to);
        sz[v] += sz[to];
        min_h[v] = min(min_h[v], min_h[to]);
    }

    if(sz[v] == 1) min_h[v] = h[v];

}



struct SegTree{
    int t[N * 4];

    void upd(int v, int vl, int vr, int pos, int x){
        if(vl == vr){
            t[v] = max(t[v], x);
            return;
        }

        int mid = (vl + vr) >> 1;

        if(pos <= mid) upd((v << 1), vl, mid, pos, x);
        else upd((v << 1) + 1, mid + 1, vr, pos, x);

        t[v] = max(t[(v << 1)], t[(v << 1) + 1]);
    }

    int get(int v, int vl, int vr, int l, int r){
        if(vl > r || vr < l) return 0;

        if(vl >= l && vr <= r) return t[v];

        int mid = (vl + vr) >> 1;
        return max(get((v << 1), vl, mid, l, r),
                   get((v << 1) + 1, mid + 1, vr, l, r));
    }

};

SegTree t;


int get(int v, int need){
    if(h[v] == need) return 0;

//    cout << tin[v] + sz[v] - 1 << ' ' << v << ' ' << sz[v] << endl;
//    for(auto to : ver[need]) cout << tin[to] << ' ' ;
//    cout << endl;
////    cout << "FIND " << v << ' ' << h[v] << ' ' << need << endl;


    int l = 0, r = (int)(ver[need].size()) - 1;
    int pos1 = -1, pos2 = -1;

    while(l <= r){
        int mid = (l + r) >> 1;
        if(tin[ver[need][mid]] >= tin[v]){
            r = mid - 1;
            pos1 = mid;
        }
        else
            l = mid + 1;
    }

//    cout << "!pos1    " << pos1 << endl;


    l = 0, r = (int)(ver[need].size()) - 1;
    while(l <= r){
        int mid = (l + r) >> 1;
        if(tin[ver[need][mid]] <= tin[v] + sz[v] - 1){
            pos2 = mid;
            l = mid + 1;
        }
        else
            r = mid - 1;
    }


//    cout << "!!! " << pos2 << endl;

    if(pos1 == -1 || pos2 == -1) return 0;

    int v1 = ver[need][pos1], v2 = ver[need][pos2];
//    cout << "!!! " << v1 << ' ' << v2 << endl;


    return t.get(1, 1, n, num[v1], num[v2]);

}

int dp[N];
void dfs1(int v){



    for(auto to : g[v]){
        dfs1(to);
    }

    dp[v] = get(v, min_h[v]) + (sz[v] != 1);
//    cout << v << ' ' << dp[v] << ' ' << h[v] << ' ' << min_h[v] << ' ' << get(v, min_h[v]) << endl;
    t.upd(1, 1, n, num[v], dp[v]);
}




int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif


//    int n;
    cin >> n;


    for(int i = 2; i <= n; i++){
        int p;
        cin >> p;

        g[p].pb(i);
    }

    h[1] = 1;
    dfs(1);



    int cnt = 1;

    for(int i = 1; i <= n; i++)
    if(ver[i].size()){
        for(auto to : ver[i])
            num[to] = cnt++;
    }

//    cout << get(1, 2) << endl;


//    cerr << "dfs" << endl;
    dfs1(1);

    cout << dp[1];














    return 0;
}
