#include <bits/stdc++.h>
//#define int ll

using namespace std;

typedef long long ll;
const int N = 1e5 + 10;

int n;
string s;
int a[N];

struct node {
    int pref = 0, suf = 0, ans = 0, sz = 0;
    int l, r;
};

node t[N * 4];

node merg(node a, node b){
    if(a.sz == 0) return b;
    if(b.sz == 0) return a;


    node res;

    if((a.ans && b.ans) || (a.pref && b.suf && a.r + b.l <= 1)) res.ans = 1;
    res.pref = (a.ans && b.pref);
    res.suf = (a.suf && b.ans);

    res.sz = a.sz + b.sz;
    res.l = a.l;
    res.r = b.r;

    return res;


}

void build(int v, int vl, int vr){
    if(vl == vr){
        t[v].l = t[v].r = a[vl];

        t[v].pref = t[v].suf = 1;
        t[v].ans = 1 - a[vl];

        t[v].sz = 1;

        return;
    }
    int mid = (vl + vr) >> 1;
    build((v << 1), vl, mid);
    build((v << 1) + 1, mid + 1, vr);

    t[v] = merg(t[(v << 1)], t[(v << 1) + 1]);
}


void upd(int v, int vl, int vr, int pos){
    if(vl == vr){
        t[v].l = t[v].r = a[vl];

        t[v].pref = t[v].suf = 1;
        t[v].ans = 1 - a[vl];

        t[v].sz = 1;

        return;
    }
    int mid = (vl + vr) >> 1;
    if(pos <= mid) upd((v << 1), vl, mid, pos);
    else upd((v << 1) + 1, mid + 1, vr, pos);

    t[v] = merg(t[(v << 1)], t[(v << 1) + 1]);
}

node get(int v, int vl, int vr, int l, int r){
    if(vl > r || vr < l) return node();

    if(vl >=l && vr <= r) return t[v];

    int mid = (vl + vr) >> 1;

    return merg(get((v << 1), vl, mid, l, r),
                get((v << 1) + 1, mid + 1, vr, l, r));
}
void solve(){
    cin >> n >> s;

    for(int i = 1; i <= n; i++) a[i] = (int)(s[i - 1] - 'a');
    build(1, 1, n);


    int q;
    cin >> q;

    while(q--){
        int tp;
        cin >> tp;

        if(tp == 1){
            int pos;
            cin >> pos;

            a[pos] ^= 1;
            upd(1, 1, n, pos);
        }
        else {
            int l, r;
            cin >> l >> r;

            node res = get(1, 1, n, l, r);

//            cout << res.ansa << ' ' << res.ans << endl;
//            if(res.ans == 1 && res.ansa <= 1 && a[l] && (r - l + 1) % 2){
//                cout << "NO" << endl;
//                continue;
//            }

            cout << ((res.ans) ? "YES" : "NO") << endl;
        }
    }


}


int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #else

    #endif

    solve();

    return 0;
}
