#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using vi = vector<int>;
using vl = vector<ll>;
#define f first
#define s second

ll mod = 1e9 + 7;

ll mult(ll a, ll b) {
    return a*b%mod;
}

vector<vl> cash(1005, vl(1005, -1));
ll fun(ll n, int i, bool flag = true) {
    if (n == 0) return 1;
    if (i > n) return 0;
    if (flag == false && cash[n][i] != -1)
        return cash[n][i];

    ll sum = 0;
    for (int ic = 1; ic*i <= n; ic++) {
        sum += fun(n - ic * i, i + 1, flag);
    }
    sum += fun(n, i+1, false);
    sum %= mod;
    cash[n][i] = sum;
    return sum;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n; cin >> n;
    ll ans = 0;
    for (int i = 2; i <= n; i++)
        ans += fun(n, i, false);
    ans += fun(n, 1, true);

    cout << (ans+1) % mod;
}
