#include <bits/stdc++.h>
#define pii pair <int, int>
using namespace std;

#define vc vector
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

#define int long long
const int mod = 1e9 + 7;
const int N = 2e5 + 100;
const int inf = 1e9;

#define fi first
#define se second
struct pt {
    int x, y, i = -1, f = 0;
    pt () {}
    pt (int x, int y): x(x), y(y) {}
    pt operator + (pt b) {
        return pt(x + b.x, y + b.y);
    }
    pt operator - (pt b) {
        return pt(x - b.x, y - b.y);
    }
    int len2() {
        return x * x + y * y;
    }
    int operator ^ (pt b) {
        return x * b.y - y * b.x;
    }
};

bool cmp (pt a, pt b) {
    if ((a ^ b) == 0) return a.len2() < b.len2();
    return (a ^ b) < 0;
}

vc <pii> g[N];
pt a[N];



void solve_case() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v; --u; --v;
        g[u].push_back({v, i - 1});
        g[v].push_back({u, i - 1});
    }
    vc <set <int>> w(n - 1);
    vector<bool> us(n - 1);
    vector<int> lst;
    function<void(int)> dfs = [&](int v) {
        us[v] = true;
        lst.push_back(v);
        for (auto u : w[v]) {
            if (!us[u]) {
                dfs(u);
            }
        }
    };
    int ans = n - 1;
    for (int u = 0; u < n; ++u) {
        vc <int> in;
        vc <pt> up, daun;
        map <int, int> mp;
        for (auto [v, j] : g[u]) {
            mp[j] = v;
            in.push_back(j);
            pt x1 = a[v] - a[u];
            pt x2 = a[u] - a[v];
            x1.f = 1;
            x1.i = j;
            x2.f = 0;
            x2.i = j;
            if (x1.x <= 0 && (x1.x != 0 || x1.y > 0))
                up.push_back(x1);
            else
                daun.push_back(x1);
            if (x2.x <= 0 && (x1.x != 0 || x1.y > 0))
                up.push_back(x2);
            else
                daun.push_back(x2);
        }
        sort(up.begin(), up.end(), cmp);
        sort(daun.begin(), daun.end(), cmp);
        vc <pt> b;
        for (pt t : up) {
            b.push_back(t);
        }
        for (pt t : daun)
            b.push_back(t);
        vector<int> lst1;
        int k = b.size();
        for (int i = 0; i < k * 2; ++i) {
            pt h = b[i % k];
            if (!h.f) {
                lst1.push_back(h.i);
            } else {
                if (!lst1.empty()) {
                    if (lst1.back() != h.i) {
                        w[h.i].insert(lst1.back());
                    } else if (lst1.size() >= 2) {
                        w[h.i].insert(lst1[lst1.size() - 2]);
                    }
                }
            }
        }
        lst1.clear();
        for (int i = k * 2 - 1; i >= 0; i--) {
            pt h = b[i % k];
            if (!h.f) {
                lst1.push_back(h.i);
            } else {
                if (!lst1.empty()) {
                    if (lst1.back() != h.i) {
                        w[h.i].insert(lst1.back());
                    } else if (lst1.size() >= 2) {
                        w[h.i].insert(lst1[lst1.size() - 2]);
                    }
                }
            }
        }
        for (int j : in) {
            w[j].erase(j);
            vc<int> del;
            int f = 0, l = -1;
            for (int q: w[j]) {
                if (((a[u] - a[mp[q]]) ^ (a[mp[j]] - a[u])) == 0) {
                    f = 1;
                    l = q;
                    break;
                }
            }
            if (f) {
                w[j] = {l};
            }
        }
        for (int j : in) {
            vc <int> del;
            for (int q : w[j]) {
                if (w[j].find(q) == w[j].end()) {
                    del.push_back(q);
                }
            }
            for (int q : del)
                w[j].erase(q);
        }
        for (int j : in) {
            if (!us[j]) {
                dfs(j);
                ans -= lst.size() / 2;
                lst.clear();
            }
        }
        for (int j : in) {
            us[j] = 0;
            w[j].clear();
        }
    }
    cout << ans << '\n';

}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; //cin >> tc;
    while (tc--) solve_case();
}
/*
 * 5
0 0
1 0
0 1
2 0
0 2
1 2
1 3
2 4
3 5
4
0 0
0 2
0 4
2 2
1 2
2 3
2 4
 */