#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;
using i128 = __int128;
using ll = long long;
using ld = long double;

#define int ll

ll bin_pow(int a, int n, int k){
    i128 res = 1;
    while(n){
        if(res > k) return -1;
        if(n & 1){
            res *= a;
        }
        a *= a;
        n >>= 1;
    }
    return res;
}

void solve() {
    int n;
    cin>>n;
    int l = 0, r = 1e12+7;
    while(r-l>1){
        int m = (r+l)/2;
        cout << "? " << m << endl;
        int k;
        cin>>k;
        if(k > n) r = m;
        else l = m;
    }
    int opt = r;
    l = 0;
    r = 1e15+7;
    while(r-l>1){
        int m = (r+l)/2;
        cout << "? " << m << endl;
        int k;
        cin>>k;
        if(k > (n+1)) r = m;
        else l = m;
    }
    int opt1 = r;
    ll b = 0;
    for(int i = 1; i <= 2023; ++i){
        if(bin_pow(i, n, 1e18)*(i-1) == opt1-opt){
            b = i;
            break;
        }
    }
    cout << "! " << bin_pow(b, n, 1e18) - opt << " " << b << endl;
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout << fixed << setprecision(6);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}