#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>

#define sz(x) (long long)x.size()
#define pb push_back
#define fr first
#define sc second

using namespace std;
using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
vl prl, prs;
vvl v;
ll suma;
const ll INF = 1e18;

struct segtree {
	vl tr;
	ll s = 1;
	void init(ll n) { while (s < n)s *= 2; tr.assign(s * 2 - 1, 0); }
	void rem(ll ind, ll c, ll l, ll x, ll r) {
		if (r - l == 1) {
			tr[x] += c;
			return;
		}
		ll mid = (l + r) / 2;
		if (ind < mid)
			rem(ind, c, l, x * 2 + 1, mid);
		else
			rem(ind, c, mid, x * 2 + 2, r);
		tr[x] = tr[x * 2 + 1] + tr[x * 2 + 2];
	} void rem(ll ind, ll c) { rem(ind, c, 0, 0, s); }
	void sum(ll lx, ll x, ll rx, ll l, ll r, ll& su) {
		if (r <= lx || rx <= l)
			return;
		if (l <= lx && rx <= r) {
			su += tr[x];
			return;
		}
		ll mid = (lx + rx) / 2;
		sum(lx, x * 2 + 1, mid, l, r, su);
		sum(mid, x * 2 + 2, rx, l, r, su);
	} ll sum(ll l, ll r) { ll su = 0; sum(0, 0, s, l, r, su); return su; }
};

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n;
	segtree tree; tree.init(n);
	vector<char> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i]; if (i > 0 && a[i - 1] == a[i] && a[i] == 'b')tree.rem(i - 1, 1), tree.rem(i, 1);
	}
	int q; cin >> q;
	while (q--) {
		int gh; cin >> gh; if (gh == 1) {
			int c; cin >> c; c--;
			if (a[c] == 'a') {
				if(c > 0 && a[c-1]=='b')
					tree.rem(c - 1, 1), tree.rem(c, 1);
				if (c < n - 1 && a[c + 1] == 'b')
					tree.rem(c + 1, 1), tree.rem(c, 1);
			}
			else {
				if (c > 0 && a[c - 1] == 'b')
					tree.rem(c - 1, -1), tree.rem(c, -1);
				if (c < n - 1 && a[c + 1] == 'b')
					tree.rem(c + 1, -1), tree.rem(c, -1);
			}
		}
		else {
			int l, r; cin >> l >> r; int sum = tree.sum(l + 1, r);
			if (sum)cout << "NO\n"; else cout << "YES\n";
		}
	}
}