#include <bits/stdc++.h>

#define int long long
#define ld long double
using namespace std;

int MOD = 1000000000 + 7;

int binpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) return binpow((a * a) % MOD, n / 2);
    return (binpow(a, n - 1) * a) % MOD;
}


const int N = 3e5 + 13;
int facts[N];

int mul(int x, int y) {
    return (x * y) % MOD;
}

int divv(int x, int y) {
    return (x * binpow(y, MOD - 2)) % MOD;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> xs(n);
    for (int i = 0; i < n; ++i) cin >> xs[i];
    int a = 0, b = 0, c = 0;

    for (int x: xs) {
        if (x % 3 == 0) c++;
        if (x % 3 == 1) a++;
        if (x % 3 == 2) b++;
    }

    int ans = 0;

    if (a + b == 0) {
        cout << 0;
        return 0;
    }



    // start from 1
    if (a > 0) {
        bool good = true;
        int a1 = a;
        int b1 = b;
        --a1;
        int sum = 1;
        while (a1 + b1 > 0) {
            if (sum == 1) {
                if (a1 == 0) {
                    good = false;
                    break;
                }
                a1--;
                sum = 2;
            } else {
                if (b1 == 0) {
                    good = false;
                    break;
                }
                b1--;
                sum = 1;
            }
        }

        if (good) {
            ans++;
        }
    }


    // start from 2
    if (b > 0) {
        bool good = true;
        int a1 = a;
        int b1 = b;
        --b1;
        int sum = 2;
        while (a1 + b1 > 0) {
            if (sum == 1) {
                if (a1 == 0) {
                    good = false;
                    break;
                }
                a1--;
                sum = 2;
            } else {
                if (b1 == 0) {
                    good = false;
                    break;
                }
                b1--;
                sum = 1;
            }
        }

        if (good) {
            ans++;
        }
    }

    // C(b + c - 1 + a, a)

    facts[0] = 1;
    for (int i = 1; i < N; ++i) {
        facts[i] = (facts[i - 1] * i) % MOD;
    }


    ans = mul(ans, facts[a + b - 1 + c]);
    ans = divv(ans, facts[a + b - 1]);
    ans = divv(ans, facts[c]);
    ans = (ans * facts[a]) % MOD;
    ans = (ans * facts[b]) % MOD;
    ans = (ans * facts[c]) % MOD;
    cout << ans;

    return 0;
}
