#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
const ll MOD = 1e9+7;

map<ll, array<ll, 2>> fx[2], fy[2];
ll smx[2], smy[2];

void add(ll x, ll y, ll d){
    smx[x % 2] -= max(fx[x % 2][x][0], fx[x%2][x][1]);
    fx[x % 2][x][y % 2]+=d;
    smx[x % 2] += max(fx[x % 2][x][0], fx[x%2][x][1]);
    smy[y % 2] -= max(fy[y%2][y][0], fy[y%2][y][1]);
    fy[y % 2][y][x%2]+=d;
    smy[y % 2] += max(fy[y%2][y][0], fy[y%2][y][1]);
}

void solve() {
    fx[0] = {};
    fx[1] = {};
    fy[0] = {};
    fy[1] = {};
    smx[0]=0;
    smx[1]=0;
    smy[0]=0;
    smy[1]=0;
    ll n;
    cin >> n;
    set<array<ll, 2>> st;
    while(n--){
        ll x, y;
        cin >> x >> y;
        if (st.find({x, y}) != st.end()){
            add(x, y, -1);
            st.erase({x, y});
        }else{
            add(x, y, 1);
            st.insert({x, y});
        }
        cout << max({smx[0], smx[1], smy[0], smy[1]}) << "\n";
    }
}
