#include <iostream>
#include <vector>
#include <map>

using namespace std;


const int M = 1000000007;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n;
    cin >> n;
    if (n == 1 || n == 2) {
        cout << 1;
        return 0;
    }
    vector<vector<long long>> v(n + 1, vector<long long>(n, 0));
    for (int i = 0; i < n; i++) {
        v[0][i] = 1;
    }
    for (int i = 1; i < n; i++) {
        v[1][i] = 2;
    }
    v[1][1] = 1;
    for (int i = 2; i <= n; i++){
        for (int j = 1 ; j < n; j++){
            v[i][j] += v[i][j - 1];
            v[i][j] %= M;
            v[i][j] += v[i - 1][j - 1];
            v[i][j] %= M;
            v[i][j] += v[i - 2][j - 1];
            v[i][j] %= M;
        }
    }
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j < n; j++) {
//            cout << v[i][j] << " ";
//        }
//        cout << "\n";
//    }
    long long ans = 1;
    for (int i = 2; i <= n; i++) {
        ans *= v[i][i - 1];
        ans %= M;
    }
    cout << ans;
}
