#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<vector<ll>> dp(5001, vector<ll> (5001, 0));
    dp[0][0] = 1;
    dp[1][1] = 1;
    dp[1][0] = 1;
    for (int i = 1; i <= 5000; i++) {
        for (int j = 2; j <= 5000; j++) {
            for (int k = 0; k < 3; k++) {
                dp[i][j] = (dp[i - 1][j - k] + dp[i][j]) % MOD;
            }
        }
    }
    ll ans = 1;
    int n; cin >> n;
    for (int i = 0; i < n - 1; i++) {
        ans = (ans * dp[i + 1][i + 2]) % MOD;
    }
    cout << ans << "\n";
    return 0;
}
