#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fir first
#define sec second

int mod = 1e9 + 7;
vector<int> f(5000 + 1, 1), rf(5000 + 1);


int pow1(int a, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int now = pow1(a, p / 2);
        return now * now % mod;
    }
    int now = pow1(a, p - 1);
    return now * a % mod;
}

int c(int k, int n) {
    return f[n] * rf[k] % mod * rf[n - k] % mod;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        f[i] = f[i - 1] * i % mod;
    }
    for (int i = 0; i <= n; i++) {
        rf[i] = pow1(f[i], mod - 2);
    }
    int res = 1;
    for (int i = 2; i <= n; i++) {
        int all = 0;
        for (int j = 1; j * 2 <= i; j++) {
            int k = c(j, i - 1) * c(i - j * 2, i - 1 - j) % mod;
            all += k;
            if (all >= mod) {
                all -= mod;
            }
        }
        res = res * all % mod;
    }
    cout << res;
}