#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;

ll mod = 1e9 + 7;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t;
	cin >> t;

	ll cnt0 = 0, cnt1 = 0, cnt2 = 0;

	while (t--) {
        int x;
        cin >> x;
        x %= 3;
        if (x == 0) cnt0++;
        else if (x == 1) cnt1++;
        else if (x == 2) cnt2++;
	}

	if (cnt2 > cnt1) swap(cnt1, cnt2);

	if (cnt1 - cnt2 > 2 || cnt1 - cnt2 <= 0) {
        cout << 0;
        return 0;
	}

	if (cnt1 - cnt2 == 1) {
        ll n = cnt2;
        ll k = cnt0;
        ll res = 1;
        res = (res * (n + 1)) % mod;

        for (ll i = 1; i <= n; ++i) {
            res = (res * i) % mod;
            res = (res * i) % mod;
        }

        for (ll i = 2 * n + 1; i <= 2 * n + k; ++i) {
            res = (res * i) % mod;
        }

        cout << res;
	} else if (cnt1 - cnt2 == 2) {
	    ll n = cnt2;
        ll k = cnt0;
        ll res = 1;
        res = (res * (n + 2)) % mod;
        res = (res * (n + 1)) % mod;

        for (ll i = 1; i <= n; ++i) {
            res = (res * i) % mod;
            res = (res * i) % mod;
        }

        for (ll i = 2 * n + 2; i <= 2 * n + k + 1; ++i) {
            res = (res * i) % mod;
        }

        cout << res;
	}

	return 0;
}
