#include<bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9 + 17;

vector <vector <int>> g;
vector <int> p;
vector <int> h;
vector <int> dist;
vector <vector <int>> a;
vector <int> ans;

int tin[200005];
int tout[200005];

int tt = 0;
void dfs0(int v){
    tin[v] = tt++;
    for(auto u : g[v]){
        dfs0(u);
    }
    tout[v] = tt++;
}

void dfs(int v)
{
    h[v] = h[p[v]] + 1;
    a[h[v]].push_back(v);
    if (g[v].size() == 0)
        dist[v] = 0;
    for (auto u : g[v])
    {
        if (u != p[v])
        dfs(u);
        dist[v] = min(dist[v], dist[u]+1);
    }
}

bool check(int p, int v){
    if(tin[v] >= tin[p] && tout[v] <= tout[p])
        return true;
    return false;
}

void dfs2(int v, int depth, int p0)
{
    ans[v] = 0;
    for(auto u : g[v])
    {
        if(h[v] == depth){
            dfs2(u, h[v]+dist[v], v);
        }else{
            dfs2(u, depth, p0);
        }   
    }
    if (h[v] == depth) ans[p0] = max(ans[p0], ans[v] + 1);
    return;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    p.resize(n);
    h.resize(n);
    g.resize(n);
    dist.resize(n, INF);
    a.resize(n);
    ans.resize(n);

    int v;
    p[0] = 0;
    h[0] = -1;
    for (int i=1; i<n; i++)
    {
        cin >> v; v--;
        p[i] = v;
        g[v].push_back(i);
    }

    dfs(0);
    dfs0(0);

    dfs2(0, 0, 0);
    cout << ans[0]-1 << '\n';
    return 0;
}