#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<set>
#include<map>
#define int long long

using namespace std;
using ll = unsigned long long;
#define all(a) a.begin(), a.end()
ll X = 1e5;

ll f(ll st) {
	ll l = 0, r = X * X * X;
	while (r - l > 1) {
		ll m = l + (r - l) / 2;
		cout << "? " << m << endl;
		ll x;
		cin >> x;
		cout << endl;
		if (x > st) {
			r = m;
		}
		else {
			l = m;
		}
	}
	return r;
}


ll binpow(ll a, ll n) {
	if (n == 0) {
		return 1;
	}
	if (n == 1) {
		return a;
	}
	if (n % 2) {
		ll x = binpow(a, n / 2);
		return a * x * x;
	}
	ll x = binpow(a, n / 2);
	return x * x;
}

void solve() {
	X = X * X;
	ll n;
	cin >> n;
	cout << endl;
	ll st = f(n);
	ll en = f(n + 1);
	ll dif = en - st;
	ll osn = 0;
	for (ll i = 2; i <= 2023; ++i) {
		if (dif % i) continue;
		ll m = dif / i;
		while (m % i == 0) {
			m /= i;
		}
		if (m < i) {
			osn = i;
			break;
		}
	}
	ll first = binpow(osn, n) - st;
	cout << "! " << first << " " << osn << endl;
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	//#ifdef _DEBUG
	//  freopen("input.txt", "r", stdin);
	//  freopen("output.txt", "w", stdout);
	//#endif // _DEBUG

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}