#include<bits/stdc++.h>
using namespace std;

int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a +  b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

const int N = 5000 + 100;

int suff[N][N], pref[N][N];

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    suff[n + 1][0] = suff[n + 2][0] =1;
    for (int i = n; i; --i) {
        for (int j = 0; j <= n; ++j) suff[i][j] = suff[i + 1][j];
        for (int j = 0; j + i <= n; ++j) {
            suff[i][j + i] =add(suff[i][j + i], suff[i][j]);
        }
    }
    pref[0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) pref[i][j] = pref[i - 1][j];
        for (int j = 0; j + i <= n; ++j) {
            pref[i][j + i] = add(pref[i][j + i], pref[i][j]);
        }
        for (int j = 0; j <= n; ++j) pref[i][j] = sub(pref[i][j], pref[i - 1][j]);
    }
    int ans = 0;
    for (int mex = 1; mex <= n + 1; ++mex) {
        for (int sum_left = mex - 1; sum_left <= n; ++sum_left) {
            int sum_right = n - sum_left;
            int cl = pref[mex - 1][sum_left];
            int cr = suff[mex + 1][sum_right];
//            cout << mex << ' ' << sum_left << ' ' << cl << ' ' << cr << endl;
            ans = add(ans, mul(mex, mul(cl, cr)));
        }
    }
    cout << ans;
}