#include<bits/stdc++.h>
using namespace std;

int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a +  b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

int binpow(int a, int n) {
    int res = 1;
    for (; n; n >>= 1) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
    }
    return res;
}

struct segtree {
    int n;
    vector<int> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(vector<int>(2 * n, 0)) {}

    void update(int k, int x) {
        for (tr[k += n] = x; k; k >>= 1, tr[k] = max(tr[k << 1], tr[k << 1 | 1]));
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res,tr[l++]);
            if (~r & 1) res = max(res,tr[r--]);
        }
        return res;
    }
};

using ll = long long;

const int N = 1e6;
int fact[N], ifac[N];

int main() {
//    cin.tie(0)->sync_with_stdio(0);

    int n;
    while (cin >> n) {
        if (n == 0) break;
        string res(n, '#');
        auto go = [&](int k) -> void {
            int c1, c2;
            cout << "? " << k + 1 << " aa" << endl;
            cin >> c1;
            cout << "? " << k + 1 << " bb" << endl;
            cin >> c2;
            int c3 = 2 - c1 - c2;
            if (c1 == 2) {
                res[k] = 'a';
                res[k + 1] = 'a';
                cout << "? " << k + 2 << " aa" << endl;
                cin >> c1;
                cout << "? " << k + 2 << " ab" << endl;
                cin >> c2;
                if (c1 == 2) res[k + 2] = 'a';
                else if (c2 == 2) res[k + 2] = 'b';
                else res[k + 2] = 'c';
            } else if (c2 == 2) {

                res[k] = 'b';
                res[k + 1] = 'b';
                cout << "? " << k + 2 << " ba" << endl;
                cin >> c1;
                cout << "? " << k + 2 << " bb" << endl;
                cin >> c2;
                if (c1 == 2) res[k + 2] = 'a';
                else if (c2 == 2) res[k + 2] = 'b';
                else res[k + 2] = 'c';
            } else if (c3 == 2) {
                res[k] = 'c';
                res[k + 1] = 'c';
                cout << "? " << k + 2 << " ca" << endl;
                cin >> c1;
                cout << "? " << k + 2 << " cb" << endl;
                cin >> c2;
                if (c1 == 2) res[k + 2] = 'a';
                else if (c2 == 2) res[k + 2] = 'b';
                else res[k + 2] = 'c';
            } else {
                string ss;
                if (c1 == 1) ss.push_back('a');
                if (c2 == 1) ss.push_back('b');
                if (c3 == 1) ss.push_back('c');
                cout << "? " << k + 2 << ' ' << ss[0] << 'a' << endl;
                int xx;
                cin >> xx;
                if (xx == 0) {
                    res[k + 1] = ss[1];
                    res[k] = ss[0];
                    cout << "? " << k + 2 << ' ' << res[k + 1] << 'b' << endl;
                    cin >> xx;
                    if (xx == 2) res[k + 2] = 'b';
                    else res[k + 2] = 'c';
                } else if (xx == 2) {
                    res[k + 1] = ss[0];
                    res[k] = ss[1];
                    res[k + 2] = 'a';
                } else {
                    cout << "? " << k + 2 << ' ' << ss[0] << 'b' << endl;
                    cin >> xx;
                    if (xx == 2) {
                        res[k + 1] = ss[0];
                        res[k] = ss[1];
                        res[k + 2] = 'b';
                    } else if (xx == 0) {
                        res[k + 1] = ss[1];
                        res[k] = ss[0];
                        res[k + 2] = 'a';
                    } else {
                        res[k + 1] = ss[0];
                        res[k] = ss[1];
                        res[k + 2] = 'c';
                    }
                }
            }
        };
        for (int i = 0; i * 3 + 2 < n; ++i) {
            go(i * 3);
        }
        if (n % 3 == 0) {}
        else if (n % 3 == 1) {
            int c1, c2;
            cout << "? " << n - 1 << ' ' << res[n - 2] << 'a' << endl;
            cin >> c1;
            cout << "? " << n - 1 << ' ' << res[n - 2] << 'b' << endl;
            cin >> c2;
            if (c1 == 2) res.back() = 'a';
            else if (c2 == 2) res.back() = 'b';
            else res.back() = 'c';
        } else {
            int k = n - 2;
            int c1, c2;
            cout << "? " << k + 1 << " aa" << endl;
            cin >> c1;
            cout << "? " << k + 1 << " bb" << endl;
            cin >> c2;
            int c3 = 2 - c1 - c2;
            if (c1 == 2) {
                res[k] = 'a';
                res[k + 1] = 'a';
            } else if (c2 == 2) {

                res[k] = 'b';
                res[k + 1] = 'b';
            } else if (c3 == 2) {
                res[k] = 'c';
                res[k + 1] = 'c';
            } else {
                string ss;
                if (c1 == 1) ss.push_back('a');
                if (c2 == 1) ss.push_back('b');
                if (c3 == 1) ss.push_back('c');
                cout << "? " << k + 1 << ' ' << ss << endl;
                int x;
                cin >> x;
                if (x == 0) reverse(ss.begin(), ss.end());
                res[n - 2] = ss[0];
                res[n - 1] = ss[1];
            }
        }
        cout << "! " << res << endl;
    }
}