#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
typedef long long ll;

ll mod = 1e9 + 7;

ll fact(ll n) {
	ll ans = 1;
	for (ll i = 2; i <= n; i++) {
		ans *= i;
		ans %= mod;
	}
	return ans;
}

ll bin_pow(ll a, ll n) {
	if (n == 0) return 1;
	if (n % 2 == 1) {
		return a * bin_pow(a, n - 1) % mod;
	}
	else {
		ll b = bin_pow(a, n / 2);
		return b * b % mod;
	}
}

ll C(ll n, ll k) {
	return ((fact(n) * bin_pow(fact(k), mod - 2)) % mod * bin_pow(fact(n - k), mod - 2)) % mod;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	vector <ll> a(n);
	ll kol0 = 0, kol1 = 0, kol2 = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] % 3 == 0) kol0++;
		else if (a[i] % 3 == 1) kol1++;
		else kol2++;
	}
	if (abs(kol1 - kol2) == 1) {
		ll ans = 1;
		ans = ans * fact(kol1) % mod;
		ans = ans * fact(kol2) % mod;
		ans = ans * C(n - 1, kol1 + kol2 - 1) % mod;
		cout << ans;
	}
	else if (abs(kol1 - kol2) == 2) {
		if (kol1 != 0 && kol2 != 0) { cout << 0; return 0; }ll ans = 1;
		ans = ans * fact(kol1) % mod;
		ans = ans * fact(kol2) % mod;
		ans = ans * C(n - 1, kol1 + kol2 - 1) % mod;
		cout << ans;
	}
	else cout << 0;
	return 0;
}