#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;
#define ll long long
#define vll vector<ll>
#define vi vector<int>
#define eol '\n'
#define Fastio(){ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);}

#define print(arr){for(auto x: arr){cout << x << " ";} cout << '\n';}
const int mod = 1e9 + 7;

ll binpowmod(ll a, ll n) {
    if (n < 0) return 0;
    if (a == 0) return 0;
    if (n == 0) return 1;
    if (n & 1) return a * binpowmod(a, n - 1) % mod;
    ll d = binpowmod(a, n >> 1);
    return d * d % mod;
}

void solve_d() {
    int n;
    cin >> n;
    vll dp(n+1, 0);
    dp[0] = 0;
    dp[1] = 1;
    dp[2] = 1;
    dp[3] = 2;
    for (int i = 4; i <= n; i++){
        dp[i] = (dp[i-1] * 2 * (i-1)) % mod;
    }
    cout << dp[n];
}

void solve_f() {
    /*int n;
    cin >> n;

    vll sum_hor(n, 0);
    vll sum_vert(n, 0);
    vector<vll > a(n, vll(n));
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll x;
            cin >> x;
            sm += x;
            a[i][j] = x;
            sum_hor[i] += x;
            sum_vert[j] += x;
        }
    }
    sm /= n;
//
//    print(sum_hor);
//    print(sum_vert);
    vi ii, jj;
    for (int i = 0; i < n; i++) {
        if (sum_hor[i] != sm) {
            ii.push_back(i);
        }
        if (sum_vert[i] != sm) {
            jj.push_back(i);
        }
    }
//    print(ii)
//    print(jj)
//    cout << "___________\n\n";



    if (ii.size() == 0) {
        for (int i = 0; i < n; i++) {
            if (sum_vert[jj[0]] - a[i][jj[0]] + a[i][jj[1]] == sm) {
                cout << i + 1 << " " << jj[0] + 1 << eol << i + 1 << " " << jj[1] + 1 << eol;
                return;
            }
        }
    }
    if (jj.size() == 0) {
        for (int j = 0; j < n; j++) {
            if (sum_hor[ii[0]] - a[ii[0]][j] + a[ii[1]][j] == sm) {
                cout << ii[0] + 1 << " " << j + 1 << eol << ii[1] + 1 << " " << j + 1 << eol;
                return;
            }
        }
    }

    int i1 = ii[0], j1 = jj[0], i2 = ii[1], j2 = jj[1];

    if (sum_vert[i1] - a[i1][j1] + a[i2][j2] == sm) {
        cout << i1 + 1 << " " << j1 + 1 << eol << i2 + 1 << " " << j2 + 1 << eol;
        return;
    }
    if (sum_vert[i1] - a[i1][j2] + a[i2][j1] == sm) {
        cout << i1 + 1 << " " << j2 + 1 << eol << i2 + 1 << " " << j1 + 1 << eol;
    }*/

    int n; cin >> n;
    ll exp_sum = n * (n * n + 1) / 2;
    vector<vector<ll>> matrix(n, vector<ll>(n));
    vector<ll> sum_col(n, 0), sum_ray(n, 0);
    for (auto& e : matrix) for (auto& ee : e) cin >> ee;
    for (int col = 0; col < n; ++col){
        for (int ray = 0; ray < n; ++ray) sum_col[col] += matrix[col][ray];
    }
    for (int ray = 0; ray < n; ++ray){
        for (int col = 0; col < n; ++ col) sum_ray[ray] += matrix[col][ray];
    }

    vector<int> wrong_col(0), wrong_ray(0);
    for (int i = 0; i < n; ++i){
        if (sum_ray[i] != exp_sum) wrong_ray.push_back(i);
        if (sum_col[i] != exp_sum) wrong_col.push_back(i);
    }

    if (wrong_ray.size() == 2 && wrong_col.size() == 2){
        int x1 = wrong_col[0];
        int x2 = wrong_col[1];
        int y1 = wrong_ray[0];
        int y2 = wrong_ray[1];
        if (sum_col[x1] - matrix[x1][y1] + matrix[x2][y2] == exp_sum){
            cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
            return;
        }
        else{
            cout << x1 + 1 << ' ' << y2 + 1 << '\n' << x2 + 1 << ' ' << y1 + 1;
            return;
        }
    }

    for (auto e : wrong_ray) cout << e << ' ';
    //cout <<

    if (wrong_ray.empty()){
        cout << 1;
        int x1 = wrong_col.front(), x2 = wrong_col.back();
        for (int ray = 0; ray < n; ++ray){
            if (sum_col[x1] - matrix[ray][x1] + matrix[ray][x2]){
                cout << x1 + 1 << ' ' << ray + 1 << '\n' << x2 + 1 << ' ' << ray + 1;
                return;
            }
        }
    }
    if (wrong_col.empty()){

    }


}

int main() {
    Fastio();
    solve_d();
}
