#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
    ll n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

    vector<ll> sumh(n);

    int r1 = -1, r2 = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            sumh[i] += a[i][j];
        }

        if (sumh[i] > n * (n * n + 1) / 2) {
            r1 = i + 1;
        }
        if (sumh[i] < n * (n * n + 1) / 2) {
            r2 = i + 1;
        }
    }

    vector<ll> sumv(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            sumv[j] += a[i][j];
        }
    }

    int c1 = -1, c2 = -1;
    for (int i = 0; i < n; ++i) {
        if (sumv[i] > n * (n * n + 1) / 2) {
            c1 = i + 1;
        }
        if (sumv[i] < n * (n * n + 1) / 2) {
            c2 = i + 1;
        }
    }

    if (r1 != -1 && c1 != -1) {
        cout << r1 << ' ' << c1 << '\n' << r2 << ' ' << c2 << '\n';
        return 0;
    }

    if (r1 == -1) {
        for (int i = 0; i < n; ++i) {
            if (sumv[c2 - 1] - sumv[c1 - 1] == 2LL * (a[i][c2 - 1] - a[i][c1 - 1])) {
                r1 = r2 = i + 1;
            }
        }

        cout << r1 << ' ' << c1 << '\n' << r2 << ' ' << c2 << '\n';
        return 0;
    }

    if (c1 == -1) {
        for (int i = 0; i < n; ++i) {
            if (sumh[r2 - 1] - sumh[r1 - 1] == 2LL * (a[r2 - 1][i] - a[r1 - 1][i])) {
                c1 = c2 = i + 1;
            }
        }

        cout << r1 << ' ' << c1 << '\n' << r2 << ' ' << c2 << '\n';
        return 0;
    }

    cout << 1 << ' ' << 1 << '\n' << n << ' ' << n << '\n';
}