#include <bits/stdc++.h>

using namespace std;
#define ll long long
//#define int long long
#define pb push_back
bool find(const string &s,const string t){
    if(s.size()<t.size()){
        return false;
    }
    for(int i=0;i<=s.size()-t.size();i++){
        bool b=true;
        for(int j=0;j<t.size();j++){
            if(s[i+j]!=t[j]){
                b=false;
                break;
            }
        }
        if(b){
            return true;
        }
    }
    return false;
}
struct Node{
    int suf;
    int pref;
    int mx;
    int len;
    int cnta;
    int cntb;
    bool b;
    string pr;
    string sf;
    Node(){
        suf=0;
        pref=0;
        mx=0;
        len=0;
        cnta=0;
        cntb=0;
        b=false;
        pr="";
        sf="";
    }
    Node(char c){
        if(c=='b'){
            suf=1;
            pref=1;
            mx=1;
            len=1;
            cnta=0;
            cntb=1;
            b=false;
            pr="b";
            sf="b";
        }else{
            suf=0;
            pref=0;
            mx=0;
            len=1;
            cnta=1;
            cntb=0;
            b=false;
            pr="a";
            sf="a";
        }
    }
    Node operator+(const Node &oth)const{
        Node ans=Node();
        ans.len=len+oth.len;
        if(pref==len){
            ans.pref=len+oth.pref;
        }else{
            ans.pref=pref;
        }
        if(oth.suf==oth.len){
            ans.suf=suf+oth.len;
        }else{
            ans.suf=oth.suf;
        }
        ans.mx=max(max(mx,oth.mx),suf+oth.pref);
        ans.cnta=cnta+oth.cnta;
        ans.cntb=cntb+oth.cntb;
        ans.pr=pr;
        for(int i=0;i<oth.pr.size() && ans.pr.size()<4;i++){
            ans.pr.pb(oth.pr[i]);
        }
        for(int i=max(0,(int)sf.size()-(4-(int)oth.sf.size()));i<sf.size();i++){
            ans.sf.pb(sf[i]);
        }
        ans.sf+=oth.sf;
        if(b || oth.b || find(sf+oth.pr,"bbabb") || find(ans.pr,"babb") || find(ans.sf,"bbab")){
            ans.b=true;
        }else{
            ans.b=false;
        }
        return ans;
    }
};
const int N=1e5+10;
string s;
Node tree[4*N];
void build(int v,int tl,int tr){
    if(tr-tl==1){
        tree[v]=Node(s[tl]);
    }else{
        int tm=(tl+tr)/2;
        build(2*v,tl,tm);
        build(2*v+1,tm,tr);
        tree[v]=tree[2*v]+tree[2*v+1];
    }
}
void change(int v,int tl,int tr,int idx){
    if(tr<=idx || idx<tl){
        return;
    }
    if(tr-tl==1){
        s[tl]=(int)'a'+(int)'b'-(int)s[tl];
        tree[v]=Node(s[tl]);
        return;
    }
    int tm=(tl+tr)/2;
    change(2*v,tl,tm,idx);
    change(2*v+1,tm,tr,idx);
    tree[v]=tree[2*v]+tree[2*v+1];
}
Node get(int v,int tl,int tr,int l,int r){
    if(r<=tl || tr<=l){
        return Node();
    }
    if(l<=tl && tr<=r){
        return tree[v];
    }
    int tm=(tl+tr)/2;
    Node a=get(2*v,tl,tm,l,r);
    Node b=get(2*v+1,tm,tr,l,r);
    if(a.len==0){
        return b;
    }
    if(b.len==0){
        return a;
    }
    return a+b;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    cin >> s;
    build(1,0,n);
    int q;
    cin >> q;
    while(q--){
        int type;
        cin >> type;
        if(type==1){
            int i;
            cin >> i;
            change(1,0,n,i-1);
        }else{
            int l,r;
            cin >> l >> r;
            Node ans=get(1,0,n,l-1,r);
            if(ans.mx>=3 || ans.pref>=2 || ans.suf>=2 || ans.cnta<ans.cntb || ans.b){
                cout << "NO\n";
            }else{
                cout << "YES\n";
            }
        }
    }
    return 0;
}