#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()

using namespace std;

#define int ll

bool check(vector<vector<int>> a, int n){
    set<ll> st;
    for(int i = 0; i < n; ++i){
        ll sum = 0;
        for(auto x : a[i]){

            sum += x;
        }
        st.insert(sum);
    }
    for(int j = 0; j < n; ++j){
        ll sum = 0;
        for(int i = 0; i < n; ++i){
            sum += a[i][j];
        }
        st.insert(sum);
    }
    return len(st) == 1;
}

void solve(){
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j) cin >> a[i][j];
    }
    set<ll> st;
    vector<ll> sumst(n);
    vector<ll> sumcol(n);
    set<ll> col;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            sumst[i] += a[i][j];
            sumcol[j] += a[i][j];
        }
    }
    for(int i = 0; i < n; ++i){
        st.insert(sumst[i]);
        col.insert(sumcol[i]);
    }
    if(len(st) > 1 && len(col) > 1){
        vector<int> str;
        vector<int> cc;
        for(int i = 0; i < n; ++i){
            if(sumst[i] == *st.begin()){
                str.push_back(i);
            }
            if(sumst[i] == *st.rbegin()){
                str.push_back(i);
            }
        }
        for(int i = 0; i < n; ++i){
            if(sumcol[i] == *col.begin()){
                cc.push_back(i);
            }
            if(sumcol[i] == *col.rbegin()){
                cc.push_back(i);
            }
        }
        swap(a[str[0]][cc[0]], a[str[1]][cc[1]]);
        if(check(a, n)){
            cout << str[0] + 1 << ' ' << cc[0] + 1 << '\n';
            cout << str[1] + 1 << ' ' << cc[1] + 1 << '\n';
        }
        swap(a[str[0]][cc[0]], a[str[1]][cc[1]]);
        swap(a[str[0]][cc[1]], a[str[1]][cc[0]]);
        if(check(a, n)){
            cout << str[0] + 1 << ' ' << cc[1] + 1 << '\n';
            cout << str[1] + 1 << ' ' << cc[0] + 1 << '\n';
        }
        return;
    }
    if(len(st) == 1){
        ll mmin = *col.begin();
        ll mmax = *col.rbegin();
        ll indmin = 0;
        ll indmax = 0;
        for(int i = 0; i < n; ++i){
            if(sumcol[i] == mmin){
                indmin = i;
            }
            if(sumcol[i] == mmax){
                indmax = i;
            }
        }
        ll mid = (mmax + mmin) / 2;
        for(int i = 0; i < n; ++i){
            if(sumcol[indmin] - a[i][indmin] + a[i][indmax] == mid){
                cout << i + 1 << ' ' << indmax + 1 << '\n';
                cout << i + 1 << ' ' << indmin + 1 << '\n';
                return;
            }
        }
    }
    else{
        ll mmin = *st.begin();
        ll mmax = *st.rbegin();
        ll indmin = 0;
        ll indmax = 0;
        for(int i = 0; i < n; ++i){
            if(sumst[i] == mmin){
                indmin = i;
            }
            if(sumst[i] == mmax){
                indmax = i;
            }
        }
        ll mid = (mmax + mmin) / 2;
        for(int i = 0; i < n; ++i){
            if(sumst[indmin] - a[indmin][i] + a[indmax][i] == mid){
                cout << indmax + 1 << ' ' << i + 1 << '\n';
                cout << indmin + 1 << ' ' << i + 1 << '\n';
                return;
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}