//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int fac[maxn], rfac[maxn];
int bp(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) n--, res = res * a % mod;
        else n /= 2, a = a * a % mod;
    }
    return res;
}

int f(int n) {
    if (n == 1)return 1;
    int prev = f(n - 1), ans = 0;
    for (int k2 = 0; k2 * 2 <= n; ++k2) {
        int k1 = n - k2 * 2;
        if (k1 + k2 > n - 1) continue;
        int k0 = n - 1 - k1 - k2;
        ans = (ans + (fac[n - 1] * rfac[k0] % mod * rfac[k1] % mod * rfac[k2] % mod)) % mod;
    }
    return ans * prev % mod;
}

void solve() {
    int n;
    cin >> n;
    fac[0] = 1;
    for (int i = 1; i <= n; ++i) {
        fac[i] = fac[i - 1] * i % mod;
    }
    rfac[n] = bp(fac[n], mod - 2);
    for (int i = n - 1; i >= 0; --i) {
        rfac[i] = rfac[i + 1] * (i + 1) % mod;
    }
    rfac[0] = 1;
    cout << f(n);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}