#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
const ll N = 1e3 + 100;
int a[N][N];
int n;

bool check() {
    set<int> is, js;
    vector<int> isums(n), jsums(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            isums[i] += a[i][j];
            jsums[j] += a[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        is.insert(isums[i]);
        js.insert(jsums[i]);
    }
    return is.size() == 1 && js.size() == 1 && *is.begin() == *js.begin();
}

void solve() {
    cin >> n;
    vector<int> isums(n), jsums(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            isums[i] += a[i][j];
            jsums[j] += a[i][j];
        }
    }
    if (n <= 5) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < n; y++) {
                        if (i == x && j == y) continue;
                        swap(a[i][j], a[x][y]);
                        if (check()) {
                            cout << i + 1 << " " << j + 1 << endl;
                            cout << x + 1 << " " << y + 1 << endl;
                            return;
                        }
                        swap(a[i][j], a[x][y]);

                    }
                }
            }
        }
        return;
    }
    vector<int> x, y;
    map<int, vector<int>> m1, m2;
    for (int i = 0; i < n; i++) {
        m1[isums[i]].push_back(i);
        m2[jsums[i]].push_back(i);
    }
    for (auto [key, val]: m1) {
        if (val.size() == 2) {
            x.push_back(val[0] + 1);
            x.push_back(val[1] + 1);
        } else if (val.size() == 1) {
            x.push_back(val[0] + 1);
        }
    }
    for (auto [key, val]: m2) {
        if (val.size() == 2) {
            y.push_back(val[0] + 1);
            y.push_back(val[1] + 1);
        } else if (val.size() == 1) {
            y.push_back(val[0] + 1);
        }
    }
    int must = (n * n + 1) * n / 2;
    if (x.size() == 0) {
        for (int i = 0; i < n; i++) {
            if (jsums[y[0] - 1] + a[i][y[1] - 1] - a[i][y[0] - 1] == must && jsums[y[1] - 1] + a[i][y[0] - 1] - a[i][y[1] - 1] == must) {
                cout << i + 1 << " " << y[0] << endl;
                cout << i + 1 << " " << y[1] << endl;
                return;
            }
        }
    } else if (y.size() == 0) {
        for (int j = 0; j < n; j++) {
            if (isums[x[0] - 1] + a[x[1] - 1][j] - a[x[0] - 1][j] == must && isums[x[1] - 1] + a[x[0] - 1][j] - a[x[1] - 1][j] == must ) {
                cout << x[0] << " " << j + 1 << endl;
                cout << x[1] << " " << j + 1 << endl;
                return;
            }
        }
    } else {
        swap(a[x[0] - 1][y[0] - 1], a[x[1] - 1][y[1] - 1]);
        if (check()) {
            cout << x[0] << " " << y[0] << endl;
            cout << x[1] << " " << y[1] << endl;
        } else {
            cout << x[0] << " " << y[1] << endl;
            cout << x[1] << " " << y[0] << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
//    cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
