#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll inf = 2e18, mod = 1e9 + 7;

ll pw(ll x, ll st) {
    if (st == 0) {
        return 1;
    }
    if (st == 1) {
        return x;
    }
    ll t = pw(x, st / 2);
    if (st % 2) {
        return t * t % mod * x % mod;
    }
    return t * t % mod;
}

ll f(ll x) {
    ll ans = 1;
    for (ll i = 2; i <= x; i++) {
        ans = (ans * i) % mod;
    }
    return ans;
}

ll mul(ll x, ll y) {
    return x * y % mod;
}

ll del(ll x, ll y) {
    return mul(x, pw(y, mod - 2));
}

void solve() {
    ll u, i, w;
    cin >> u;
    ll c0 = 0, c1 = 0, c2 = 0;
    for (i = 0; i < u; i++) {
        cin >> w;
        w %= 3;
        if (w == 0) {
            c0 ++;
        }
        else if (w == 1) {
            c1 ++;
        }
        else {
            c2 ++;
        }
    }
    ll ans = 0;
    ll n = c1 + c2;
    ll k = c0;
    ll t = mul(mul(f(c1), f(c2)), del(del(f(n + k - 1), f(k)), f(n - 1)));
    t = mul(t, f(c0));
    if (c1 - c2 == 1 || c1 - c2 == 2) {
        ans = t;
    }
    else if (c2 - c1 == 1 || c2 - c1 == 2) {
        ans = t;
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}


