#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template<typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#define int ll

void solve() {
    ll n, mod = 1e9 + 7;
    cin >> n;

    ll k = 1;
    while (k * (k - 1) / 2 <= n) k++;
    k += 100;

    vector<vector<ll>> cntl(k, vector<ll>(n + 1)), cntr(k, vector<ll>(n + 1));

    for (int i = 0; i <= n; i += 1) cntl[0][i] = 1;
    for (int i = 0; i <= n; i += k) cntr[k - 1][i] = 1;

    for (int i = 1; i < k; i++) {
        forn(need, n + 1) {
            for (int j = need; j >= 0; j -= i + 1) cntl[i][need] += cntl[i - 1][j], cntl[i][need] %= mod;
        }
    }

    for (int i = k - 2; i >= 0; i--) {
        forn(need, n + 1) {
            for (int j = need; j >= 0; j -= i + 1) cntr[i][need] += cntr[i + 1][j], cntr[i][need] %= mod;
        }
    }

//    forn(i, k) forn(j, n + 1) cerr << cntl[i][j] << " \n"[j == n];
//    cerr << nl;
//    forn(i, k) forn(j, n + 1) cerr << cntr[i][j] << " \n"[j == n];
//    cerr << nl;

    ll ans = cntr[1][n] % mod;
    for (int i = 1; i < k; i++) {
        ll ost = n - i * (i + 1) / 2;
        forn(k1, ost + 1) {
            ans += (i + 1) * cntl[i - 1][k1] % mod * cntr[i + 1][ost - k1] % mod;
            ans %= mod;
        }
    }
    cout << ans << nl;
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}

