#include <bits/stdc++.h>
using namespace std;
 
#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if(false) cerr
#endif
 
typedef long long ll;

struct FixedY {
    int f;
    map<int, array<int, 2>> cnt;
    set<pair<int, int>> s;
    int skill = 0;
    FixedY(int _f) : f(_f) {}
    void add(int x, int y) {
        if ((y & 1) != f) return;
        if (s.find(pair<int, int>(x, y)) == s.end()) {
            s.insert({x, y});
            if (cnt.find(y) == cnt.end()) {
                cnt[y] = array<int, 2>{0, 0};
            }
            auto elem = cnt[y];
            skill -= max(elem[0], elem[1]);
            elem[x & 1] += 1;
            skill += max(elem[0], elem[1]);
            cnt[y] = elem;
        } else {
            s.erase({x, y});
            auto elem = cnt[y];
            skill -= max(elem[0], elem[1]);
            elem[x & 1] -= 1;
            skill += max(elem[0], elem[1]);
            cnt[y] = elem;
        }
    }
};
 
int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    FixedY a(0), b(1), u(0), v(1);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a.add(x, y);
        b.add(x, y);
        u.add(y, x);
        v.add(y, x);
        cout << max({a.skill, b.skill, u.skill, v.skill}) << '\n';
    }
    return 0;
}