#include <bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    int S = n * (n * n + 1) / 2;
    vector<int> rows, cols;
    for (int i = 0; i < n; i++) {
        int cur = S;
        for (int j = 0; j < n; j++) {
            cur -= a[i][j];
        }
        if (cur != 0) {
            rows.push_back(i);
        }
    }
    for (int i = 0; i < n; i++) {
        int cur = S;
        for (int j = 0; j < n; j++) {
            cur -= a[j][i];
        }
        if (cur != 0) {
            cols.push_back(i);
        }
    }
    if (rows.empty() && cols.empty()) {
        assert(false);
        cout << "1 1\n1 1\n";
        exit(0);
    }
    if (rows.empty()) {
        assert(cols.size() == 2);
        map<int, int> values;
        int S1 = 0, S2 = 0;
        for (int i = 0; i < n; i++) {
            values[a[i][cols[1]]] = i;
            S1 += a[i][cols[0]];
            S2 += a[i][cols[1]];
        }
        for (int i = 0; i < n; i++) {
            if (values.count(S - S1 + a[i][cols[0]])) {
                int j = values[S - S1 + a[i][cols[0]]];
                cout << 1 + i << " " << 1 + cols[0] << "\n" << 1 + j << " " << 1 + cols[1] << "\n";
                exit(0);
            }
        }
    }
    if (cols.empty()) {
        assert(rows.size() == 2);
        map<int, int> values;
        int S1 = 0, S2 = 0;
        for (int i = 0; i < n; i++) {
            values[a[rows[1]][i]] = i;
            S1 += a[rows[0]][i];
            S2 += a[rows[1]][i];
        }
        for (int i = 0; i < n; i++) {
            if (values.count(S - S1 + a[rows[0]][i])) {
                int j = values[S - S1 + a[rows[0]][i]];
                cout << 1 + rows[0] << " " << 1 + i << "\n" << 1 + rows[1] << " " << 1 + j << "\n";
                exit(0);
            }
        }
    }
    assert(cols.size() == 2);
    assert(rows.size() == 2);
    for (int x = 0; x < 2; x++) {
        for (int y = 0; y < 2; y++) {
            int x1 = rows[x], y1 = cols[y], x2 = rows[x ^ 1], y2 = cols[y ^ 1];
            vector<vector<int>> b = a;
            swap(b[x1][y1], b[x2][y2]);
            bool good = true;
            for (int i = 0; i < n; i++) {
                int cur = S;
                for (int j = 0; j < n; j++) {
                    cur -= b[i][j];
                }
                if (cur != 0) {
                    good = false;
                }
            }
            for (int i = 0; i < n; i++) {
                int cur = S;
                for (int j = 0; j < n; j++) {
                    cur -= b[j][i];
                }
                if (cur != 0) {
                    good = false;
                }
            }
            if (good) {
                cout << 1 + x1 << " " << 1 + y1 << "\n" << 1 + x2 << " " << 1 + y2 << "\n";
                exit(0);
            }
        }
    }
}
