#include <bits/stdc++.h>

#define int long long
using namespace std;

int ask(int x) {
    int ans;
    cout << "? " << x << endl;
    cin >> ans;
    return ans;
}

int binpow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1)
            ans = ans * n;
        n = n * n;
        p >>= 1;
    }
    return ans;
}

void solve() {
    int x;
    cin >> x;
    int l = 2, r = 2;

    while (r < 2023) {
        int cur = 1e9, cnt = 0;
        while (cur)
            cur /= (r + 1), cnt++;
        if (cnt < x)
            break;
        r++;
    }
    while (l < r - 1) {
        int m = (l + r) / 2;
        int nw = ask(binpow(m, x));
        if (nw >= x + 1)
            r = m;
        else
            l = m + 1;
    }
    while (l < r && ask(binpow(l, x + 1)) < x + 2)
        l++;
    int b = l;
    int my = 0, lft = binpow(b, x) * (b - 1);
    for (int i = x - 1; i >= 0; i--) {
        l = 1, r = b;
        int cur = binpow(b, i);
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (ask(m * cur + lft) < x + 2)
                l = m + 1;
            else
                r = m;
        }
        while (l < r && ask(l * cur + lft) < x + 2)
            l++;
        lft += (l - 1) * cur;
        my += (b - l) * cur;
//        cout << l << ' ' << cur << ' \n';
    }
    cout << "! " << my << ' ' << b << endl;
}

main(){
    solve();

    return 0;
}
