#include <bits/stdc++.h>

#define int long long
using namespace std;
const int N = 1e5 + 10;
string s;
int a[4 * N], bf[4 * N], bl[4 * N], bo[4 * N];

void build(int v, int l, int r) {
    if (l == r) {
        if (s[l] == 'a') {
            a[v] = 1;
        }
        bf[v] = 1;
        bl[v] = 1;
        bo[v] = 0;
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    if (a[2 * v] == 1 && a[2 * v + 1] == 1)a[v] = 1;
    if (bl[2 * v] == 1 && bf[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b')) {
        a[v] = 1;
    }
    if (a[2 * v] == 1 && bl[2 * v + 1] == 1 ||
        bl[2 * v] == 1 && bo[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))
        bl[v] = 1;
    if (bf[2 * v] == 1 && a[2 * v + 1] == 1 ||
        bo[2 * v] == 1 && bf[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))
        bf[v] = 1;
    if (bf[2 * v] == 1 && bl[2 * v + 1] == 1 ||
        bo[2 * v] == 1 && bo[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))
        bo[v] = 1;
    if (l == r - 1)bo[v] = 1;
}

void upd(int v, int l, int r, int x) {
    if (l == r) {
        if (s[l] == 'a')s[l] = 'b';
        else s[l] = 'a';
        a[v]++;
        a[v] %= 2;
        bf[v] = 1;
        bl[v] = 1;
        bo[v] = 0;
        return;
    }
    int m = l + (r - l) / 2;
    if (x <= m)upd(2 * v, l, m, x);
    else upd(2 * v + 1, m + 1, r, x);
    if (a[2 * v] == 1 && a[2 * v + 1] == 1)a[v] = 1;
    if (bl[2 * v] == 1 && bf[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b')) {
        a[v] = 1;
    }
    if (a[2 * v] == 1 && bl[2 * v + 1] == 1 ||
        bl[2 * v] == 1 && bo[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))
        bl[v] = 1;
    if (bf[2 * v] == 1 && a[2 * v + 1] == 1 ||
        bo[2 * v] == 1 && bf[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))
        bf[v] = 1;
    if (bf[2 * v] == 1 && bl[2 * v + 1] == 1 ||
        bo[2 * v] == 1 && bo[2 * v + 1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))
        bo[v] = 1;
    if (l == r - 1)bo[v] = 1;
}

vector<int> ga(int v, int l, int r, int l1, int r1) {
    if (l >= l1 && r <= r1) {
        return {a[v], bf[v], bl[v], bo[v]};
    }
    if (l > r1 || r < l1) {
        return {-1};
    }
    int m = l + (r - l) / 2;
    vector<int> v1 = ga(2 * v, l, m, l1, r1), v2 = ga(2 * v + 1, m + 1, r, l1, r1);
    int a1 = 0, bf1 = 0, bl1 = 0, bo1 = 0;
    if (v1[0] == -1)return v2;
    else if (v2[0] == -1)return v1;
    if (v1[0] == 1 && v2[0] == 1)a1 = 1;
    if (v1[2] == 1 && v2[1] == 1 && (s[m] != 'b' || s[m + 1] != 'b')) {
        a1 = 1;
    }
    if (v1[0] == 1 && v2[2] == 1 || v1[2] == 1 && v2[3] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))bl1 = 1;
    if (v1[1] == 1 && v2[0] == 1 || v1[3] == 1 && v2[1] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))bf1 = 1;
    if (v1[1] == 1 && v2[2] == 1 || v1[3] == 1 && v2[3] == 1 && (s[m] != 'b' || s[m + 1] != 'b'))bo1 = 1;
    if (l == r - 1)bo1 = 1;
    return {a1, bf1, bl1, bo1};
}

signed main() {
    int n, m, i, j;
    cin >> n;
    cin >> s;
    build(1, 0, n - 1);
    int t, tt, x, y;
    cin >> t;
    while (t--) {
        cin >> tt;
        if (tt == 1) {
            cin >> x;
            upd(1, 0, n - 1, x - 1);
        } else {
            cin >> x >> y;
            vector<int> q = ga(1, 0, n - 1, x - 1, y - 1);
            if (q[0] == 1)cout << "YES\n";
            else cout << "NO\n";
        }
    }
    return 0;
}
