#include <bits/stdc++.h>
using namespace std;

#define int long long
#define sz(a) ((int) (a).size())

signed main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    auto check = [&]() -> bool {
        vector<int> col(n), row(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                col[j] += a[i][j];
                row[i] += a[i][j];
            }
        }
        sort(col.begin(), col.end());
        sort(row.begin(), row.end());
        return col[0] == col.back() && row[0] == row.back() && row[0] == col[0];
    };
    vector<int> col(n), row(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            col[j] += a[i][j];
            row[i] += a[i][j];
        }
    }
    int need = n * (n * n + 1) / 2;
    vector<int> badcol, badrow;
    for (int i = 0; i < n; ++i) {
        if (row[i] != need) {
            badrow.push_back(i);
        }
        if (col[i] != need) {
            badcol.push_back(i);
        }
    }
    if (sz(badcol) == 2 && sz(badrow) == 2) {
        for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < 2; ++j) {
                swap(a[badrow[i]][badcol[j]], a[badrow[1 - i]][badcol[1 - j]]);
                if (check()) {
                    cout << badrow[i] + 1 << " " << badcol[j] + 1 << '\n';
                    cout << badrow[1 - i] + 1 << " " << badcol[1 - j] + 1 << '\n';
                    return 0;
                }
                swap(a[badrow[i]][badcol[j]], a[badrow[1 - i]][badcol[1 - j]]);
            }
        }
    } else if (sz(badcol) == 2) {
        for (int i = 0; i < n; ++i) {
            if (col[badcol[0]] + a[i][badcol[1]] - a[i][badcol[0]] == need) {
                cout << i + 1 << " " << badcol[0] + 1 << '\n';
                cout << i + 1 << " " << badcol[1] + 1 << '\n';
                return 0;
            }
        }
    } else {
        assert(sz(badrow) == 2);
        for (int j = 0; j < n; ++j) {
            if (row[badrow[0]] + a[badrow[1]][j] - a[badrow[0]][j] == need) {
                cout << badrow[0] + 1 << " " << j + 1 << '\n';
                cout << badrow[1] + 1 << " " << j + 1 << '\n';
                return 0;
            }
        }

    }
    return 0;
}

