#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;

const int INF = (int)(1e18) + 42;
const int EPS = 1ll << 45;

map<int, int> mem;

int ask(int d) {
    if (mem.count(d))
        return mem[d];

    cout << "? " << d << endl;
    int res;
    cin >> res;
    mem[d] = res;
    return res;
}

void answer(int x, int b) {
    cout << "! " << x << " " << b << endl;
}

int qpow(int a, int n) {
    if (n == 0)
        return 1;
    if (a > INF / a)
        return INF;
    if (n % 2 == 0)
        return qpow(a * a, n / 2);
    int res = qpow(a * a, n / 2);
    if (res > INF / a)
        return INF;
    return a * res;
}

int my_sqrt(int a, int n) {
    int l = 0, r = a + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (qpow(m, n - 1) * (m - 1) <= a)
            l = m;
        else
            r = m;
    }
    return l;
}

void solve() {
    int n;
    cin >> n;

    int l = 0, r = (1ll << 40);
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (ask(m) == n)
            l = m;
        else
            r = m;
    }

    int l1 = 0, r1 = (1ll << 50);
    while (r1 - l1 > 1) {
        int m = (l1 + r1) / 2;
        if (ask(m) <= n + 1)
            l1 = m;
        else
            r1 = m;
    }

    int d = r1 - r;
    int p = n + 1;
    int b = my_sqrt(d, p);
    int x = qpow(b, p - 1) - r;

    answer(x, b);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}