#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pt {ll x, y;};
pt operator +(pt a, pt b) {return {a.x + b.x, a.y + b.y};}
pt operator -(pt a, pt b) {return {a.x - b.x, a.y - b.y};}
ll cross(pt a, pt b) {return a.x * b.y - b.x * a.y;}
int half(pt a) {return (a.x < 0 || (a.x == 0 && a.y <= 0)) ? 0 : 1;}

const int N = 210000;

ll n;
pt p[N];
vector<int> g[N], h[N];
map<pair<int, int>, bool> mp;
bool used[N];

void addh(int a, int b, int c, int i, int j) {
    if (a == c) return;
    h[i].push_back(j);
    mp[{i, j}] = true;
}

int cnt;
void dfs(int v) {
    if (used[v]) return;
    cnt++;
    used[v] = true;
    for (int u : h[v])
        dfs(u);
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        ll x, y; cin >> x >> y;
        p[i] = {x, y};
    }
    for (int i = 1; i < n; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int ans = 0;
    for (int k = 1; k <= n; k++) {
        sort(begin(g[k]), end(g[k]), [&](int i, int j){
            if (half(p[i] - p[k]) != half(p[j] - p[k]))
                return half(p[i] - p[k]) < half(p[j] - p[k]);
            return cross(p[i] - p[k], p[j] - p[k]) > 0;
        });
        int ptr = 0, sz = g[k].size();
        for (int i = 0; i < sz; i++)
            h[i].clear();
        mp.clear();
        if (sz > 1) {
            for (int i = 0; i < sz; i++) {
                int v = g[k][i];
                if (ptr == i) ptr = (ptr + 1) % sz;
                while (cross(p[k] - p[v], p[g[k][ptr]] - p[k]) < 0)
                    ptr = (ptr + 1) % sz;
                addh(v, k, g[k][ptr], i, ptr);
                if (cross(p[k] - p[v], p[g[k][ptr]] - p[k]) != 0 || i == ptr)
                    addh(v, k, g[k][(ptr + sz - 1) % sz], i, (ptr + sz - 1) % sz);
            }
        }
        for (int i = 0; i < sz; i++) {
            vector<int> o;
            for (int v : h[i])
                if (mp[{v, i}])
                    o.push_back(v);
            h[i] = o;
        }
        for (int i = 0; i < sz; i++)
            used[i] = false;
        for (int i = 0; i < sz; i++) {
            cnt = 0;
            dfs(i);
            ans += cnt % 2;
        }
    }
    cout << ans / 2;
}
