#include <bits/stdc++.h>

//#define int long long
#define f first
#define s second
#define sz(x) (int)x.size()
#define pb push_back

using namespace std;

using pii = pair <int, int>;

const int N = 1005;
int a[N][N];
int smi[N], smj[N];
int n;

void calc_sm() {
    for (int i = 0; i < n; i++) {
        int smn = 0;
        for (int j = 0; j < n; j++)
            smn += a[i][j];

        smi[i] = smn;
    }

    for (int j = 0; j < n; j++) {
        int smn = 0;
        for (int i = 0; i < n; i++)
            smn += a[i][j];

        smj[j] = smn;
    }
}

int find_sm() {
    int res = 0, mx = 0;
    map<int, int> sm;
    for (int i = 0; i < n; i++) {
        int smn = 0;
        for (int j = 0; j < n; j++)
            smn += a[i][j];

        sm[smn]++;
        if (sm[smn] > mx) {
            mx = sm[smn];
            res = smn;
        }
    }

    for (int j = 0; j < n; j++) {
        int smn = 0;
        for (int i = 0; i < n; i++)
            smn += a[i][j];

        sm[smn]++;
        if (sm[smn] > mx) {
            mx = sm[smn];
            res = smn;
        }
    }

    return res;
}

bool stupid_can() {
    set <int> st;
    for (int i = 0; i < n; i++) {
        int smn = 0;
        for (int j = 0; j < n; j++)
            smn += a[i][j];

        st.insert(smn);
        if (sz(st) > 1)
            return false;
    }

    for (int j = 0; j < n; j++) {
        int smn = 0;
        for (int i = 0; i < n; i++)
            smn += a[i][j];

        st.insert(smn);
        if (sz(st) > 1)
            return false;
    }

    return true;
}

bool can(int i1, int j1, int i2, int j2, int smn) {
    return (smi[i1] - a[i1][j1] + a[i2][j2] == smn) &&
        (smi[i2] - a[i2][j2] + a[i1][j1] == smn) &&
        (smj[j1] - a[i1][j1] + a[i2][j2] == smn) &&
        (smj[j2] - a[i2][j2] + a[i1][j1] == smn);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            cin >> a[i][j];

    if(stupid_can())
    {
        cout << "1 1\n1 1";
        return 0;
    }

    vector<pii> ps;
    if (n <= 7) {
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                ps.pb({i, j});

        for (auto& [i1, j1] : ps) {
            for (auto& [i2, j2] : ps) {
                swap(a[i1][j1], a[i2][j2]);
                if (stupid_can()) {
                    cout << i1 + 1 << " " << j1 + 1 << "\n" << i2 + 1 << " " << j2 + 1;
                    return 0;
                }
                swap(a[i1][j1], a[i2][j2]);
            }
        }
    } else {
        int sm = find_sm();
        for (int i = 0; i < n; i++) {
            int smn = 0;
            for (int j = 0; j < n; j++)
                smn += a[i][j];

            if (smn == sm)
                continue;

            for (int j = 0; j < n; j++)
                ps.pb({i, j});
        }

        for (int j = 0; j < n; j++) {
            int smn = 0;
            for (int i = 0; i < n; i++)
                smn += a[i][j];

            if (smn == sm)
                continue;

            for (int i = 0; i < n; i++)
                ps.pb({i, j});
        }

        calc_sm();
        for (auto& [i1, j1] : ps) {
            for (auto& [i2, j2] : ps) {
                if (can(i1, j1, i2, j2, sm)) {
                    cout << i1 + 1 << " " << j1 + 1 << "\n" << i2 + 1 << " " << j2 + 1;
                    return 0;
                }
            }
        }
    }

    assert(0);
}
