#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define sz(x) (int)x.size()

using namespace std;
const int N = 1001;
int n;
int a[N][N];

bool check()
{
    set<int> s;
    for(int i = 0; i < n; i++)
    {
        int sum1 = 0, sum2 = 0;
        for(int j = 0; j < n; j++)
            sum1 += a[i][j], sum2 += a[j][i];
        s.insert(sum1);
        s.insert(sum2);
    }
    return (sz(s) == 1);
}

int32_t main() {
    cin >> n;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cin >> a[i][j];
    if(n <= 4)
    {
        for(int x1 = 0; x1 < n; x1++)
            for(int y1 = 0; y1 < n; y1++)
                for(int x2 = x1; x2 < n; x2++)
                    for(int y2 = y1; y2 < n; y2++)
                    {
                        swap(a[x1][y1], a[x2][y2]);
                        if(check())
                        {
                            cout << x1 + 1 << " " << y1 + 1 << endl;
                            cout << x2 + 1 << " " << y2 + 1;
                            return 0;
                        }
                        swap(a[x1][y1], a[x2][y2]);
                    }
        return 0;
    }
    map<int, int> cnt;
    for(int i = 0; i < n; i++)
    {
        int sum1 = 0, sum2 = 0;
        for(int j = 0; j < n; j++)
            sum1 += a[i][j], sum2 += a[j][i];
        cnt[sum1]++;
        cnt[sum2]++;
    }
    int SUM = 0;
    for(auto i : cnt)
        if(i.y > cnt[SUM])
            SUM = i.x;
    vector<pair<int, int>> bad;
    for(int i = 0; i < n; i++)
    {
        int sum = 0;
        for(int j = 0; j < n; j++)
            sum += a[i][j];
        if(sum != SUM)
            bad.push_back({i, sum});
    }
    if(sz(bad) == 2)
    {
        int x = bad[0].x, y = bad[1].x;
        int sumx = bad[0].y, sumy = bad[1].y;
        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
            {
                if(sumx + a[y][j] - a[x][i] != SUM)
                    continue;
                if(sumy - a[y][j] + a[x][i] != SUM)
                    continue;
                cout << x + 1 << " " << i + 1 << endl;
                cout << y + 1 << " " << j + 1;
                return 0;
            }
    }
    bad.clear();
    for(int i = 0; i < n; i++)
    {
        int sum = 0;
        for(int j = 0; j < n; j++)
            sum += a[j][i];
        if(sum != SUM)
            bad.push_back({i, sum});
    }
    if(sz(bad) == 2)
    {
        int x = bad[0].x, y = bad[1].x;
        int sumx = bad[0].y, sumy = bad[1].y;
        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
            {
                if(sumx + a[j][y] - a[i][x] != SUM)
                    continue;
                if(sumy - a[j][y] + a[i][x] != SUM)
                    continue;
                cout << i + 1 << " " << x + 1 << endl;
                cout << j + 1 << " " << y + 1;
                return 0;
            }
    }
    cout << "1 1\n1 1";
}
