#include<bits/stdc++.h>
using namespace std;
#define int long long
#define pb push_back
#define ff first
#define ss second

using vi = vector<int>;
using pi = pair<int, int>;
const int INF = 1e18;

vector<vi> g;
vi p;
vector<set<pi>> s;
vi ans;

void merge(int u, int v) {
    if (s[v].size() > s[u].size()) {
        swap(s[u], s[v]);
    }
    for (auto x : s[v]) {
        s[u].insert(x);
    }
    s[v].clear();
}

int dfs(int v, int h) {
    h++;
    int mn = INF;
    for (auto u : g[v]) {
        mn = min(mn, dfs(u, h));
        merge(v, u);
    }
//    cout << v << " " << mn << endl;
    if (mn == INF) {
        s[v].insert({h, 0});
        return h;
    }
//    cout << v + 1 << endl;
//    for (auto x : s[v]) {
//        cout << x.ff << " " << x.ss << endl;
//    }
//    cout << mn << endl;
    int need = mn;
    auto it = s[v].lower_bound({need, INF});
    it--;
    if ((*it).ff == mn) {
        ans[v] = (*it).ss + 1;
    }
    s[v].insert({h, ans[v]});
    return mn;
}

void solve() {
    int n; cin >> n;
    p.resize(n);
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int pp; cin >> pp;
        pp--;
        g[pp].pb(i + 1);
        p[i + 1] = pp;
    }
    s.resize(n);
    ans.assign(n, 1);
    dfs(0, -1);
    cout << ans[0] << endl;
}

signed main() {
    solve();
}
