#include<bits/stdc++.h>
using namespace std;
#define pb push_back
#define ff first
#define ss second
#define st string
#define endl "\n"

using vi = vector<int>;
using pi = pair<int, int>;
const int INF = 1e9;

struct Node {
    int fl = 0;
    int idal = INF;
    int idar = -1;
    int idbl = INF;
    int idbr = -1;
};

vector<Node> t;
st s;

Node calc(Node l, Node r, int m) {
    if (l.fl == -1) {
        return r;
    }
    if (r.fl == -1) {
        return l;
    }
    Node x;
    if (l.fl == -1 && r.fl == -1) {
        x.fl = -1;
        return x;
    }
    x.idbl = min(l.idbl, r.idbl);
    x.idbr = max(l.idbr, r.idbr);
    x.idal = min(l.idal, r.idal);
    x.idar = max(l.idar, r.idar);
    if (l.fl || r.fl) {
        x.fl = 1;
        return x;
    }
    if (s[m - 1] == 'a' && s[m] == 'a') {
//        cout << 111 << endl;
        x.idal = min(l.idal, m - 1);
        x.idar = max(r.idar, m - 1);
        return x;
    }
    if (s[m - 1] == 'b' && s[m] == 'b') {
//        cout << 222 << endl;
        x.idbl = min(l.idbl, m - 1);
        x.idbr = max(r.idbr, m - 1);
        if (l.idar < l.idbr || r.idal > r.idbl) {
            x.fl = 1;
        }
        return x;
    }
    x.fl = 1;
    if (l.idbl == INF || r.idbl == INF) {
        x.fl = 0;
        return x;
    }
    if (l.idar >= l.idbr) {
        x.fl = 0;
    }
    if (r.idal <= r.idbl) {
        x.fl = 0;
    }
    return x;
}

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        return;
    }
    int m = (tl + tr) / 2;
    build(2 * v + 1, tl, m);
    build(2 * v + 2, m, tr);
    t[v] = calc(t[2 * v + 1], t[2 * v + 2], m);
}

void upd(int v, int tl, int tr, int id) {
    if (tr - tl == 1) {
        return;
    }
    int m = (tl + tr) / 2;
    if (id < m) {
        upd(2 * v + 1, tl, m, id);
    }
    else {
        upd(2 * v + 2, m, tr, id);
    }
    t[v] = calc(t[2 * v + 1], t[2 * v + 2], m);
}

// 0 -> good, 1 -> bad
Node get(int v, int tl, int tr, int l, int r) {
//    cout << tl << " " << tr << " " << v << endl;
    if (tl >= r || tr <= l) {
        Node x;
        x.fl = -1;
        return x;
    }
    if ((tl >= l && tr <= r) || tr - tl == 1) {
        return t[v];
    }
    int m = (tl + tr) / 2;
    Node v1 = get(2 * v + 1, tl, m, l, r);
    Node v2 = get(2 * v + 2, m, tr, l, r);
//    cout << v1.fl << " " << v2.fl << endl;
    return calc(v1, v2, m);
}

void solve() {
    int n; cin >> n;
    cin >> s;
    int k = 1;
    while (k < n) {
        k *= 2;
    }
    t.resize(2 * k - 1);
    build(0, 0, n);
    int q; cin >> q;
    while (q--) {
        int tt; cin >> tt;
        if (tt == 1) {
            int id; cin >> id;
            id--;
            s[id] = (s[id] == 'a' ? 'b' : 'a');
            upd(0, 0, n, id);
        }
        else {
            int l, r; cin >> l >> r;
            l--; r--;
            if (l == r) {
                cout << (s[l] == 'b' ? "NO" : "YES") << endl;
                continue;
            }
            if (s[l] == s[l + 1] && s[l] == 'b') {
                cout << "NO" << endl;
                continue;
            }
            if (s[r] == s[r - 1] && s[r - 1] == 'b') {
                cout << "NO" << endl;
                continue;
            }
            Node ans = get(0, 0, n, l, r + 1);
//            cout << ans.fl << " " << ans.idbl << " " << ans.idbr << endl;
            if (ans.fl == 1) {
                cout << "NO" << endl;
                continue;
            }
            if (s[r] == 'b' && ans.idbr != -1 && ans.idbr > ans.idar) {
                cout << "NO" << endl;
                continue;
            }
            if (s[l] == 'b' && ans.idbl != INF && ans.idbl < ans.idal) {
                cout << "NO" << endl;
                continue;
            }
            if (s[l] == 'b' && s[r] == 'b' && ans.idal == INF) {
                cout << "NO" << endl;
                continue;
            }
            cout << "YES" << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}