#include <bits/stdc++.h>

using namespace std;

bool check(vector<vector<int>> &arr) {
    int sum = 0;
    int n = arr.size();
    for (int i = 0; i < n; i++)
        sum += arr[0][i];

    for (int j = 1; j < n; j++) {
        int buff = 0;
        for (int i = 0; i < n; i++)
            buff += arr[j][i];
        if (buff != sum)
            return false;
    }

    for (int i = 0; i < n; i++) {
        int buff = 0;
        for (int j = 0; j < n; j++)
            buff += arr[j][i];
        if (buff != sum)
            return false;
    }

    return true;
}

void stupid(int n) {
    vector<vector<int>> arr(n, vector<int>(n));
    for (auto &a : arr)
        for (auto &b : a)
            cin >> b;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                for (int l = 0; l < n; l++) {
                    if (i == k || j == l)
                        continue;

                    swap(arr[i][j], arr[k][l]);

                    if (check(arr)) {
                        cout << i + 1 << ' ' << j + 1 << '\n';
                        cout << k + 1 << ' ' << l + 1 << '\n';
                        exit(0);
                    }

                    swap(arr[i][j], arr[k][l]);
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    if (n <= 4) {
        stupid(n);
    }

    vector<vector<int>> arr(n, vector<int>(n));

    map<int, vector<int>> x, y; // sum, ind

    for (int i = 0; i < n; i++) {
        int buff = 0;
        for (int j = 0; j < n; j++) {
            cin >> arr[i][j];
            buff += arr[i][j];
        }

        x[buff].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        int buff = 0;
        for (int j = 0; j < n; j++) {
            buff += arr[j][i];
        }

        y[buff].push_back(i);
    }

    vector<int> a, b;
    int ok;
    for (auto &e : x) {
        if (e.second.size() > 2) {
            ok = e.first;
        } else {
            for (auto i : e.second) {
                a.push_back(i);
            }
        }
    }

    for (auto &e : y) {
        if (e.first != ok) {
            for (auto i : e.second)
                b.push_back(i);
        }
    }

    int x1, y1, x2, y2;
    if (a.size() == 0) {
        int s1 = 0, s2 = 0;
        y1 = b[0];
        y2 = b[1];
        for (int i = 0; i < n; i++) {
            s1 += arr[i][y1];
            s2 += arr[i][y2];
        }

        for (int i = 0; i < n; i++) {
            if (s1 - arr[i][y1] + arr[i][y2] == s2 - arr[i][y2] + arr[i][y1]) {
                cout << i + 1 << ' ' << y1 + 1 << '\n';
                cout << i + 1 << ' ' << y2 + 1 << '\n';
                exit(0);
            }
        }
    } else if (a.size() == 1) {
        x1 = x2 = a[0];
    } else {
        x1 = a[0];
        x2 = a[1];
    }

    if (b.size() == 0) {
        int s1 = 0, s2 = 0;
        for (int i = 0; i < n; i++) {
            s1 += arr[x1][i];
            s2 += arr[x2][i];
        }

        for (int i = 0; i < n; i++) {
            if (s1 - arr[x1][i] + arr[x2][i] == s2 - arr[x2][i] + arr[x1][i]) {
                cout << x1 + 1 << ' ' << i + 1 << '\n';
                cout << x2 + 1 << ' ' << i + 1 << '\n';
                exit(0);
            }
        }
    } else if (b.size() == 1) {
            y1 = y2 = b[0];
    } else {
        y1 = b[0];
        y2 = b[1];
    }

    if (!check(arr))
        swap(x1, x2);

    cout << x1 + 1 << ' ' << y1 + 1 << '\n';
    cout << x2 + 1 << ' ' << y2 + 1 << '\n';

    return 0;
}
