#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef vector<int> vi;
vector<ll> facts;
ll mod= 1e9 + 7;

ll bin_pow(ll x, ll step){
    if (step == 0){
        return 1;
    }
    ll ans  = bin_pow(x, step/ 2);
    ans *= ans;
    ans %= mod;
    if (step % 2){
        return ans * x % mod;
    }
    return ans;
}

vector<ll> rev_facts;

ll C(ll k, ll n){
    if (k > n){
        return 0;
    }

    ll f1 = facts[n];
    ll f2 = rev_facts[k] * rev_facts[n - k] % mod;
    return f1 * f2 % mod;

}
void run_case(){
    ll n;
    cin >> n;
    facts.resize(n + 1, 1);
    rev_facts.resize(n + 1, 1);
    for (ll i = 2;i <= n; i++){
        facts[i] = facts[i - 1] * i % mod;
    }
    for (ll i = 0; i <= n; i++){
        rev_facts[i]= bin_pow(facts[i], mod - 2);
    }
    ll ans = 1;
    for (ll level = 1; level < n; level++){
        ll d1 = 0;
        for (ll col2 = 1; col2 <= n; col2++){
            ll d = col2 * 2;
            ll ost = level + 1 - d;
            if (ost >= 0){
                d1 += C(col2, level) * C(ost, level - col2) % mod;\
                d1 %= mod;
            }
        }
        ans *= d1;
        ans %= mod;
    }
    cout << ans << "\n";

}

signed main() {
    int tt = 1;
    //cin >> tt;
    while(tt--)run_case();
}
