#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef vector<int> vi;

bool check(vector<vi>& v){
    int n = v.size();
    int x = -1;
    for(int i = 0; i < n; i++){
        int s1 = 0, s2 =0;
        for(int j = 0; j < n; j++){
            s1 += v[i][j];
            s2 += v[j][i];
        }
        if(x == -1){
            x = s1;
        }
        if(s1 != x  || s2 != x)return 0;
    }
    return 1;
}

void run_case(){
    int n;
    cin >> n;
    vector<vector<int>> v(n, vi(n));
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            cin >> v[i][j];
        }
    }
    if(n <= 5){
        for(int i1 = 0; i1 < n; i1++){
            for(int j1 = 0; j1 < n; j1++){
                for(int i2 = 0; i2 < n; i2++){
                    for(int j2 = 0; j2 < n; j2++){
                        if(i1 == i2 && j1 == j2)continue;
                        swap(v[i1][j1], v[i2][j2]);
                        if(check(v)){
                            cout << i1+1 << ' '<< j1+1 << '\n';
                            cout << i2+1 << ' '<< j2+1 << '\n';
                            return;
                        }
                        swap(v[i1][j1], v[i2][j2]);
                    }
                }
            }
        }
        return;
    }
    vi sum_stroki(n), sum_stolbi(n);
    //stroki
    map<int, int> cnt_stroki;
    for(int i = 0; i < n; i++){
        int cur = 0;
        for(int j = 0; j < n; j++){
            cur += v[i][j];
        }
        sum_stroki[i] = cur;
        cnt_stroki[cur]++;
    }
    //stolbi
    map<int, int> cnt_stolbi;
    for(int i = 0; i < n; i++){
        int cur = 0;
        for(int j = 0; j < n; j++){
            cur += v[j][i];
        }
        sum_stolbi[i] = cur;
        cnt_stolbi[cur]++;
    }

    vector<int> d_stroki, d_stolbi;
    int mx_sum_stroki = cnt_stroki.begin()->first, mx_sum_stolbi = cnt_stolbi.begin()->first;
    for (auto [a, b] : cnt_stroki) {
        if (cnt_stroki[mx_sum_stroki] < b){
            mx_sum_stroki = a;
        }
    }
    for (auto [a, b] : cnt_stolbi) {
        if (cnt_stolbi[mx_sum_stolbi] < b){
            mx_sum_stolbi = a;
        }
    }
    for(int i = 0; i < n; i++){
        if(sum_stroki[i] != mx_sum_stroki) d_stroki.push_back(i);
        if(sum_stolbi[i] != mx_sum_stolbi)d_stolbi.push_back(i);
    }
    if(d_stroki.size() == 2 && d_stolbi.size() == 2){
        swap(v[d_stroki[0]][d_stolbi[0]], v[d_stroki[1]][d_stolbi[1]]);
        if(check(v)) {
            cout << d_stroki[0] + 1 << ' ' << d_stolbi[0] + 1 << '\n';
            cout << d_stroki[1] + 1 << ' ' << d_stolbi[1] + 1 << '\n';
        }else{
            cout << d_stroki[0] + 1 << ' ' << d_stolbi[1] + 1 << '\n';
            cout << d_stroki[1] + 1 << ' ' << d_stolbi[0] + 1 << '\n';
        }
        return;
    }
    else if(d_stroki.size() == 2 && d_stolbi.size() == 0){
        int s1 = d_stroki[0];
        int s2 = d_stroki[1];
        for(int i = 0; i < n; i++){
            int e1 = v[s1][i];
            int e2 = v[s2][i];
            if(sum_stroki[s1] - e1 + e2 == mx_sum_stroki && sum_stroki[s2] - e2 + e1 == mx_sum_stroki){
                cout << s1 + 1 << ' '<< i + 1 << '\n';
                cout << s2 + 1 << ' '<< i + 1 << '\n';
                return;
            }
        }
        exit(1);
    }else if(d_stroki.size() == 0 && d_stolbi.size() == 2){
        int s1 = d_stolbi[0];
        int s2 = d_stolbi[1];
        for(int i = 0; i < n; i++){
            int e1 = v[i][s1];
            int e2 = v[i][s2];
            if(sum_stolbi[s1] - e1 + e2 == mx_sum_stolbi && sum_stolbi[s2] - e2 + e1 == mx_sum_stolbi){
                cout << i + 1 << ' '<< s1 + 1 << '\n';
                cout << i + 1 << ' '<< s2 + 1 << '\n';
                return;
            }
        }
        exit(1);
    }else{
        exit(1);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while(tt--)run_case();
}
