#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()


void solve () {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n, 0));
    int sx = ((n * n + 1) * n) / 2;
    vector<int> s_row(n, 0), s_col(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            s_row[i] += a[i][j];
            s_col[j] += a[i][j];
        }
    }


    vector<int> col;
    vector<int> row;
    for (int i = 0; i < n; i++) {
        if (s_row[i] != sx) {
            row.push_back(i);
        }
        if (s_col[i] != sx) {
            col.push_back(i);
        }
    }

    if (sz(col) == 0 && sz(row) == 0) {
        assert(false);
    }

    auto check = [&] (int x1, int y1, int x2, int y2) {
        s_col[y1] -= a[x1][y1];
        s_col[y2] -= a[x2][y2];
        s_row[x1] -= a[x1][y1];
        s_row[x2] -= a[x2][y2];

        s_col[y2] += a[x1][y1];
        s_col[y1] += a[x2][y2];
        s_row[x2] += a[x1][y1];
        s_row[x1] += a[x2][y2];

        bool ok = true;

        ok &= s_col[y1] == sx;
        ok &= s_col[y2] == sx;
        ok &= s_row[x1] == sx;
        ok &= s_row[x2] == sx;

        s_col[y2] -= a[x1][y1];
        s_col[y1] -= a[x2][y2];
        s_row[x2] -= a[x1][y1];
        s_row[x1] -= a[x2][y2];

        s_col[y1] += a[x1][y1];
        s_col[y2] += a[x2][y2];
        s_row[x1] += a[x1][y1];
        s_row[x2] += a[x2][y2];

        return ok;
    };

    if (sz(col) == 2 && sz(row) == 2) {
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 2; j++) {
                if (check(row[i], col[j], row[i ^ 1], col[j ^ 1])) {
                    cout << row[i] + 1 << " " << col[j] + 1 << endl;
                    cout << row[i ^ 1] + 1 << " " << col[j ^ 1] + 1 << endl;
                    return;
                }
            }
        }
    }

    if (sz(col) == 2) {
        for (int i = 0; i < n; i++) {
            if (check(i, col[0], i, col[1])) {
                cout << i + 1 << " " << col[0] + 1 << endl << i + 1 << " " << col[1] + 1 << endl;
                return;
            }
        }
    }

    if (sz(row) == 2) {
        for (int i = 0; i < n; i++) {
            if (check(row[0], i, row[1], i)) {
                cout << row[0] + 1 << " " << i + 1 << endl << row[1] + 1 << " " << i + 1 << endl;
                return;
            }
        }
    }

    assert(false);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}