#include <bits/stdc++.h>

using namespace std;
#define int int64_t

const int N = (int) 1e5 * 3;
const int mod = (int) 1e9 + 7;

int f[N];

int binpow(int x, int n) {
    if (n == 0)return 1;
    if (n % 2 == 1)
        return (x * binpow((x * x) % mod, n / 2)) % mod;
    return binpow((x * x) % mod, n / 2);
}

int inv(int x) {
    return binpow(x, mod - 2);
}

int cnk(int n, int k) {
    if (k > n)
        return 0;
    return ((f[n] * inv(f[k])) % mod * inv(f[n - k])) % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    f[0] = 1;
    for(int i = 1; i < N; i++)
        f[i] = (f[i - 1] * i) % mod;

    int n;
    cin >> n;
    int a = 0, b = 0, c = 0;
    for (int i = 0; i < n; i++) {
        int A;
        cin >> A;
        if (A % 3 == 0)a++;
        else if (A % 3 == 1)b++;
        else c++;
    }
    int m = b + c;
    if((m - 1) % 2 == 0){
        if(abs(b - c) != 1){
            cout << 0;
            return 0;
        }
        cout << ((((cnk(n - 1, a) * f[a]) % mod * f[b]) % mod * f[c]) % mod);
    }else{
        if(abs(b - c) != 2){
            cout << 0;
            return 0;
        }
        cout << ((((cnk(n - 1, a) * f[a]) % mod * f[b]) % mod * f[c]) % mod);
    }
    return 0;
}