#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const int inf = 1e9;
const ll INF = 1e18;

int n, dp[N];
vector <int> g[N];

void dfs(int v, int d) {
    dp[v] = 1e9;
    for (auto to : g[v]) {
        dfs(to, d + 1);
        dp[v] = min(dp[v], dp[to]);
    }
    if (dp[v] == 1e9) dp[v] = d;
}

int ans = 1;

void calc(int v, int to, int d, int res) {
    for (auto u : g[v]) {
        if (d == to) calc(u, dp[v], d + 1, res + 1);
        else calc(u, to, d + 1, res);
    }
    ans = max(ans, res);
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }

    dfs(1, 1);
    calc(1, dp[1], 1, 1);

    cout << ans << "\n";

    return 0;
}
