    #include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const int inf = 1e9;
const ll INF = 1e18;

const int mod = 1e9 + 7;

int add (int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int mult (int a, int b) {
    return 1ll * a * b % mod;
}

int n;
int dp[5006][5006];

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;

    dp[0][0] = 1;

    for (int i = 1; i <= n; ++ i) {
        for (int k = 0; k <= n; ++ k) {
            dp[i][k + 0] = add (dp[i][k + 0], dp[i - 1][k]);
            dp[i][k + 1] = add (dp[i][k + 1], dp[i - 1][k]);
            dp[i][k + 2] = add (dp[i][k + 2], dp[i - 1][k]);
        }
    }

    int res = 1;

    for (int i = 2; i <= n; ++ i) {
        res = mult (res, dp[i - 1][i]);
    }

    cout << res << "\n";
    return 0;
}
