#include <bits/stdc++.h>
using namespace std;
using ll  = long long;
using ld = long double;
const int INF = 1e9;

const ll MOD = 1e9 + 7;
struct Residue {
    ll value;
    Residue(ll val): value(val) {
        if (value < -MOD || value >= 2 * MOD) value %= MOD;
        if (value < 0) value += MOD;
        if (value >= MOD) value -= MOD;
    }
    Residue(): Residue(0) {}
};

Residue operator+(Residue a, Residue b) {
    return {a.value + b.value};
}

Residue operator-(Residue a, Residue b) {
    return {a.value - b.value};
}

Residue operator*(Residue a, Residue b) {
    return {a.value * b.value};
}

istream& operator>>(istream& i, Residue &r) {
    i >> r.value;
    r = Residue(r.value);
    return i;
}

ostream& operator<<(ostream& o, Residue r) {
    return o << r.value;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    int numbers[3];
    numbers[0] = 0;
    numbers[1] = 0;
    numbers[2] = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        numbers[x%3] += 1;
    }
    Residue fact1 = 1;
    Residue fact2 = 1;
    for (int i = 1; i <= numbers[1]; i++) {
        fact1 = fact1 * i;
    }
    for (int i = 1; i <= numbers[2]; i++) {
        fact2 = fact2 * i;
    }
    Residue ans = 0;
    int dif = numbers[1] - numbers[2];
    if (dif == 1 || dif == 2) ans = ans + fact1 * fact2;
    if (dif == -1 || dif == -2) ans = ans + fact1 * fact2;
    for (int i = numbers[1] + numbers[2]; i < n; i++) {
        ans = ans * i;
    }
    cout << ans;
    return 0.42069;
}