#include <bits/stdc++.h>

using i64 = long long;

void solve() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> adj(n);
    for (int i = 1; i < n; i++) {
        int p;
        std::cin >> p;
        --p;
        adj[i].emplace_back(p);
        adj[p].emplace_back(i);
    }
    std::vector<int> h(n), minH(n, INT_MAX), res(n);
    std::vector<std::unordered_map<int, int>> mp(n);
    auto init = [&](auto &init, int v, int f) -> void {
        h[v] = (f == v ? 0 : h[f] + 1);
        bool ok = false;
        for (int u : adj[v]) {
            if (u == f) {
                continue;
            }
            ok = true;
            init(init, u, v);
            minH[v] = std::min(minH[v], minH[u]);
        }
        if (!ok) {
            minH[v] = h[v];
        }
    };
    auto dfs = [&](auto &dfs, int v, int f) -> void {
        for (int u : adj[v]) {
            if (u == f) {
                continue;
            }
            dfs(dfs, u, v);
            res[v] = std::max(res[v], res[u]);
            if (int(mp[u].size()) < int(mp[v].size())) {
                for (auto [x, y] : mp[u]) {
                    mp[v][x] = std::max(mp[v][x], y);
                }
            } else {
                for (auto [x, y] : mp[v]) {
                    mp[u][x] = std::max(mp[u][x], y);
                }
                mp[v].swap(mp[u]);
            }
        }
        res[v] = mp[v][minH[v]] + 1;
        mp[v][h[v]] = res[v];
    };
    init(init, 0, 0);
    dfs(dfs, 0, 0);
    std::cout << res[0] - 1 << "\n";
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
