#include <bits/stdc++.h>

using i64 = long long;

#define pb push_back
#define int long long

const int mod = (1e9)+7;

using namespace std;

__int128 bin_pow(__int128 x, __int128 st){
    if(st == 0){
        return 1LL;
    }
    if(st % 2 == 0){
        __int128 h = bin_pow(x, st/2);
        return (1LL*h*h)%mod;
    }
    else{
        __int128 h = bin_pow(x, st-1);
        return (1LL*h*x)%mod;
    }
}

void solve() {
    vector<__int128>fact{1};
    for(int i=1; i<=1000000; i++){
        fact.pb((1LL*fact[i-1]*i)%mod);
    }

    int n;
    cin >> n;
    vector<int>a(n);
    int k0=0, k1=0, k2=0;
    for(int i=0; i<n; i++){
        cin >> a[i];
        if(a[i]%3 == 0){
            k0++;
        }
        else if(a[i]%3 == 1){
            k1++;
        }
        else{
            k2++;
        }
    }

    if(k1-k2>2 or k1==k2 or k1 - k2 < -2){
        cout << 0;
        return;
    }

    __int128 ans = (1LL*fact[k1]*fact[k2])%mod;
    for(int i=k1+k2; i<n; i++){
        ans *= i;
        ans %= mod;
    }

//    map<__int128, __int128>cnt_a;
//    for(int i=0; i<n; i++){
//        cnt_a[a[i]]++;
//    }

//    for(auto [x, cnt]:cnt_a){
//        ans *= bin_pow(fact[cnt], mod-2);
//        ans %= mod;
//    }
    cout << ((int)ans%mod);
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
