#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
//#ifdef LOCAL
//    freopen("input.txt","r",stdin);
//#endif
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

const ll MOD = 1e9 + 7;
ll fact[100010];


ll bin_pow(ll n, ll pow) {
    if (pow == 0) {
        return 1;
    }
    if (pow & 1) {
        return (bin_pow(n, pow - 1) * n) % MOD;
    } else {
        ll d = bin_pow(n, pow / 2);
        return (d * d) % MOD;
    }
}

ll devision(ll n, ll k) {
    return (n * bin_pow(k, MOD - 2)) % MOD;
}


void count_fact() {
    fact[0] = 1;
    for (ll i = 1; i < 100010; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
    }
}

ll C(ll n, ll k) {
    if (k == 0 || k == n) {
        return 1;
    }
    if (k < 0 || k > n || n < 0) {
        return 0;
    }
    return devision(devision(fact[n], fact[k]), fact[n - k]);
}

ll a[3];

void solve() {
    ll n, m, k, i, j;
    cin >> n;
    count_fact();
    a[0] = 0;
    a[1] = 0;
    a[2] = 0;
    for (i = 0; i < n; i++) {
        cin >> k;
        a[k % 3]++;
    }
    if (a[1] > a[2] && a[1] - a[2] < 3) {
        cout << (((C(n - 1, a[0]) * fact[a[1]]) % MOD) * fact[a[2]]) % MOD;
    } else if (a[2] > a[1] && a[2] - a[1] < 3) {
        cout << (((C(n - 1, a[0]) * fact[a[1]]) % MOD) * fact[a[2]]) % MOD;
    } else {
        cout << 0;
        return;
    }
}