#include <bits/stdc++.h>

#define PB push_back
#define pb push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())
#define int ll
#define itn int

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1002;

ll arr[N][N],sumx[N],sumy[N];
char used[N][N];

void solve()
{
    ll n;
    cin>>n;

    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<n;j++)
            cin>>arr[i][j];
    }

    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<n;j++)
        {
            sumx[i]+=arr[i][j];
            sumy[j]+=arr[i][j];
        }
    }

    ll need=n*(n*n+1)/2;
    ve<ll> vx,vy;

    for(ll i=0;i<n;i++)
    {
        if(sumx[i]==need) continue;
        vx.PB(i);

        for(ll j=0;j<n;j++)
            used[i][j]=1;
    }

    for(ll i=0;i<n;i++)
    {
        if(sumy[i]==need) continue;
        vy.PB(i);

        for(ll j=0;j<n;j++)
            used[j][i]=1;
    }

    ve<pll> v;

    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<n;j++)
        {
            if(used[i][j])
                v.PB({i,j});
        }
    }

    for(ll i=0;i<sz(v);i++)
    {
        for(ll j=i+1;j<sz(v);j++)
        {
            ll ax,ay,bx,by;
            tie(ax,ay)=v[i];
            tie(bx,by)=v[j];

            sumx[ax]-=arr[ax][ay];
            sumy[ay]-=arr[ax][ay];
            sumx[bx]-=arr[bx][by];
            sumy[by]-=arr[bx][by];

            sumx[ax]+=arr[bx][by];
            sumy[ay]+=arr[bx][by];
            sumx[bx]+=arr[ax][ay];
            sumy[by]+=arr[ax][ay];

            bool ok=1;
            for(ll i:vx) ok&=(sumx[i]==need);
            for(ll i:vy) ok&=(sumy[i]==need);
            ok&=(sumx[ax]==need);
            ok&=(sumx[bx]==need);
            ok&=(sumy[ay]==need);
            ok&=(sumy[by]==need);

            if(ok)
            {
                cout<<ax+1<<' '<<ay+1<<endl<<bx+1<<' '<<by+1;
                return;
            }

            sumx[ax]-=arr[bx][by];
            sumy[ay]-=arr[bx][by];
            sumx[bx]-=arr[ax][ay];
            sumy[by]-=arr[ax][ay];

            sumx[ax]+=arr[ax][ay];
            sumy[ay]+=arr[ax][ay];
            sumx[bx]+=arr[bx][by];
            sumy[by]+=arr[bx][by];
        }
    }

    cout<<"1 1"<<endl<<"1 1";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen( "input.txt" , "r" , stdin );
        freopen( "output.txt" , "w" , stdout );
    #endif // LOCAL

    solve();
    return 0;
}
